/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.37.0-dev.20230322(ae158a25246af016a0c56e2b47df83bd4b1c2426)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var Y=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/platform","vs/base/common/event","vs/base/common/errors","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/lineRange","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/nls","vs/base/common/arrays","vs/base/common/cache","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],X=function(O){for(var n=[],E=0,M=O.length;E<M;E++)n[E]=Y[O[E]];return n};const Ee=this,Re=typeof global=="object"?global:{};var se;(function(O){O.global=Ee;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=n})(se||(se={}));var se;(function(O){class n{constructor(l,S,y){this.type=l,this.detail=S,this.timestamp=y}}O.LoaderEvent=n;class E{constructor(l){this._events=[new n(1,"",l)]}record(l,S){this._events.push(new n(l,S,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=E;class M{record(l,S){}getEvents(){return[]}}M.INSTANCE=new M,O.NullLoaderEventRecorder=M})(se||(se={}));var se;(function(O){class n{static fileUriToFilePath(M,i){if(i=decodeURI(i).replace(/%23/g,"#"),M){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(M,i){return M.length>=i.length&&M.substr(0,i.length)===i}static endsWith(M,i){return M.length>=i.length&&M.substr(M.length-i.length)===i}static containsQueryString(M){return/^[^\#]*\?/gi.test(M)}static isAbsolutePath(M){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(M)}static forEachProperty(M,i){if(M){let l;for(l in M)M.hasOwnProperty(l)&&i(l,M[l])}}static isEmpty(M){let i=!0;return n.forEachProperty(M,()=>{i=!1}),i}static recursiveClone(M){if(!M||typeof M!="object"||M instanceof RegExp||!Array.isArray(M)&&Object.getPrototypeOf(M)!==Object.prototype)return M;let i=Array.isArray(M)?[]:{};return n.forEachProperty(M,(l,S)=>{S&&typeof S=="object"?i[l]=n.recursiveClone(S):i[l]=S}),i}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(M){return n.startsWith(M,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,O.Utilities=n})(se||(se={}));var se;(function(O){function n(i){if(i instanceof Error)return i;const l=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(l.stack=i.stack),l}O.ensureError=n;class E{static validateConfigurationOptions(l){function S(y){if(y.phase==="loading"){console.error('Loading "'+y.moduleId+'" failed'),console.error(y),console.error("Here are the modules that depend on it:"),console.error(y.neededBy);return}if(y.phase==="factory"){console.error('The factory function of "'+y.moduleId+'" has thrown an exception'),console.error(y),console.error("Here are the modules that depend on it:"),console.error(y.neededBy);return}}if(l=l||{},typeof l.baseUrl!="string"&&(l.baseUrl=""),typeof l.isBuild!="boolean"&&(l.isBuild=!1),typeof l.paths!="object"&&(l.paths={}),typeof l.config!="object"&&(l.config={}),typeof l.catchError>"u"&&(l.catchError=!1),typeof l.recordStats>"u"&&(l.recordStats=!1),typeof l.urlArgs!="string"&&(l.urlArgs=""),typeof l.onError!="function"&&(l.onError=S),Array.isArray(l.ignoreDuplicateModules)||(l.ignoreDuplicateModules=[]),l.baseUrl.length>0&&(O.Utilities.endsWith(l.baseUrl,"/")||(l.baseUrl+="/")),typeof l.cspNonce!="string"&&(l.cspNonce=""),typeof l.preferScriptTags>"u"&&(l.preferScriptTags=!1),l.nodeCachedData&&typeof l.nodeCachedData=="object"&&(typeof l.nodeCachedData.seed!="string"&&(l.nodeCachedData.seed="seed"),(typeof l.nodeCachedData.writeDelay!="number"||l.nodeCachedData.writeDelay<0)&&(l.nodeCachedData.writeDelay=1e3*7),!l.nodeCachedData.path||typeof l.nodeCachedData.path!="string")){const y=n(new Error("INVALID cached data configuration, 'path' MUST be set"));y.phase="configuration",l.onError(y),l.nodeCachedData=void 0}return l}static mergeConfigurationOptions(l=null,S=null){let y=O.Utilities.recursiveClone(S||{});return O.Utilities.forEachProperty(l,(c,h)=>{c==="ignoreDuplicateModules"&&typeof y.ignoreDuplicateModules<"u"?y.ignoreDuplicateModules=y.ignoreDuplicateModules.concat(h):c==="paths"&&typeof y.paths<"u"?O.Utilities.forEachProperty(h,(w,e)=>y.paths[w]=e):c==="config"&&typeof y.config<"u"?O.Utilities.forEachProperty(h,(w,e)=>y.config[w]=e):y[c]=O.Utilities.recursiveClone(h)}),E.validateConfigurationOptions(y)}}O.ConfigurationOptionsUtil=E;class M{constructor(l,S){if(this._env=l,this.options=E.mergeConfigurationOptions(S),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let y=this.options.nodeRequire.main.filename,c=Math.max(y.lastIndexOf("/"),y.lastIndexOf("\\"));this.options.baseUrl=y.substring(0,c+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let l=0;l<this.options.ignoreDuplicateModules.length;l++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[l]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(l,S)=>{Array.isArray(S)?this.sortedPathsRules.push({from:l,to:S}):this.sortedPathsRules.push({from:l,to:[S]})}),this.sortedPathsRules.sort((l,S)=>S.from.length-l.from.length)}cloneAndMerge(l){return new M(this._env,E.mergeConfigurationOptions(l,this.options))}getOptionsLiteral(){return this.options}_applyPaths(l){let S;for(let y=0,c=this.sortedPathsRules.length;y<c;y++)if(S=this.sortedPathsRules[y],O.Utilities.startsWith(l,S.from)){let h=[];for(let w=0,e=S.to.length;w<e;w++)h.push(S.to[w]+l.substr(S.from.length));return h}return[l]}_addUrlArgsToUrl(l){return O.Utilities.containsQueryString(l)?l+"&"+this.options.urlArgs:l+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(l){return this.options.urlArgs?this._addUrlArgsToUrl(l):l}_addUrlArgsIfNecessaryToUrls(l){if(this.options.urlArgs)for(let S=0,y=l.length;S<y;S++)l[S]=this._addUrlArgsToUrl(l[S]);return l}moduleIdToPaths(l){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(l))return this.isBuild()?["empty:"]:["node|"+l];let S=l,y;if(!O.Utilities.endsWith(S,".js")&&!O.Utilities.isAbsolutePath(S)){y=this._applyPaths(S);for(let c=0,h=y.length;c<h;c++)this.isBuild()&&y[c]==="empty:"||(O.Utilities.isAbsolutePath(y[c])||(y[c]=this.options.baseUrl+y[c]),!O.Utilities.endsWith(y[c],".js")&&!O.Utilities.containsQueryString(y[c])&&(y[c]=y[c]+".js"))}else!O.Utilities.endsWith(S,".js")&&!O.Utilities.containsQueryString(S)&&(S=S+".js"),y=[S];return this._addUrlArgsIfNecessaryToUrls(y)}requireToUrl(l){let S=l;return O.Utilities.isAbsolutePath(S)||(S=this._applyPaths(S)[0],O.Utilities.isAbsolutePath(S)||(S=this.options.baseUrl+S)),this._addUrlArgsIfNecessaryToUrl(S)}isBuild(){return this.options.isBuild}shouldInvokeFactory(l){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(l)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[l])}isDuplicateMessageIgnoredFor(l){return this.ignoreDuplicateModulesMap.hasOwnProperty(l)}getConfigForModule(l){if(this.options.config)return this.options.config[l]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(l){this.options.onError(l)}}O.Configuration=M})(se||(se={}));var se;(function(O){class n{constructor(h){this._env=h,this._scriptLoader=null,this._callbackMap={}}load(h,w,e,_){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:b}=h.getConfig().getOptionsLiteral();b?this._scriptLoader=new E:this._scriptLoader=new l(this._env)}else this._env.isNode?this._scriptLoader=new l(this._env):this._scriptLoader=new E;let f={callback:e,errorback:_};if(this._callbackMap.hasOwnProperty(w)){this._callbackMap[w].push(f);return}this._callbackMap[w]=[f],this._scriptLoader.load(h,w,()=>this.triggerCallback(w),b=>this.triggerErrorback(w,b))}triggerCallback(h){let w=this._callbackMap[h];delete this._callbackMap[h];for(let e=0;e<w.length;e++)w[e].callback()}triggerErrorback(h,w){let e=this._callbackMap[h];delete this._callbackMap[h];for(let _=0;_<e.length;_++)e[_].errorback(w)}}class E{attachListeners(h,w,e){let _=()=>{h.removeEventListener("load",f),h.removeEventListener("error",b)},f=g=>{_(),w()},b=g=>{_(),e(g)};h.addEventListener("load",f),h.addEventListener("error",b)}load(h,w,e,_){if(/^node\|/.test(w)){let f=h.getConfig().getOptionsLiteral(),b=S(h.getRecorder(),f.nodeRequire||O.global.nodeRequire),g=w.split("|"),C=null;try{C=b(g[1])}catch(A){_(A);return}h.enqueueDefineAnonymousModule([],()=>C),e()}else{let f=document.createElement("script");f.setAttribute("async","async"),f.setAttribute("type","text/javascript"),this.attachListeners(f,e,_);const{trustedTypesPolicy:b}=h.getConfig().getOptionsLiteral();b&&(w=b.createScriptURL(w)),f.setAttribute("src",w);const{cspNonce:g}=h.getConfig().getOptionsLiteral();g&&f.setAttribute("nonce",g),document.getElementsByTagName("head")[0].appendChild(f)}}}function M(c){const{trustedTypesPolicy:h}=c.getConfig().getOptionsLiteral();try{return(h?self.eval(h.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(h){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=M(h)),this._cachedCanUseEval}load(h,w,e,_){if(/^node\|/.test(w)){const f=h.getConfig().getOptionsLiteral(),b=S(h.getRecorder(),f.nodeRequire||O.global.nodeRequire),g=w.split("|");let C=null;try{C=b(g[1])}catch(A){_(A);return}h.enqueueDefineAnonymousModule([],function(){return C}),e()}else{const{trustedTypesPolicy:f}=h.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(w)&&w.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(h)){fetch(w).then(g=>{if(g.status!==200)throw new Error(g.statusText);return g.text()}).then(g=>{g=`${g}
//# sourceURL=${w}`,(f?self.eval(f.createScript("",g)):new Function(g)).call(self),e()}).then(void 0,_);return}try{f&&(w=f.createScriptURL(w)),importScripts(w),e()}catch(g){_(g)}}}}class l{constructor(h){this._env=h,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(h){this._didInitialize||(this._didInitialize=!0,this._fs=h("fs"),this._vm=h("vm"),this._path=h("path"),this._crypto=h("crypto"))}_initNodeRequire(h,w){const{nodeCachedData:e}=w.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const _=this,f=h("module");function b(g){const C=g.constructor;let A=function(d){try{return g.require(d)}finally{}};return A.resolve=function(d,m){return C._resolveFilename(d,g,!1,m)},A.resolve.paths=function(d){return C._resolveLookupPaths(d,g)},A.main=process.mainModule,A.extensions=C._extensions,A.cache=C._cache,A}f.prototype._compile=function(g,C){const A=f.wrap(g.replace(/^#!.*/,"")),p=w.getRecorder(),d=_._getCachedDataPath(e,C),m={filename:C};let v;try{const R=_._fs.readFileSync(d);v=R.slice(0,16),m.cachedData=R.slice(16),p.record(60,d)}catch{p.record(61,d)}const r=new _._vm.Script(A,m),o=r.runInThisContext(m),s=_._path.dirname(C),a=b(this),u=[this.exports,a,this,C,s,process,Re,Buffer],L=o.apply(this.exports,u);return _._handleCachedData(r,A,d,!m.cachedData,w),_._verifyCachedData(r,A,d,v,w),L}}load(h,w,e,_){const f=h.getConfig().getOptionsLiteral(),b=S(h.getRecorder(),f.nodeRequire||O.global.nodeRequire),g=f.nodeInstrumenter||function(A){return A};this._init(b),this._initNodeRequire(b,h);let C=h.getRecorder();if(/^node\|/.test(w)){let A=w.split("|"),p=null;try{p=b(A[1])}catch(d){_(d);return}h.enqueueDefineAnonymousModule([],()=>p),e()}else{w=O.Utilities.fileUriToFilePath(this._env.isWindows,w);const A=this._path.normalize(w),p=this._getElectronRendererScriptPathOrUri(A),d=Boolean(f.nodeCachedData),m=d?this._getCachedDataPath(f.nodeCachedData,w):void 0;this._readSourceAndCachedData(A,m,C,(v,r,o,s)=>{if(v){_(v);return}let a;r.charCodeAt(0)===l._BOM?a=l._PREFIX+r.substring(1)+l._SUFFIX:a=l._PREFIX+r+l._SUFFIX,a=g(a,A);const u={filename:p,cachedData:o},L=this._createAndEvalScript(h,a,u,e,_);this._handleCachedData(L,a,m,d&&!o,h),this._verifyCachedData(L,a,m,s,h)})}}_createAndEvalScript(h,w,e,_,f){const b=h.getRecorder();b.record(31,e.filename);const g=new this._vm.Script(w,e),C=g.runInThisContext(e),A=h.getGlobalAMDDefineFunc();let p=!1;const d=function(){return p=!0,A.apply(null,arguments)};return d.amd=A.amd,C.call(O.global,h.getGlobalAMDRequireFunc(),d,e.filename,this._path.dirname(e.filename)),b.record(32,e.filename),p?_():f(new Error(`Didn't receive define call in ${e.filename}!`)),g}_getElectronRendererScriptPathOrUri(h){if(!this._env.isElectronRenderer)return h;let w=h.match(/^([a-z])\:(.*)/i);return w?`file:///${(w[1].toUpperCase()+":"+w[2]).replace(/\\/g,"/")}`:`file://${h}`}_getCachedDataPath(h,w){const e=this._crypto.createHash("md5").update(w,"utf8").update(h.seed,"utf8").update(process.arch,"").digest("hex"),_=this._path.basename(w).replace(/\.js$/,"");return this._path.join(h.path,`${_}-${e}.code`)}_handleCachedData(h,w,e,_,f){h.cachedDataRejected?this._fs.unlink(e,b=>{f.getRecorder().record(62,e),this._createAndWriteCachedData(h,w,e,f),b&&f.getConfig().onError(b)}):_&&this._createAndWriteCachedData(h,w,e,f)}_createAndWriteCachedData(h,w,e,_){let f=Math.ceil(_.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),b=-1,g=0,C;const A=()=>{setTimeout(()=>{C||(C=this._crypto.createHash("md5").update(w,"utf8").digest());const p=h.createCachedData();if(!(p.length===0||p.length===b||g>=5)){if(p.length<b){A();return}b=p.length,this._fs.writeFile(e,Buffer.concat([C,p]),d=>{d&&_.getConfig().onError(d),_.getRecorder().record(63,e),A()})}},f*Math.pow(4,g++))};A()}_readSourceAndCachedData(h,w,e,_){if(!w)this._fs.readFile(h,{encoding:"utf8"},_);else{let f,b,g,C=2;const A=p=>{p?_(p):--C===0&&_(void 0,f,b,g)};this._fs.readFile(h,{encoding:"utf8"},(p,d)=>{f=d,A(p)}),this._fs.readFile(w,(p,d)=>{!p&&d&&d.length>0?(g=d.slice(0,16),b=d.slice(16),e.record(60,w)):e.record(61,w),A()})}}_verifyCachedData(h,w,e,_,f){!_||h.cachedDataRejected||setTimeout(()=>{const b=this._crypto.createHash("md5").update(w,"utf8").digest();_.equals(b)||(f.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,g=>{g&&f.getConfig().onError(g)}))},Math.ceil(5e3*(1+Math.random())))}}l._BOM=65279,l._PREFIX="(function (require, define, __filename, __dirname) { ",l._SUFFIX=`
});`;function S(c,h){if(h.__$__isRecorded)return h;const w=function(_){c.record(33,_);try{return h(_)}finally{c.record(34,_)}};return w.__$__isRecorded=!0,w}O.ensureRecordedNodeRequire=S;function y(c){return new n(c)}O.createScriptLoader=y})(se||(se={}));var se;(function(O){class n{constructor(c){let h=c.lastIndexOf("/");h!==-1?this.fromModulePath=c.substr(0,h+1):this.fromModulePath=""}static _normalizeModuleId(c){let h=c,w;for(w=/\/\.\//;w.test(h);)h=h.replace(w,"/");for(h=h.replace(/^\.\//g,""),w=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;w.test(h);)h=h.replace(w,"/");return h=h.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),h}resolveModule(c){let h=c;return O.Utilities.isAbsolutePath(h)||(O.Utilities.startsWith(h,"./")||O.Utilities.startsWith(h,"../"))&&(h=n._normalizeModuleId(this.fromModulePath+h)),h}}n.ROOT=new n(""),O.ModuleIdResolver=n;class E{constructor(c,h,w,e,_,f){this.id=c,this.strId=h,this.dependencies=w,this._callback=e,this._errorback=_,this.moduleIdResolver=f,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(c,h){try{return{returnedValue:c.apply(O.global,h),producedError:null}}catch(w){return{returnedValue:null,producedError:w}}}static _invokeFactory(c,h,w,e){return c.shouldInvokeFactory(h)?c.shouldCatchError()?this._safeInvokeFunction(w,e):{returnedValue:w.apply(O.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(c,h,w,e){this._isComplete=!0;let _=null;if(this._callback)if(typeof this._callback=="function"){c.record(21,this.strId);let f=E._invokeFactory(h,this.strId,this._callback,w);_=f.producedError,c.record(22,this.strId),!_&&typeof f.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=f.returnedValue)}else this.exports=this._callback;if(_){let f=O.ensureError(_);f.phase="factory",f.moduleId=this.strId,f.neededBy=e(this.id),this.error=f,h.onError(f)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(c){return this._isComplete=!0,this.error=c,this._errorback?(this._errorback(c),!0):!1}isComplete(){return this._isComplete}}O.Module=E;class M{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(c){let h=this._strModuleIdToIntModuleId.get(c);return typeof h>"u"&&(h=this._nextId++,this._strModuleIdToIntModuleId.set(c,h),this._intModuleIdToStrModuleId[h]=c),h}getStrModuleId(c){return this._intModuleIdToStrModuleId[c]}}class i{constructor(c){this.id=c}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),O.RegularDependency=i;class l{constructor(c,h,w){this.id=c,this.pluginId=h,this.pluginParam=w}}O.PluginDependency=l;class S{constructor(c,h,w,e,_=0){this._env=c,this._scriptLoader=h,this._loaderAvailableTimestamp=_,this._defineFunc=w,this._requireFunc=e,this._moduleIdProvider=new M,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new S(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(c,h){let w=f=>f.replace(/\\/g,"/"),e=w(c),_=h.split(/\n/);for(let f=0;f<_.length;f++){let b=_[f].match(/(.*):(\d+):(\d+)\)?$/);if(b){let g=b[1],C=b[2],A=b[3],p=Math.max(g.lastIndexOf(" ")+1,g.lastIndexOf("(")+1);if(g=g.substr(p),g=w(g),g===e){let d={line:parseInt(C,10),col:parseInt(A,10)};return d.line===1&&(d.col-=53),d}}}throw new Error("Could not correlate define call site for needle "+c)}getBuildInfo(){if(!this._config.isBuild())return null;let c=[],h=0;for(let w=0,e=this._modules2.length;w<e;w++){let _=this._modules2[w];if(!_)continue;let f=this._buildInfoPath[_.id]||null,b=this._buildInfoDefineStack[_.id]||null,g=this._buildInfoDependencies[_.id];c[h++]={id:_.strId,path:f,defineLocation:f&&b?S._findRelevantLocationInStack(f,b):null,dependencies:g,shim:null,exports:_.exports}}return c}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(c,h){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let w=null;this._config.isBuild()&&(w=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:w,dependencies:c,callback:h}}defineModule(c,h,w,e,_,f=new n(c)){let b=this._moduleIdProvider.getModuleId(c);if(this._modules2[b]){this._config.isDuplicateMessageIgnoredFor(c)||console.warn("Duplicate definition of module '"+c+"'");return}let g=new E(b,c,this._normalizeDependencies(h,f),w,e,f);this._modules2[b]=g,this._config.isBuild()&&(this._buildInfoDefineStack[b]=_,this._buildInfoDependencies[b]=(g.dependencies||[]).map(C=>this._moduleIdProvider.getStrModuleId(C.id))),this._resolve(g)}_normalizeDependency(c,h){if(c==="exports")return i.EXPORTS;if(c==="module")return i.MODULE;if(c==="require")return i.REQUIRE;let w=c.indexOf("!");if(w>=0){let e=h.resolveModule(c.substr(0,w)),_=h.resolveModule(c.substr(w+1)),f=this._moduleIdProvider.getModuleId(e+"!"+_),b=this._moduleIdProvider.getModuleId(e);return new l(f,b,_)}return new i(this._moduleIdProvider.getModuleId(h.resolveModule(c)))}_normalizeDependencies(c,h){let w=[],e=0;for(let _=0,f=c.length;_<f;_++)w[e++]=this._normalizeDependency(c[_],h);return w}_relativeRequire(c,h,w,e){if(typeof h=="string")return this.synchronousRequire(h,c);this.defineModule(O.Utilities.generateAnonymousModule(),h,w,e,null,c)}synchronousRequire(c,h=new n(c)){let w=this._normalizeDependency(c,h),e=this._modules2[w.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+c+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+c+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(c,h){let w=this._config.shouldRecordStats();h?this._config=new O.Configuration(this._env,c):this._config=this._config.cloneAndMerge(c),this._config.shouldRecordStats()&&!w&&(this._recorder=null)}getConfig(){return this._config}_onLoad(c){if(this._currentAnonymousDefineCall!==null){let h=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(c),h.dependencies,h.callback,null,h.stack)}}_createLoadError(c,h){let w=this._moduleIdProvider.getStrModuleId(c),e=(this._inverseDependencies2[c]||[]).map(f=>this._moduleIdProvider.getStrModuleId(f));const _=O.ensureError(h);return _.phase="loading",_.moduleId=w,_.neededBy=e,_}_onLoadError(c,h){const w=this._createLoadError(c,h);this._modules2[c]||(this._modules2[c]=new E(c,this._moduleIdProvider.getStrModuleId(c),[],()=>{},null,null));let e=[];for(let b=0,g=this._moduleIdProvider.getMaxModuleId();b<g;b++)e[b]=!1;let _=!1,f=[];for(f.push(c),e[c]=!0;f.length>0;){let b=f.shift(),g=this._modules2[b];g&&(_=g.onDependencyError(w)||_);let C=this._inverseDependencies2[b];if(C)for(let A=0,p=C.length;A<p;A++){let d=C[A];e[d]||(f.push(d),e[d]=!0)}}_||this._config.onError(w)}_hasDependencyPath(c,h){let w=this._modules2[c];if(!w)return!1;let e=[];for(let f=0,b=this._moduleIdProvider.getMaxModuleId();f<b;f++)e[f]=!1;let _=[];for(_.push(w),e[c]=!0;_.length>0;){let b=_.shift().dependencies;if(b)for(let g=0,C=b.length;g<C;g++){let A=b[g];if(A.id===h)return!0;let p=this._modules2[A.id];p&&!e[A.id]&&(e[A.id]=!0,_.push(p))}}return!1}_findCyclePath(c,h,w){if(c===h||w===50)return[c];let e=this._modules2[c];if(!e)return null;let _=e.dependencies;if(_)for(let f=0,b=_.length;f<b;f++){let g=this._findCyclePath(_[f].id,h,w+1);if(g!==null)return g.push(c),g}return null}_createRequire(c){let h=(w,e,_)=>this._relativeRequire(c,w,e,_);return h.toUrl=w=>this._config.requireToUrl(c.resolveModule(w)),h.getStats=()=>this.getLoaderEvents(),h.hasDependencyCycle=()=>this._hasDependencyCycle,h.config=(w,e=!1)=>{this.configure(w,e)},h.__$__nodeRequire=O.global.nodeRequire,h}_loadModule(c){if(this._modules2[c]||this._knownModules2[c])return;this._knownModules2[c]=!0;let h=this._moduleIdProvider.getStrModuleId(c),w=this._config.moduleIdToPaths(h),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(h.indexOf("/")===-1||e.test(h))&&w.push("node|"+h);let _=-1,f=b=>{if(_++,_>=w.length)this._onLoadError(c,b);else{let g=w[_],C=this.getRecorder();if(this._config.isBuild()&&g==="empty:"){this._buildInfoPath[c]=g,this.defineModule(this._moduleIdProvider.getStrModuleId(c),[],null,null,null),this._onLoad(c);return}C.record(10,g),this._scriptLoader.load(this,g,()=>{this._config.isBuild()&&(this._buildInfoPath[c]=g),C.record(11,g),this._onLoad(c)},A=>{C.record(12,g),f(A)})}};f(null)}_loadPluginDependency(c,h){if(this._modules2[h.id]||this._knownModules2[h.id])return;this._knownModules2[h.id]=!0;let w=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(h.id),[],e,null,null)};w.error=e=>{this._config.onError(this._createLoadError(h.id,e))},c.load(h.pluginParam,this._createRequire(n.ROOT),w,this._config.getOptionsLiteral())}_resolve(c){let h=c.dependencies;if(h)for(let w=0,e=h.length;w<e;w++){let _=h[w];if(_===i.EXPORTS){c.exportsPassedIn=!0,c.unresolvedDependenciesCount--;continue}if(_===i.MODULE){c.unresolvedDependenciesCount--;continue}if(_===i.REQUIRE){c.unresolvedDependenciesCount--;continue}let f=this._modules2[_.id];if(f&&f.isComplete()){if(f.error){c.onDependencyError(f.error);return}c.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(_.id,c.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(_.id)+"' and '"+this._moduleIdProvider.getStrModuleId(c.id)+"'. The cyclic path follows:");let b=this._findCyclePath(_.id,c.id,0)||[];b.reverse(),b.push(_.id),console.warn(b.map(g=>this._moduleIdProvider.getStrModuleId(g)).join(` => 
`)),c.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[_.id]=this._inverseDependencies2[_.id]||[],this._inverseDependencies2[_.id].push(c.id),_ instanceof l){let b=this._modules2[_.pluginId];if(b&&b.isComplete()){this._loadPluginDependency(b.exports,_);continue}let g=this._inversePluginDependencies2.get(_.pluginId);g||(g=[],this._inversePluginDependencies2.set(_.pluginId,g)),g.push(_),this._loadModule(_.pluginId);continue}this._loadModule(_.id)}c.unresolvedDependenciesCount===0&&this._onModuleComplete(c)}_onModuleComplete(c){let h=this.getRecorder();if(c.isComplete())return;let w=c.dependencies,e=[];if(w)for(let g=0,C=w.length;g<C;g++){let A=w[g];if(A===i.EXPORTS){e[g]=c.exports;continue}if(A===i.MODULE){e[g]={id:c.strId,config:()=>this._config.getConfigForModule(c.strId)};continue}if(A===i.REQUIRE){e[g]=this._createRequire(c.moduleIdResolver);continue}let p=this._modules2[A.id];if(p){e[g]=p.exports;continue}e[g]=null}const _=g=>(this._inverseDependencies2[g]||[]).map(C=>this._moduleIdProvider.getStrModuleId(C));c.complete(h,this._config,e,_);let f=this._inverseDependencies2[c.id];if(this._inverseDependencies2[c.id]=null,f)for(let g=0,C=f.length;g<C;g++){let A=f[g],p=this._modules2[A];p.unresolvedDependenciesCount--,p.unresolvedDependenciesCount===0&&this._onModuleComplete(p)}let b=this._inversePluginDependencies2.get(c.id);if(b){this._inversePluginDependencies2.delete(c.id);for(let g=0,C=b.length;g<C;g++)this._loadPluginDependency(c.exports,b[g])}}}O.ModuleManager=S})(se||(se={}));var Q,se;(function(O){const n=new O.Environment;let E=null;const M=function(y,c,h){typeof y!="string"&&(h=c,c=y,y=null),(typeof c!="object"||!Array.isArray(c))&&(h=c,c=null),c||(c=["require","exports","module"]),y?E.defineModule(y,c,h,null,null):E.enqueueDefineAnonymousModule(c,h)};M.amd={jQuery:!0};const i=function(y,c=!1){E.configure(y,c)},l=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return E.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){E.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};l.config=i,l.getConfig=function(){return E.getConfig().getOptionsLiteral()},l.reset=function(){E=E.reset()},l.getBuildInfo=function(){return E.getBuildInfo()},l.getStats=function(){return E.getLoaderEvents()},l.define=M;function S(){if(typeof O.global.require<"u"||typeof require<"u"){const y=O.global.require||require;if(typeof y=="function"&&typeof y.resolve=="function"){const c=O.ensureRecordedNodeRequire(E.getRecorder(),y);O.global.nodeRequire=c,l.nodeRequire=c,l.__$__nodeRequire=c}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=l:(n.isElectronRenderer||(O.global.define=M),O.global.require=l)}O.init=S,(typeof O.global.define!="function"||!O.global.define.amd)&&(E=new O.ModuleManager(n,O.createScriptLoader(n),M,l,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&l.config(O.global.require),Q=function(){return M.apply(null,arguments)},Q.amd=M.amd,typeof doNotInitLoader>"u"&&S())})(se||(se={}));var fe=this&&this.__awaiter||function(O,n,E,M){function i(l){return l instanceof E?l:new E(function(S){S(l)})}return new(E||(E=Promise))(function(l,S){function y(w){try{h(M.next(w))}catch(e){S(e)}}function c(w){try{h(M.throw(w))}catch(e){S(e)}}function h(w){w.done?l(w.value):i(w.value).then(y,c)}h((M=M.apply(O,n||[])).next())})};Q(Y[24],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let E=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const M="i-default";function i(b,g){let C;return g.length===0?C=b:C=b.replace(/\{(\d+)\}/g,(A,p)=>{const d=p[0],m=g[d];let v=A;return typeof m=="string"?v=m:(typeof m=="number"||typeof m=="boolean"||m===void 0||m===null)&&(v=String(m)),v}),E&&(C="\uFF3B"+C.replace(/[aouei]/g,"$&$&")+"\uFF3D"),C}function l(b,g){let C=b[g];return C||(C=b["*"],C)?C:null}function S(b){return b.charAt(b.length-1)==="/"?b:b+"/"}function y(b,g,C){return fe(this,void 0,void 0,function*(){const A=S(b)+S(g)+"vscode/"+S(C),p=yield fetch(A);if(p.ok)return yield p.json();throw new Error(`${p.status} - ${p.statusText}`)})}function c(b){return function(g,C){const A=Array.prototype.slice.call(arguments,2);return i(b[g],A)}}function h(b,g,...C){return i(g,C)}n.localize=h;function w(b){}n.getConfiguredDefaultLocale=w;function e(b){E=b}n.setPseudoTranslation=e;function _(b,g){var C;return{localize:c(g[b]),getConfiguredDefaultLocale:(C=g.getConfiguredDefaultLocale)!==null&&C!==void 0?C:A=>{}}}n.create=_;function f(b,g,C,A){var p;const d=(p=A["vs/nls"])!==null&&p!==void 0?p:{};if(!b||b.length===0)return C({localize:h,getConfiguredDefaultLocale:()=>{var s;return(s=d.availableLanguages)===null||s===void 0?void 0:s["*"]}});const m=d.availableLanguages?l(d.availableLanguages,b):null,v=m===null||m===M;let r=".nls";v||(r=r+"."+m);const o=s=>{Array.isArray(s)?s.localize=c(s):s.localize=c(s[b]),s.getConfiguredDefaultLocale=()=>{var a;return(a=d.availableLanguages)===null||a===void 0?void 0:a["*"]},C(s)};typeof d.loadBundle=="function"?d.loadBundle(b,m,(s,a)=>{s?g([b+".nls"],o):o(a)}):d.translationServiceUrl&&!v?fe(this,void 0,void 0,function*(){var s;try{const a=yield y(d.translationServiceUrl,m,b);return o(a)}catch(a){if(!m.includes("-"))return console.error(a),g([b+".nls"],o);try{const u=m.split("-")[0],L=yield y(d.translationServiceUrl,u,b);return(s=d.availableLanguages)!==null&&s!==void 0||(d.availableLanguages={}),d.availableLanguages["*"]=u,o(L)}catch(u){return console.error(u),g([b+".nls"],o)}}}):g([b+r],o,s=>{if(r===".nls"){console.error("Failed trying to load default language strings",s);return}console.error(`Failed to load message bundle for language ${m}. Falling back to the default language:`,s),g([b+".nls"],o)})}n.load=f}),function(){var O,n;const E=globalThis.MonacoEnvironment,M=E&&E.baseUrl?E.baseUrl:"../../../",i=typeof((O=self.trustedTypes)===null||O===void 0?void 0:O.createPolicy)=="function"?(n=self.trustedTypes)===null||n===void 0?void 0:n.createPolicy("amdLoader",{createScriptURL:e=>e,createScript:(e,..._)=>{const f=_.slice(0,-1).join(","),b=_.pop().toString();return`(function anonymous(${f}) { ${b}
})`}}):void 0;function l(){try{return(i?globalThis.eval(i.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function S(){return new Promise((e,_)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return e();const f=M+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,globalThis.origin.length)!==globalThis.origin)&&l()){fetch(f).then(g=>{if(g.status!==200)throw new Error(g.statusText);return g.text()}).then(g=>{g=`${g}
//# sourceURL=${f}`,(i?globalThis.eval(i.createScript("",g)):new Function(g)).call(globalThis),e()}).then(void 0,_);return}i?importScripts(i.createScriptURL(f)):importScripts(f),e()})}function y(){require.config({baseUrl:M,catchError:!0,trustedTypesPolicy:i,amdModulesPattern:/^vs\//})}function c(e){S().then(()=>{y(),require([e],function(_){setTimeout(function(){const f=_.create((b,g)=>{globalThis.postMessage(b,g)},null);for(globalThis.onmessage=b=>f.onmessage(b.data,b.ports);w.length>0;){const b=w.shift();f.onmessage(b.data,b.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&y();let h=!0;const w=[];globalThis.onmessage=e=>{if(!h){w.push(e);return}h=!1,c(e.data)}}(),Q(Y[25],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.numberComparator=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.asArray=n.pushMany=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.firstOrDefault=n.lastIndex=n.findLast=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesceInPlace=n.coalesce=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function E(I,F=0){return I[I.length-(1+F)]}n.tail=E;function M(I){if(I.length===0)throw new Error("Invalid tail call");return[I.slice(0,I.length-1),I[I.length-1]]}n.tail2=M;function i(I,F,k=(V,t)=>V===t){if(I===F)return!0;if(!I||!F||I.length!==F.length)return!1;for(let V=0,t=I.length;V<t;V++)if(!k(I[V],F[V]))return!1;return!0}n.equals=i;function l(I,F){const k=I.length-1;F<k&&(I[F]=I[k]),I.pop()}n.removeFastWithoutKeepingOrder=l;function S(I,F,k){return y(I.length,V=>k(I[V],F))}n.binarySearch=S;function y(I,F){let k=0,V=I-1;for(;k<=V;){const t=(k+V)/2|0,ne=F(t);if(ne<0)k=t+1;else if(ne>0)V=t-1;else return t}return-(k+1)}n.binarySearch2=y;function c(I,F){let k=0,V=I.length;if(V===0)return 0;for(;k<V;){const t=Math.floor((k+V)/2);F(I[t])?V=t:k=t+1}return k}n.findFirstInSorted=c;function h(I,F,k){if(I=I|0,I>=F.length)throw new TypeError("invalid index");const V=F[Math.floor(F.length*Math.random())],t=[],ne=[],oe=[];for(const de of F){const pe=k(de,V);pe<0?t.push(de):pe>0?ne.push(de):oe.push(de)}return I<t.length?h(I,t,k):I<t.length+oe.length?oe[0]:h(I-(t.length+oe.length),ne,k)}n.quickSelect=h;function w(I,F){const k=[];let V;for(const t of I.slice(0).sort(F))!V||F(V[0],t)!==0?(V=[t],k.push(V)):V.push(t);return k}n.groupBy=w;function e(I){return I.filter(F=>!!F)}n.coalesce=e;function _(I){let F=0;for(let k=0;k<I.length;k++)I[k]&&(I[F]=I[k],F+=1);I.length=F}n.coalesceInPlace=_;function f(I){return!Array.isArray(I)||I.length===0}n.isFalsyOrEmpty=f;function b(I){return Array.isArray(I)&&I.length>0}n.isNonEmptyArray=b;function g(I,F=k=>k){const k=new Set;return I.filter(V=>{const t=F(V);return k.has(t)?!1:(k.add(t),!0)})}n.distinct=g;function C(I,F){const k=A(I,F);if(k!==-1)return I[k]}n.findLast=C;function A(I,F){for(let k=I.length-1;k>=0;k--){const V=I[k];if(F(V))return k}return-1}n.lastIndex=A;function p(I,F){return I.length>0?I[0]:F}n.firstOrDefault=p;function d(I,F){let k=typeof F=="number"?I:0;typeof F=="number"?k=I:(k=0,F=I);const V=[];if(k<=F)for(let t=k;t<F;t++)V.push(t);else for(let t=k;t>F;t--)V.push(t);return V}n.range=d;function m(I,F,k){const V=I.slice(0,F),t=I.slice(F);return V.concat(k,t)}n.arrayInsert=m;function v(I,F){const k=I.indexOf(F);k>-1&&(I.splice(k,1),I.unshift(F))}n.pushToStart=v;function r(I,F){const k=I.indexOf(F);k>-1&&(I.splice(k,1),I.push(F))}n.pushToEnd=r;function o(I,F){for(const k of F)I.push(k)}n.pushMany=o;function s(I){return Array.isArray(I)?I:[I]}n.asArray=s;function a(I,F,k){const V=L(I,F),t=I.length,ne=k.length;I.length=t+ne;for(let oe=t-1;oe>=V;oe--)I[oe+ne]=I[oe];for(let oe=0;oe<ne;oe++)I[oe+V]=k[oe]}n.insertInto=a;function u(I,F,k,V){const t=L(I,F),ne=I.splice(t,k);return a(I,t,V),ne}n.splice=u;function L(I,F){return F<0?Math.max(F+I.length,0):Math.min(F,I.length)}var R;(function(I){function F(t){return t<0}I.isLessThan=F;function k(t){return t>0}I.isGreaterThan=k;function V(t){return t===0}I.isNeitherLessOrGreaterThan=V,I.greaterThan=1,I.lessThan=-1,I.neitherLessOrGreaterThan=0})(R=n.CompareResult||(n.CompareResult={}));function N(I,F){return(k,V)=>F(I(k),I(V))}n.compareBy=N;const D=(I,F)=>I-F;n.numberComparator=D;function U(I,F){if(I.length===0)return;let k=I[0];for(let V=1;V<I.length;V++){const t=I[V];F(t,k)>0&&(k=t)}return k}n.findMaxBy=U;function B(I,F){if(I.length===0)return;let k=I[0];for(let V=1;V<I.length;V++){const t=I[V];F(t,k)>=0&&(k=t)}return k}n.findLastMaxBy=B;function T(I,F){return U(I,(k,V)=>-F(k,V))}n.findMinBy=T;class q{constructor(F){this.items=F,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(F){let k=this.firstIdx;for(;k<this.items.length&&F(this.items[k]);)k++;const V=k===this.firstIdx?null:this.items.slice(this.firstIdx,k);return this.firstIdx=k,V}takeFromEndWhile(F){let k=this.lastIdx;for(;k>=0&&F(this.items[k]);)k--;const V=k===this.lastIdx?null:this.items.slice(k+1,this.lastIdx+1);return this.lastIdx=k,V}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const F=this.items[this.firstIdx];return this.firstIdx++,F}takeCount(F){const k=this.items.slice(this.firstIdx,this.firstIdx+F);return this.firstIdx+=F,k}}n.ArrayQueue=q;class H{constructor(F){this.iterate=F}toArray(){const F=[];return this.iterate(k=>(F.push(k),!0)),F}filter(F){return new H(k=>this.iterate(V=>F(V)?k(V):!0))}map(F){return new H(k=>this.iterate(V=>k(F(V))))}findLast(F){let k;return this.iterate(V=>(F(V)&&(k=V),!0)),k}findLastMaxBy(F){let k,V=!0;return this.iterate(t=>((V||R.isGreaterThan(F(t,k)))&&(V=!1,k=t),!0)),k}}H.empty=new H(I=>{}),n.CallbackIterable=H}),Q(Y[26],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class E{constructor(l){this.fn=l,this.lastCache=void 0,this.lastArgKey=void 0}get(l){const S=JSON.stringify(l);return this.lastArgKey!==S&&(this.lastArgKey=S,this.lastCache=this.fn(l)),this.lastCache}}n.LRUCachedFunction=E;class M{get cachedValues(){return this._map}constructor(l){this.fn=l,this._map=new Map}get(l){if(this._map.has(l))return this._map.get(l);const S=this.fn(l);return this._map.set(l,S),S}}n.CachedFunction=M}),Q(Y[27],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class E{constructor(i,l,S,y){this.originalStart=i,this.originalLength=l,this.modifiedStart=S,this.modifiedLength=y}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=E}),Q(Y[8],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(C){setTimeout(()=>{throw C.stack?f.isErrorNoTelemetry(C)?new f(C.message+`

`+C.stack):new Error(C.message+`

`+C.stack):C},0)}}emit(C){this.listeners.forEach(A=>{A(C)})}onUnexpectedError(C){this.unexpectedErrorHandler(C),this.emit(C)}onUnexpectedExternalError(C){this.unexpectedErrorHandler(C)}}n.ErrorHandler=E,n.errorHandler=new E;function M(g){y(g)||n.errorHandler.onUnexpectedError(g)}n.onUnexpectedError=M;function i(g){y(g)||n.errorHandler.onUnexpectedExternalError(g)}n.onUnexpectedExternalError=i;function l(g){if(g instanceof Error){const{name:C,message:A}=g,p=g.stacktrace||g.stack;return{$isError:!0,name:C,message:A,stack:p,noTelemetry:f.isErrorNoTelemetry(g)}}return g}n.transformErrorForSerialization=l;const S="Canceled";function y(g){return g instanceof c?!0:g instanceof Error&&g.name===S&&g.message===S}n.isCancellationError=y;class c extends Error{constructor(){super(S),this.name=this.message}}n.CancellationError=c;function h(){const g=new Error(S);return g.name=g.message,g}n.canceled=h;function w(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}n.illegalArgument=w;function e(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}n.illegalState=e;class _ extends Error{constructor(C){super("NotSupported"),C&&(this.message=C)}}n.NotSupportedError=_;class f extends Error{constructor(C){super(C),this.name="CodeExpectedError"}static fromError(C){if(C instanceof f)return C;const A=new f;return A.message=C.message,A.stack=C.stack,A}static isErrorNoTelemetry(C){return C.name==="CodeExpectedError"}}n.ErrorNoTelemetry=f;class b extends Error{constructor(C){super(C||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype);debugger}}n.BugIndicatingError=b}),Q(Y[9],X([0,1,8]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assertNever=n.ok=void 0;function M(y,c){if(!y)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}n.ok=M;function i(y,c="Unreachable"){throw new Error(c)}n.assertNever=i;function l(y){if(!y()){debugger;y(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}n.assertFn=l;function S(y,c){let h=0;for(;h<y.length-1;){const w=y[h],e=y[h+1];if(!c(w,e))return!1;h++}return!0}n.checkAdjacentItems=S}),Q(Y[13],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function E(M){const i=this;let l=!1,S;return function(){return l||(l=!0,S=M.apply(i,arguments)),S}}n.once=E}),Q(Y[14],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var E;(function(M){function i(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}M.is=i;const l=Object.freeze([]);function S(){return l}M.empty=S;function*y(m){yield m}M.single=y;function c(m){return i(m)?m:y(m)}M.wrap=c;function h(m){return m||l}M.from=h;function w(m){return!m||m[Symbol.iterator]().next().done===!0}M.isEmpty=w;function e(m){return m[Symbol.iterator]().next().value}M.first=e;function _(m,v){for(const r of m)if(v(r))return!0;return!1}M.some=_;function f(m,v){for(const r of m)if(v(r))return r}M.find=f;function*b(m,v){for(const r of m)v(r)&&(yield r)}M.filter=b;function*g(m,v){let r=0;for(const o of m)yield v(o,r++)}M.map=g;function*C(...m){for(const v of m)for(const r of v)yield r}M.concat=C;function A(m,v,r){let o=r;for(const s of m)o=v(o,s);return o}M.reduce=A;function*p(m,v,r=m.length){for(v<0&&(v+=m.length),r<0?r+=m.length:r>m.length&&(r=m.length);v<r;v++)yield m[v]}M.slice=p;function d(m,v=Number.POSITIVE_INFINITY){const r=[];if(v===0)return[r,m];const o=m[Symbol.iterator]();for(let s=0;s<v;s++){const a=o.next();if(a.done)return[r,M.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return o}}]}M.consume=d})(E=n.Iterable||(n.Iterable={}))}),Q(Y[28],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class E{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(_,f){this._keyCodeToStr[_]=f,this._strToKeyCode[f.toLowerCase()]=_}keyCodeToStr(_){return this._keyCodeToStr[_]}strToKeyCode(_){return this._strToKeyCode[_.toLowerCase()]||0}}const M=new E,i=new E,l=new E;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const S=[],y=Object.create(null),c=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",_=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],f=[],b=[];for(const g of _){const[C,A,p,d,m,v,r,o,s,a]=g;if(b[p]||(b[p]=!0,S[p]=d,y[d]=p,c[d.toLowerCase()]=p,A&&(n.IMMUTABLE_CODE_TO_KEY_CODE[p]=m,m!==0&&m!==3&&m!==5&&m!==4&&m!==6&&m!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[m]=p))),!f[m]){if(f[m]=!0,!v)throw new Error(`String representation missing for key code ${m} around scan code ${d}`);M.define(m,v),i.define(m,s||v),l.define(m,a||s||v)}r&&(n.EVENT_KEY_CODE_MAP[r]=m),o&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[o]=m)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var h;(function(e){function _(p){return M.keyCodeToStr(p)}e.toString=_;function f(p){return M.strToKeyCode(p)}e.fromString=f;function b(p){return i.keyCodeToStr(p)}e.toUserSettingsUS=b;function g(p){return l.keyCodeToStr(p)}e.toUserSettingsGeneral=g;function C(p){return i.strToKeyCode(p)||l.strToKeyCode(p)}e.fromUserSettings=C;function A(p){if(p>=93&&p<=108)return null;switch(p){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(p)}e.toElectronAccelerator=A})(h=n.KeyCodeUtils||(n.KeyCodeUtils={}));function w(e,_){const f=(_&65535)<<16>>>0;return(e|f)>>>0}n.KeyChord=w}),Q(Y[29],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class E{constructor(i){this.executor=i,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=E}),Q(Y[10],X([0,1,13,14]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.SafeDisposable=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const i=!1;let l=null;function S(o){l=o}if(n.setDisposableTracker=S,i){const o="__is_disposable_tracked__";S(new class{trackDisposable(s){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[o]||console.log(a)},3e3)}setParent(s,a){if(s&&s!==A.None)try{s[o]=!0}catch{}}markAsDisposed(s){if(s&&s!==A.None)try{s[o]=!0}catch{}}markAsSingleton(s){}})}function y(o){return l?.trackDisposable(o),o}function c(o){l?.markAsDisposed(o)}function h(o,s){l?.setParent(o,s)}function w(o,s){if(!!l)for(const a of o)l.setParent(a,s)}function e(o){return l?.markAsSingleton(o),o}n.markAsSingleton=e;function _(o){return typeof o.dispose=="function"&&o.dispose.length===0}n.isDisposable=_;function f(o){if(M.Iterable.is(o)){const s=[];for(const a of o)if(a)try{a.dispose()}catch(u){s.push(u)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}n.dispose=f;function b(...o){const s=g(()=>f(o));return w(o,s),s}n.combinedDisposable=b;function g(o){const s=y({dispose:(0,E.once)(()=>{c(s),o()})});return s}n.toDisposable=g;class C{constructor(){this._toDispose=new Set,this._isDisposed=!1,y(this)}dispose(){this._isDisposed||(c(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{f(this._toDispose)}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return h(s,this),this._isDisposed?C.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}C.DISABLE_DISPOSED_WARNING=!1,n.DisposableStore=C;class A{constructor(){this._store=new C,y(this),h(this._store,this)}dispose(){c(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}A.None=Object.freeze({dispose(){}}),n.Disposable=A;class p{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){var a;this._isDisposed||s===this._value||((a=this._value)===null||a===void 0||a.dispose(),s&&h(s,this),this._value=s)}clear(){this.value=void 0}dispose(){var s;this._isDisposed=!0,c(this),(s=this._value)===null||s===void 0||s.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&h(s,null),s}}n.MutableDisposable=p;class d{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=d;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(s){let a=s;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,c(this))},this}}n.SafeDisposable=m;class v{constructor(s){this.object=s}dispose(){}}n.ImmortalReference=v;class r{constructor(){this._store=new Map,this._isDisposed=!1,y(this)}dispose(){c(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this._store.size)try{f(this._store.values())}finally{this._store.clear()}}get(s){return this._store.get(s)}set(s,a,u=!1){var L;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),u||(L=this._store.get(s))===null||L===void 0||L.dispose(),this._store.set(s,a)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=r}),Q(Y[15],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class E{constructor(l){this.element=l,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class M{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let l=this._first;for(;l!==E.Undefined;){const S=l.next;l.prev=E.Undefined,l.next=E.Undefined,l=S}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(l){return this._insert(l,!1)}push(l){return this._insert(l,!0)}_insert(l,S){const y=new E(l);if(this._first===E.Undefined)this._first=y,this._last=y;else if(S){const h=this._last;this._last=y,y.prev=h,h.next=y}else{const h=this._first;this._first=y,y.next=h,h.prev=y}this._size+=1;let c=!1;return()=>{c||(c=!0,this._remove(y))}}shift(){if(this._first!==E.Undefined){const l=this._first.element;return this._remove(this._first),l}}pop(){if(this._last!==E.Undefined){const l=this._last.element;return this._remove(this._last),l}}_remove(l){if(l.prev!==E.Undefined&&l.next!==E.Undefined){const S=l.prev;S.next=l.next,l.next.prev=S}else l.prev===E.Undefined&&l.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):l.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):l.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let l=this._first;for(;l!==E.Undefined;)yield l.element,l=l.next}}n.LinkedList=M}),Q(Y[4],X([0,1,26,29]),function(O,n,E,M){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpFlags=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function l(P){return!P||typeof P!="string"?!0:P.trim().length===0}n.isFalsyOrWhitespace=l;const S=/{(\d+)}/g;function y(P,...x){return x.length===0?P:P.replace(S,function(W,z){const Z=parseInt(z,10);return isNaN(Z)||Z<0||Z>=x.length?W:x[Z]})}n.format=y;function c(P){return P.replace(/[<>&]/g,function(x){switch(x){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return x}})}n.escape=c;function h(P){return P.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=h;function w(P,x=" "){const W=e(P,x);return _(W,x)}n.trim=w;function e(P,x){if(!P||!x)return P;const W=x.length;if(W===0||P.length===0)return P;let z=0;for(;P.indexOf(x,z)===z;)z=z+W;return P.substring(z)}n.ltrim=e;function _(P,x){if(!P||!x)return P;const W=x.length,z=P.length;if(W===0||z===0)return P;let Z=z,ie=-1;for(;ie=P.lastIndexOf(x,Z-1),!(ie===-1||ie+W!==Z);){if(ie===0)return"";Z=ie}return P.substring(0,Z)}n.rtrim=_;function f(P){return P.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=f;function b(P){return P.replace(/\*/g,"")}n.stripWildcards=b;function g(P,x,W={}){if(!P)throw new Error("Cannot create regex from empty string");x||(P=h(P)),W.wholeWord&&(/\B/.test(P.charAt(0))||(P="\\b"+P),/\B/.test(P.charAt(P.length-1))||(P=P+"\\b"));let z="";return W.global&&(z+="g"),W.matchCase||(z+="i"),W.multiline&&(z+="m"),W.unicode&&(z+="u"),new RegExp(P,z)}n.createRegExp=g;function C(P){return P.source==="^"||P.source==="^$"||P.source==="$"||P.source==="^\\s*$"?!1:!!(P.exec("")&&P.lastIndex===0)}n.regExpLeadsToEndlessLoop=C;function A(P){return(P.global?"g":"")+(P.ignoreCase?"i":"")+(P.multiline?"m":"")+(P.unicode?"u":"")}n.regExpFlags=A;function p(P){return P.split(/\r\n|\r|\n/)}n.splitLines=p;function d(P){for(let x=0,W=P.length;x<W;x++){const z=P.charCodeAt(x);if(z!==32&&z!==9)return x}return-1}n.firstNonWhitespaceIndex=d;function m(P,x=0,W=P.length){for(let z=x;z<W;z++){const Z=P.charCodeAt(z);if(Z!==32&&Z!==9)return P.substring(x,z)}return P.substring(x,W)}n.getLeadingWhitespace=m;function v(P,x=P.length-1){for(let W=x;W>=0;W--){const z=P.charCodeAt(W);if(z!==32&&z!==9)return W}return-1}n.lastNonWhitespaceIndex=v;function r(P,x){return P<x?-1:P>x?1:0}n.compare=r;function o(P,x,W=0,z=P.length,Z=0,ie=x.length){for(;W<z&&Z<ie;W++,Z++){const ge=P.charCodeAt(W),re=x.charCodeAt(Z);if(ge<re)return-1;if(ge>re)return 1}const ue=z-W,ve=ie-Z;return ue<ve?-1:ue>ve?1:0}n.compareSubstring=o;function s(P,x){return a(P,x,0,P.length,0,x.length)}n.compareIgnoreCase=s;function a(P,x,W=0,z=P.length,Z=0,ie=x.length){for(;W<z&&Z<ie;W++,Z++){let ge=P.charCodeAt(W),re=x.charCodeAt(Z);if(ge===re)continue;if(ge>=128||re>=128)return o(P.toLowerCase(),x.toLowerCase(),W,z,Z,ie);L(ge)&&(ge-=32),L(re)&&(re-=32);const he=ge-re;if(he!==0)return he}const ue=z-W,ve=ie-Z;return ue<ve?-1:ue>ve?1:0}n.compareSubstringIgnoreCase=a;function u(P){return P>=48&&P<=57}n.isAsciiDigit=u;function L(P){return P>=97&&P<=122}n.isLowerAsciiLetter=L;function R(P){return P>=65&&P<=90}n.isUpperAsciiLetter=R;function N(P,x){return P.length===x.length&&a(P,x)===0}n.equalsIgnoreCase=N;function D(P,x){const W=x.length;return x.length>P.length?!1:a(P,x,0,W)===0}n.startsWithIgnoreCase=D;function U(P,x){const W=Math.min(P.length,x.length);let z;for(z=0;z<W;z++)if(P.charCodeAt(z)!==x.charCodeAt(z))return z;return W}n.commonPrefixLength=U;function B(P,x){const W=Math.min(P.length,x.length);let z;const Z=P.length-1,ie=x.length-1;for(z=0;z<W;z++)if(P.charCodeAt(Z-z)!==x.charCodeAt(ie-z))return z;return W}n.commonSuffixLength=B;function T(P){return 55296<=P&&P<=56319}n.isHighSurrogate=T;function q(P){return 56320<=P&&P<=57343}n.isLowSurrogate=q;function H(P,x){return(P-55296<<10)+(x-56320)+65536}n.computeCodePoint=H;function I(P,x,W){const z=P.charCodeAt(W);if(T(z)&&W+1<x){const Z=P.charCodeAt(W+1);if(q(Z))return H(z,Z)}return z}n.getNextCodePoint=I;function F(P,x){const W=P.charCodeAt(x-1);if(q(W)&&x>1){const z=P.charCodeAt(x-2);if(T(z))return H(z,W)}return W}class k{get offset(){return this._offset}constructor(x,W=0){this._str=x,this._len=x.length,this._offset=W}setOffset(x){this._offset=x}prevCodePoint(){const x=F(this._str,this._offset);return this._offset-=x>=65536?2:1,x}nextCodePoint(){const x=I(this._str,this._len,this._offset);return this._offset+=x>=65536?2:1,x}eol(){return this._offset>=this._len}}n.CodePointIterator=k;class V{get offset(){return this._iterator.offset}constructor(x,W=0){this._iterator=new k(x,W)}nextGraphemeLength(){const x=ee.getInstance(),W=this._iterator,z=W.offset;let Z=x.getGraphemeBreakType(W.nextCodePoint());for(;!W.eol();){const ie=W.offset,ue=x.getGraphemeBreakType(W.nextCodePoint());if(K(Z,ue)){W.setOffset(ie);break}Z=ue}return W.offset-z}prevGraphemeLength(){const x=ee.getInstance(),W=this._iterator,z=W.offset;let Z=x.getGraphemeBreakType(W.prevCodePoint());for(;W.offset>0;){const ie=W.offset,ue=x.getGraphemeBreakType(W.prevCodePoint());if(K(ue,Z)){W.setOffset(ie);break}Z=ue}return z-W.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=V;function t(P,x){return new V(P,x).nextGraphemeLength()}n.nextCharLength=t;function ne(P,x){return new V(P,x).prevGraphemeLength()}n.prevCharLength=ne;function oe(P,x){x>0&&q(P.charCodeAt(x))&&x--;const W=x+t(P,x);return[W-ne(P,W),W]}n.getCharContainingOffset=oe;let de;function pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Le(P){return de||(de=pe()),de.test(P)}n.containsRTL=Le;const Se=/^[\t\n\r\x20-\x7E]*$/;function we(P){return Se.test(P)}n.isBasicASCII=we,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ye(P){return n.UNUSUAL_LINE_TERMINATORS.test(P)}n.containsUnusualLineTerminators=ye;function Ae(P){return P>=11904&&P<=55215||P>=63744&&P<=64255||P>=65281&&P<=65374}n.isFullWidthCharacter=Ae;function J(P){return P>=127462&&P<=127487||P===8986||P===8987||P===9200||P===9203||P>=9728&&P<=10175||P===11088||P===11093||P>=127744&&P<=128591||P>=128640&&P<=128764||P>=128992&&P<=129008||P>=129280&&P<=129535||P>=129648&&P<=129782}n.isEmojiImprecise=J,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function j(P){return!!(P&&P.length>0&&P.charCodeAt(0)===65279)}n.startsWithUTF8BOM=j;function G(P,x=!1){return P?(x&&(P=P.replace(/\\./g,"")),P.toLowerCase()!==P):!1}n.containsUppercaseCharacter=G;function $(P){return P=P%(2*26),P<26?String.fromCharCode(97+P):String.fromCharCode(65+P-26)}n.singleLetterHash=$;function K(P,x){return P===0?x!==5&&x!==7:P===2&&x===3?!1:P===4||P===2||P===3||x===4||x===2||x===3?!0:!(P===8&&(x===8||x===9||x===11||x===12)||(P===11||P===9)&&(x===9||x===10)||(P===12||P===10)&&x===10||x===5||x===13||x===7||P===1||P===13&&x===14||P===6&&x===6)}class ee{static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}constructor(){this._data=te()}getGraphemeBreakType(x){if(x<32)return x===10?3:x===13?2:4;if(x<127)return 0;const W=this._data,z=W.length/3;let Z=1;for(;Z<=z;)if(x<W[3*Z])Z=2*Z;else if(x>W[3*Z+1])Z=2*Z+1;else return W[3*Z+2];return 0}}ee._INSTANCE=null;function te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function le(P,x){if(P===0)return 0;const W=be(P,x);if(W!==void 0)return W;const z=new k(x,P);return z.prevCodePoint(),z.offset}n.getLeftDeleteOffset=le;function be(P,x){const W=new k(x,P);let z=W.prevCodePoint();for(;_e(z)||z===65039||z===8419;){if(W.offset===0)return;z=W.prevCodePoint()}if(!J(z))return;let Z=W.offset;return Z>0&&W.prevCodePoint()===8205&&(Z=W.offset),Z}function _e(P){return 127995<=P&&P<=127999}n.noBreakWhitespace="\xA0";class ae{static getInstance(x){return ae.cache.get(Array.from(x))}static getLocales(){return ae._locales.value}constructor(x){this.confusableDictionary=x}isAmbiguous(x){return this.confusableDictionary.has(x)}getPrimaryConfusable(x){return this.confusableDictionary.get(x)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}i=ae,ae.ambiguousCharacterData=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ae.cache=new E.LRUCachedFunction(P=>{function x(re){const he=new Map;for(let me=0;me<re.length;me+=2)he.set(re[me],re[me+1]);return he}function W(re,he){const me=new Map(re);for(const[Ce,Ne]of he)me.set(Ce,Ne);return me}function z(re,he){if(!re)return he;const me=new Map;for(const[Ce,Ne]of re)he.has(Ce)&&me.set(Ce,Ne);return me}const Z=i.ambiguousCharacterData.value;let ie=P.filter(re=>!re.startsWith("_")&&re in Z);ie.length===0&&(ie=["_default"]);let ue;for(const re of ie){const he=x(Z[re]);ue=z(ue,he)}const ve=x(Z._common),ge=W(ve,ue);return new ae(ge)}),ae._locales=new M.Lazy(()=>Object.keys(ae.ambiguousCharacterData.value).filter(P=>!P.startsWith("_"))),n.AmbiguousCharacters=ae;class ce{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ce.getRawData())),this._data}static isInvisibleCharacter(x){return ce.getData().has(x)}static get codePoints(){return ce.getData()}}ce._data=void 0,n.InvisibleCharacters=ce}),Q(Y[30],X([0,1,4]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function M(g){return i(g,0)}n.hash=M;function i(g,C){switch(typeof g){case"object":return g===null?l(349,C):Array.isArray(g)?c(g,C):h(g,C);case"string":return y(g,C);case"boolean":return S(g,C);case"number":return l(g,C);case"undefined":return l(937,C);default:return l(617,C)}}n.doHash=i;function l(g,C){return(C<<5)-C+g|0}n.numberHash=l;function S(g,C){return l(g?433:863,C)}function y(g,C){C=l(149417,C);for(let A=0,p=g.length;A<p;A++)C=l(g.charCodeAt(A),C);return C}n.stringHash=y;function c(g,C){return C=l(104579,C),g.reduce((A,p)=>i(p,A),C)}function h(g,C){return C=l(181387,C),Object.keys(g).sort().reduce((A,p)=>(A=y(p,A),i(g[p],A)),C)}function w(g,C,A=32){const p=A-C,d=~((1<<p)-1);return(g<<C|(d&g)>>>p)>>>0}function e(g,C=0,A=g.byteLength,p=0){for(let d=0;d<A;d++)g[C+d]=p}function _(g,C,A="0"){for(;g.length<C;)g=A+g;return g}function f(g,C=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(A=>A.toString(16).padStart(2,"0")).join(""):_((g>>>0).toString(16),C/4)}n.toHexString=f;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(C){const A=C.length;if(A===0)return;const p=this._buff;let d=this._buffLen,m=this._leftoverHighSurrogate,v,r;for(m!==0?(v=m,r=-1,m=0):(v=C.charCodeAt(0),r=0);;){let o=v;if(E.isHighSurrogate(v))if(r+1<A){const s=C.charCodeAt(r+1);E.isLowSurrogate(s)?(r++,o=E.computeCodePoint(v,s)):o=65533}else{m=v;break}else E.isLowSurrogate(v)&&(o=65533);if(d=this._push(p,d,o),r++,r<A)v=C.charCodeAt(r);else break}this._buffLen=d,this._leftoverHighSurrogate=m}_push(C,A,p){return p<128?C[A++]=p:p<2048?(C[A++]=192|(p&1984)>>>6,C[A++]=128|(p&63)>>>0):p<65536?(C[A++]=224|(p&61440)>>>12,C[A++]=128|(p&4032)>>>6,C[A++]=128|(p&63)>>>0):(C[A++]=240|(p&1835008)>>>18,C[A++]=128|(p&258048)>>>12,C[A++]=128|(p&4032)>>>6,C[A++]=128|(p&63)>>>0),A>=64&&(this._step(),A-=64,this._totalLen+=64,C[0]=C[64+0],C[1]=C[64+1],C[2]=C[64+2]),A}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const C=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(C/4294967296),!1),this._buffDV.setUint32(60,C%4294967296,!1),this._step()}_step(){const C=b._bigBlock32,A=this._buffDV;for(let u=0;u<64;u+=4)C.setUint32(u,A.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)C.setUint32(u,w(C.getUint32(u-12,!1)^C.getUint32(u-32,!1)^C.getUint32(u-56,!1)^C.getUint32(u-64,!1),1),!1);let p=this._h0,d=this._h1,m=this._h2,v=this._h3,r=this._h4,o,s,a;for(let u=0;u<80;u++)u<20?(o=d&m|~d&v,s=1518500249):u<40?(o=d^m^v,s=1859775393):u<60?(o=d&m|d&v|m&v,s=2400959708):(o=d^m^v,s=3395469782),a=w(p,5)+o+r+s+C.getUint32(u*4,!1)&4294967295,r=v,v=m,m=w(d,30),d=p,p=a;this._h0=this._h0+p&4294967295,this._h1=this._h1+d&4294967295,this._h2=this._h2+m&4294967295,this._h3=this._h3+v&4294967295,this._h4=this._h4+r&4294967295}}b._bigBlock32=new DataView(new ArrayBuffer(320)),n.StringSHA1=b}),Q(Y[16],X([0,1,27,30]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class i{constructor(e){this.source=e}getElements(){const e=this.source,_=new Int32Array(e.length);for(let f=0,b=e.length;f<b;f++)_[f]=e.charCodeAt(f);return _}}n.StringDiffSequence=i;function l(w,e,_){return new h(new i(w),new i(e)).ComputeDiff(_).changes}n.stringDiff=l;class S{static Assert(e,_){if(!e)throw new Error(_)}}class y{static Copy(e,_,f,b,g){for(let C=0;C<g;C++)f[b+C]=e[_+C]}static Copy2(e,_,f,b,g){for(let C=0;C<g;C++)f[b+C]=e[_+C]}}class c{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,_){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,_),this.m_originalCount++}AddModifiedElement(e,_){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,_),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class h{constructor(e,_,f=null){this.ContinueProcessingPredicate=f,this._originalSequence=e,this._modifiedSequence=_;const[b,g,C]=h._getElements(e),[A,p,d]=h._getElements(_);this._hasStrings=C&&d,this._originalStringElements=b,this._originalElementsOrHash=g,this._modifiedStringElements=A,this._modifiedElementsOrHash=p,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const _=e.getElements();if(h._isStringArray(_)){const f=new Int32Array(_.length);for(let b=0,g=_.length;b<g;b++)f[b]=(0,M.stringHash)(_[b],0);return[_,f,!0]}return _ instanceof Int32Array?[[],_,!1]:[[],new Int32Array(_),!1]}ElementsAreEqual(e,_){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[_]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[_]:!0}ElementsAreStrictEqual(e,_){if(!this.ElementsAreEqual(e,_))return!1;const f=h._getStrictElement(this._originalSequence,e),b=h._getStrictElement(this._modifiedSequence,_);return f===b}static _getStrictElement(e,_){return typeof e.getStrictElement=="function"?e.getStrictElement(_):null}OriginalElementsAreEqual(e,_){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[_]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[_]:!0}ModifiedElementsAreEqual(e,_){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[_]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[_]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,_,f,b,g){const C=[!1];let A=this.ComputeDiffRecursive(e,_,f,b,C);return g&&(A=this.PrettifyChanges(A)),{quitEarly:C[0],changes:A}}ComputeDiffRecursive(e,_,f,b,g){for(g[0]=!1;e<=_&&f<=b&&this.ElementsAreEqual(e,f);)e++,f++;for(;_>=e&&b>=f&&this.ElementsAreEqual(_,b);)_--,b--;if(e>_||f>b){let v;return f<=b?(S.Assert(e===_+1,"originalStart should only be one more than originalEnd"),v=[new E.DiffChange(e,0,f,b-f+1)]):e<=_?(S.Assert(f===b+1,"modifiedStart should only be one more than modifiedEnd"),v=[new E.DiffChange(e,_-e+1,f,0)]):(S.Assert(e===_+1,"originalStart should only be one more than originalEnd"),S.Assert(f===b+1,"modifiedStart should only be one more than modifiedEnd"),v=[]),v}const C=[0],A=[0],p=this.ComputeRecursionPoint(e,_,f,b,C,A,g),d=C[0],m=A[0];if(p!==null)return p;if(!g[0]){const v=this.ComputeDiffRecursive(e,d,f,m,g);let r=[];return g[0]?r=[new E.DiffChange(d+1,_-(d+1)+1,m+1,b-(m+1)+1)]:r=this.ComputeDiffRecursive(d+1,_,m+1,b,g),this.ConcatenateChanges(v,r)}return[new E.DiffChange(e,_-e+1,f,b-f+1)]}WALKTRACE(e,_,f,b,g,C,A,p,d,m,v,r,o,s,a,u,L,R){let N=null,D=null,U=new c,B=_,T=f,q=o[0]-u[0]-b,H=-1073741824,I=this.m_forwardHistory.length-1;do{const F=q+e;F===B||F<T&&d[F-1]<d[F+1]?(v=d[F+1],s=v-q-b,v<H&&U.MarkNextChange(),H=v,U.AddModifiedElement(v+1,s),q=F+1-e):(v=d[F-1]+1,s=v-q-b,v<H&&U.MarkNextChange(),H=v-1,U.AddOriginalElement(v,s+1),q=F-1-e),I>=0&&(d=this.m_forwardHistory[I],e=d[0],B=1,T=d.length-1)}while(--I>=-1);if(N=U.getReverseChanges(),R[0]){let F=o[0]+1,k=u[0]+1;if(N!==null&&N.length>0){const V=N[N.length-1];F=Math.max(F,V.getOriginalEnd()),k=Math.max(k,V.getModifiedEnd())}D=[new E.DiffChange(F,r-F+1,k,a-k+1)]}else{U=new c,B=C,T=A,q=o[0]-u[0]-p,H=1073741824,I=L?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const F=q+g;F===B||F<T&&m[F-1]>=m[F+1]?(v=m[F+1]-1,s=v-q-p,v>H&&U.MarkNextChange(),H=v+1,U.AddOriginalElement(v+1,s+1),q=F+1-g):(v=m[F-1],s=v-q-p,v>H&&U.MarkNextChange(),H=v,U.AddModifiedElement(v+1,s+1),q=F-1-g),I>=0&&(m=this.m_reverseHistory[I],g=m[0],B=1,T=m.length-1)}while(--I>=-1);D=U.getChanges()}return this.ConcatenateChanges(N,D)}ComputeRecursionPoint(e,_,f,b,g,C,A){let p=0,d=0,m=0,v=0,r=0,o=0;e--,f--,g[0]=0,C[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const s=_-e+(b-f),a=s+1,u=new Int32Array(a),L=new Int32Array(a),R=b-f,N=_-e,D=e-f,U=_-b,T=(N-R)%2===0;u[R]=e,L[N]=_,A[0]=!1;for(let q=1;q<=s/2+1;q++){let H=0,I=0;m=this.ClipDiagonalBound(R-q,q,R,a),v=this.ClipDiagonalBound(R+q,q,R,a);for(let k=m;k<=v;k+=2){k===m||k<v&&u[k-1]<u[k+1]?p=u[k+1]:p=u[k-1]+1,d=p-(k-R)-D;const V=p;for(;p<_&&d<b&&this.ElementsAreEqual(p+1,d+1);)p++,d++;if(u[k]=p,p+d>H+I&&(H=p,I=d),!T&&Math.abs(k-N)<=q-1&&p>=L[k])return g[0]=p,C[0]=d,V<=L[k]&&1447>0&&q<=1447+1?this.WALKTRACE(R,m,v,D,N,r,o,U,u,L,p,_,g,d,b,C,T,A):null}const F=(H-e+(I-f)-q)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(H,F))return A[0]=!0,g[0]=H,C[0]=I,F>0&&1447>0&&q<=1447+1?this.WALKTRACE(R,m,v,D,N,r,o,U,u,L,p,_,g,d,b,C,T,A):(e++,f++,[new E.DiffChange(e,_-e+1,f,b-f+1)]);r=this.ClipDiagonalBound(N-q,q,N,a),o=this.ClipDiagonalBound(N+q,q,N,a);for(let k=r;k<=o;k+=2){k===r||k<o&&L[k-1]>=L[k+1]?p=L[k+1]-1:p=L[k-1],d=p-(k-N)-U;const V=p;for(;p>e&&d>f&&this.ElementsAreEqual(p,d);)p--,d--;if(L[k]=p,T&&Math.abs(k-R)<=q&&p<=u[k])return g[0]=p,C[0]=d,V>=u[k]&&1447>0&&q<=1447+1?this.WALKTRACE(R,m,v,D,N,r,o,U,u,L,p,_,g,d,b,C,T,A):null}if(q<=1447){let k=new Int32Array(v-m+2);k[0]=R-m+1,y.Copy2(u,m,k,1,v-m+1),this.m_forwardHistory.push(k),k=new Int32Array(o-r+2),k[0]=N-r+1,y.Copy2(L,r,k,1,o-r+1),this.m_reverseHistory.push(k)}}return this.WALKTRACE(R,m,v,D,N,r,o,U,u,L,p,_,g,d,b,C,T,A)}PrettifyChanges(e){for(let _=0;_<e.length;_++){const f=e[_],b=_<e.length-1?e[_+1].originalStart:this._originalElementsOrHash.length,g=_<e.length-1?e[_+1].modifiedStart:this._modifiedElementsOrHash.length,C=f.originalLength>0,A=f.modifiedLength>0;for(;f.originalStart+f.originalLength<b&&f.modifiedStart+f.modifiedLength<g&&(!C||this.OriginalElementsAreEqual(f.originalStart,f.originalStart+f.originalLength))&&(!A||this.ModifiedElementsAreEqual(f.modifiedStart,f.modifiedStart+f.modifiedLength));){const d=this.ElementsAreStrictEqual(f.originalStart,f.modifiedStart);if(this.ElementsAreStrictEqual(f.originalStart+f.originalLength,f.modifiedStart+f.modifiedLength)&&!d)break;f.originalStart++,f.modifiedStart++}const p=[null];if(_<e.length-1&&this.ChangesOverlap(e[_],e[_+1],p)){e[_]=p[0],e.splice(_+1,1),_--;continue}}for(let _=e.length-1;_>=0;_--){const f=e[_];let b=0,g=0;if(_>0){const v=e[_-1];b=v.originalStart+v.originalLength,g=v.modifiedStart+v.modifiedLength}const C=f.originalLength>0,A=f.modifiedLength>0;let p=0,d=this._boundaryScore(f.originalStart,f.originalLength,f.modifiedStart,f.modifiedLength);for(let v=1;;v++){const r=f.originalStart-v,o=f.modifiedStart-v;if(r<b||o<g||C&&!this.OriginalElementsAreEqual(r,r+f.originalLength)||A&&!this.ModifiedElementsAreEqual(o,o+f.modifiedLength))break;const a=(r===b&&o===g?5:0)+this._boundaryScore(r,f.originalLength,o,f.modifiedLength);a>d&&(d=a,p=v)}f.originalStart-=p,f.modifiedStart-=p;const m=[null];if(_>0&&this.ChangesOverlap(e[_-1],e[_],m)){e[_-1]=m[0],e.splice(_,1),_++;continue}}if(this._hasStrings)for(let _=1,f=e.length;_<f;_++){const b=e[_-1],g=e[_],C=g.originalStart-b.originalStart-b.originalLength,A=b.originalStart,p=g.originalStart+g.originalLength,d=p-A,m=b.modifiedStart,v=g.modifiedStart+g.modifiedLength,r=v-m;if(C<5&&d<20&&r<20){const o=this._findBetterContiguousSequence(A,d,m,r,C);if(o){const[s,a]=o;(s!==b.originalStart+b.originalLength||a!==b.modifiedStart+b.modifiedLength)&&(b.originalLength=s-b.originalStart,b.modifiedLength=a-b.modifiedStart,g.originalStart=s+C,g.modifiedStart=a+C,g.originalLength=p-g.originalStart,g.modifiedLength=v-g.modifiedStart)}}}return e}_findBetterContiguousSequence(e,_,f,b,g){if(_<g||b<g)return null;const C=e+_-g+1,A=f+b-g+1;let p=0,d=0,m=0;for(let v=e;v<C;v++)for(let r=f;r<A;r++){const o=this._contiguousSequenceScore(v,r,g);o>0&&o>p&&(p=o,d=v,m=r)}return p>0?[d,m]:null}_contiguousSequenceScore(e,_,f){let b=0;for(let g=0;g<f;g++){if(!this.ElementsAreEqual(e+g,_+g))return 0;b+=this._originalStringElements[e+g].length}return b}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,_){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(_>0){const f=e+_;if(this._OriginalIsBoundary(f-1)||this._OriginalIsBoundary(f))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,_){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(_>0){const f=e+_;if(this._ModifiedIsBoundary(f-1)||this._ModifiedIsBoundary(f))return!0}return!1}_boundaryScore(e,_,f,b){const g=this._OriginalRegionIsBoundary(e,_)?1:0,C=this._ModifiedRegionIsBoundary(f,b)?1:0;return g+C}ConcatenateChanges(e,_){const f=[];if(e.length===0||_.length===0)return _.length>0?_:e;if(this.ChangesOverlap(e[e.length-1],_[0],f)){const b=new Array(e.length+_.length-1);return y.Copy(e,0,b,0,e.length-1),b[e.length-1]=f[0],y.Copy(_,1,b,e.length,_.length-1),b}else{const b=new Array(e.length+_.length);return y.Copy(e,0,b,0,e.length),y.Copy(_,0,b,e.length,_.length),b}}ChangesOverlap(e,_,f){if(S.Assert(e.originalStart<=_.originalStart,"Left change is not less than or equal to right change"),S.Assert(e.modifiedStart<=_.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=_.originalStart||e.modifiedStart+e.modifiedLength>=_.modifiedStart){const b=e.originalStart;let g=e.originalLength;const C=e.modifiedStart;let A=e.modifiedLength;return e.originalStart+e.originalLength>=_.originalStart&&(g=_.originalStart+_.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=_.modifiedStart&&(A=_.modifiedStart+_.modifiedLength-e.modifiedStart),f[0]=new E.DiffChange(b,g,C,A),!0}else return f[0]=null,!1}ClipDiagonalBound(e,_,f,b){if(e>=0&&e<b)return e;const g=f,C=b-f-1,A=_%2===0;if(e<0){const p=g%2===0;return A===p?0:1}else{const p=C%2===0;return A===p?b-1:b-2}}}n.LcsDiff=h}),Q(Y[17],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.withNullAsUndefined=n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isString=void 0;function E(A){return typeof A=="string"}n.isString=E;function M(A){return typeof A=="object"&&A!==null&&!Array.isArray(A)&&!(A instanceof RegExp)&&!(A instanceof Date)}n.isObject=M;function i(A){const p=Object.getPrototypeOf(Uint8Array);return typeof A=="object"&&A instanceof p}n.isTypedArray=i;function l(A){return typeof A=="number"&&!isNaN(A)}n.isNumber=l;function S(A){return!!A&&typeof A[Symbol.iterator]=="function"}n.isIterable=S;function y(A){return A===!0||A===!1}n.isBoolean=y;function c(A){return typeof A>"u"}n.isUndefined=c;function h(A){return!w(A)}n.isDefined=h;function w(A){return c(A)||A===null}n.isUndefinedOrNull=w;function e(A,p){if(!A)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}n.assertType=e;function _(A){if(w(A))throw new Error("Assertion Failed: argument is undefined or null");return A}n.assertIsDefined=_;function f(A){return typeof A=="function"}n.isFunction=f;function b(A,p){const d=Math.min(A.length,p.length);for(let m=0;m<d;m++)g(A[m],p[m])}n.validateConstraints=b;function g(A,p){if(E(p)){if(typeof A!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(f(p)){try{if(A instanceof p)return}catch{}if(!w(A)&&A.constructor===p||p.length===1&&p.call(void 0,A)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=g;function C(A){return A===null?void 0:A}n.withNullAsUndefined=C}),Q(Y[31],X([0,1,17]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.getCodiconFontCharacters=void 0;const M=Object.create(null);function i(S,y){if((0,E.isString)(y)){const c=M[y];if(c===void 0)throw new Error(`${S} references an unknown codicon: ${y}`);y=c}return M[S]=y,{id:S}}function l(){return M}n.getCodiconFontCharacters=l,n.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Q(Y[11],X([0,1,17]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function M(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const b=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([g,C])=>{b[g]=C&&typeof C=="object"?M(C):C}),b}n.deepClone=M;function i(f){if(!f||typeof f!="object")return f;const b=[f];for(;b.length>0;){const g=b.shift();Object.freeze(g);for(const C in g)if(l.call(g,C)){const A=g[C];typeof A=="object"&&!Object.isFrozen(A)&&!(0,E.isTypedArray)(A)&&b.push(A)}}return f}n.deepFreeze=i;const l=Object.prototype.hasOwnProperty;function S(f,b){return y(f,b,new Set)}n.cloneAndChange=S;function y(f,b,g){if((0,E.isUndefinedOrNull)(f))return f;const C=b(f);if(typeof C<"u")return C;if(Array.isArray(f)){const A=[];for(const p of f)A.push(y(p,b,g));return A}if((0,E.isObject)(f)){if(g.has(f))throw new Error("Cannot clone recursive data-structure");g.add(f);const A={};for(const p in f)l.call(f,p)&&(A[p]=y(f[p],b,g));return g.delete(f),A}return f}function c(f,b,g=!0){return(0,E.isObject)(f)?((0,E.isObject)(b)&&Object.keys(b).forEach(C=>{C in f?g&&((0,E.isObject)(f[C])&&(0,E.isObject)(b[C])?c(f[C],b[C],g):f[C]=b[C]):f[C]=b[C]}),f):b}n.mixin=c;function h(f,b){if(f===b)return!0;if(f==null||b===null||b===void 0||typeof f!=typeof b||typeof f!="object"||Array.isArray(f)!==Array.isArray(b))return!1;let g,C;if(Array.isArray(f)){if(f.length!==b.length)return!1;for(g=0;g<f.length;g++)if(!h(f[g],b[g]))return!1}else{const A=[];for(C in f)A.push(C);A.sort();const p=[];for(C in b)p.push(C);if(p.sort(),!h(A,p))return!1;for(g=0;g<A.length;g++)if(!h(f[A[g]],b[A[g]]))return!1}return!0}n.equals=h;function w(f){let b=[],g=Object.getPrototypeOf(f);for(;Object.prototype!==g;)b=b.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return b}n.getAllPropertyNames=w;function e(f){const b=[];for(const g of w(f))typeof f[g]=="function"&&b.push(g);return b}n.getAllMethodNames=e;function _(f,b){const g=A=>function(){const p=Array.prototype.slice.call(arguments,0);return b(A,p)},C={};for(const A of f)C[A]=g(A);return C}n.createProxyObject=_}),Q(Y[18],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function E(i){return i<0?0:i>255?255:i|0}n.toUint8=E;function M(i){return i<0?0:i>4294967295?4294967295:i|0}n.toUint32=M}),Q(Y[19],X([0,1,18]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class M{constructor(S){const y=(0,E.toUint8)(S);this._defaultValue=y,this._asciiMap=M._createAsciiMap(y),this._map=new Map}static _createAsciiMap(S){const y=new Uint8Array(256);return y.fill(S),y}set(S,y){const c=(0,E.toUint8)(y);S>=0&&S<256?this._asciiMap[S]=c:this._map.set(S,c)}get(S){return S>=0&&S<256?this._asciiMap[S]:this._map.get(S)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=M;class i{constructor(){this._actual=new M(0)}add(S){this._actual.set(S,1)}has(S){return this._actual.get(S)===1}clear(){return this._actual.clear()}}n.CharacterSet=i}),Q(Y[20],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=void 0;class E{constructor(i,l){this.startLineNumber=i,this.endLineNumberExclusive=l}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(i){return new E(this.startLineNumber+i,this.endLineNumberExclusive+i)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(i){return new E(Math.min(this.startLineNumber,i.startLineNumber),Math.max(this.endLineNumberExclusive,i.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}n.LineRange=E}),Q(Y[3],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class E{constructor(i,l){this.lineNumber=i,this.column=l}with(i=this.lineNumber,l=this.column){return i===this.lineNumber&&l===this.column?this:new E(i,l)}delta(i=0,l=0){return this.with(this.lineNumber+i,this.column+l)}equals(i){return E.equals(this,i)}static equals(i,l){return!i&&!l?!0:!!i&&!!l&&i.lineNumber===l.lineNumber&&i.column===l.column}isBefore(i){return E.isBefore(this,i)}static isBefore(i,l){return i.lineNumber<l.lineNumber?!0:l.lineNumber<i.lineNumber?!1:i.column<l.column}isBeforeOrEqual(i){return E.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,l){return i.lineNumber<l.lineNumber?!0:l.lineNumber<i.lineNumber?!1:i.column<=l.column}static compare(i,l){const S=i.lineNumber|0,y=l.lineNumber|0;if(S===y){const c=i.column|0,h=l.column|0;return c-h}return S-y}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new E(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}n.Position=E}),Q(Y[2],X([0,1,3]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class M{constructor(l,S,y,c){l>y||l===y&&S>c?(this.startLineNumber=y,this.startColumn=c,this.endLineNumber=l,this.endColumn=S):(this.startLineNumber=l,this.startColumn=S,this.endLineNumber=y,this.endColumn=c)}isEmpty(){return M.isEmpty(this)}static isEmpty(l){return l.startLineNumber===l.endLineNumber&&l.startColumn===l.endColumn}containsPosition(l){return M.containsPosition(this,l)}static containsPosition(l,S){return!(S.lineNumber<l.startLineNumber||S.lineNumber>l.endLineNumber||S.lineNumber===l.startLineNumber&&S.column<l.startColumn||S.lineNumber===l.endLineNumber&&S.column>l.endColumn)}static strictContainsPosition(l,S){return!(S.lineNumber<l.startLineNumber||S.lineNumber>l.endLineNumber||S.lineNumber===l.startLineNumber&&S.column<=l.startColumn||S.lineNumber===l.endLineNumber&&S.column>=l.endColumn)}containsRange(l){return M.containsRange(this,l)}static containsRange(l,S){return!(S.startLineNumber<l.startLineNumber||S.endLineNumber<l.startLineNumber||S.startLineNumber>l.endLineNumber||S.endLineNumber>l.endLineNumber||S.startLineNumber===l.startLineNumber&&S.startColumn<l.startColumn||S.endLineNumber===l.endLineNumber&&S.endColumn>l.endColumn)}strictContainsRange(l){return M.strictContainsRange(this,l)}static strictContainsRange(l,S){return!(S.startLineNumber<l.startLineNumber||S.endLineNumber<l.startLineNumber||S.startLineNumber>l.endLineNumber||S.endLineNumber>l.endLineNumber||S.startLineNumber===l.startLineNumber&&S.startColumn<=l.startColumn||S.endLineNumber===l.endLineNumber&&S.endColumn>=l.endColumn)}plusRange(l){return M.plusRange(this,l)}static plusRange(l,S){let y,c,h,w;return S.startLineNumber<l.startLineNumber?(y=S.startLineNumber,c=S.startColumn):S.startLineNumber===l.startLineNumber?(y=S.startLineNumber,c=Math.min(S.startColumn,l.startColumn)):(y=l.startLineNumber,c=l.startColumn),S.endLineNumber>l.endLineNumber?(h=S.endLineNumber,w=S.endColumn):S.endLineNumber===l.endLineNumber?(h=S.endLineNumber,w=Math.max(S.endColumn,l.endColumn)):(h=l.endLineNumber,w=l.endColumn),new M(y,c,h,w)}intersectRanges(l){return M.intersectRanges(this,l)}static intersectRanges(l,S){let y=l.startLineNumber,c=l.startColumn,h=l.endLineNumber,w=l.endColumn;const e=S.startLineNumber,_=S.startColumn,f=S.endLineNumber,b=S.endColumn;return y<e?(y=e,c=_):y===e&&(c=Math.max(c,_)),h>f?(h=f,w=b):h===f&&(w=Math.min(w,b)),y>h||y===h&&c>w?null:new M(y,c,h,w)}equalsRange(l){return M.equalsRange(this,l)}static equalsRange(l,S){return!l&&!S?!0:!!l&&!!S&&l.startLineNumber===S.startLineNumber&&l.startColumn===S.startColumn&&l.endLineNumber===S.endLineNumber&&l.endColumn===S.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(l){return new E.Position(l.endLineNumber,l.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(l){return new E.Position(l.startLineNumber,l.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(l,S){return new M(this.startLineNumber,this.startColumn,l,S)}setStartPosition(l,S){return new M(l,S,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(l){return new M(l.startLineNumber,l.startColumn,l.startLineNumber,l.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(l){return new M(l.endLineNumber,l.endColumn,l.endLineNumber,l.endColumn)}delta(l){return new M(this.startLineNumber+l,this.startColumn,this.endLineNumber+l,this.endColumn)}static fromPositions(l,S=l){return new M(l.lineNumber,l.column,S.lineNumber,S.column)}static lift(l){return l?new M(l.startLineNumber,l.startColumn,l.endLineNumber,l.endColumn):null}static isIRange(l){return l&&typeof l.startLineNumber=="number"&&typeof l.startColumn=="number"&&typeof l.endLineNumber=="number"&&typeof l.endColumn=="number"}static areIntersectingOrTouching(l,S){return!(l.endLineNumber<S.startLineNumber||l.endLineNumber===S.startLineNumber&&l.endColumn<S.startColumn||S.endLineNumber<l.startLineNumber||S.endLineNumber===l.startLineNumber&&S.endColumn<l.startColumn)}static areIntersecting(l,S){return!(l.endLineNumber<S.startLineNumber||l.endLineNumber===S.startLineNumber&&l.endColumn<=S.startColumn||S.endLineNumber<l.startLineNumber||S.endLineNumber===l.startLineNumber&&S.endColumn<=l.startColumn)}static compareRangesUsingStarts(l,S){if(l&&S){const h=l.startLineNumber|0,w=S.startLineNumber|0;if(h===w){const e=l.startColumn|0,_=S.startColumn|0;if(e===_){const f=l.endLineNumber|0,b=S.endLineNumber|0;if(f===b){const g=l.endColumn|0,C=S.endColumn|0;return g-C}return f-b}return e-_}return h-w}return(l?1:0)-(S?1:0)}static compareRangesUsingEnds(l,S){return l.endLineNumber===S.endLineNumber?l.endColumn===S.endColumn?l.startLineNumber===S.startLineNumber?l.startColumn-S.startColumn:l.startLineNumber-S.startLineNumber:l.endColumn-S.endColumn:l.endLineNumber-S.endLineNumber}static spansMultipleLines(l){return l.endLineNumber>l.startLineNumber}toJSON(){return this}}n.Range=M}),Q(Y[32],X([0,1,3,2]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class i extends M.Range{constructor(S,y,c,h){super(S,y,c,h),this.selectionStartLineNumber=S,this.selectionStartColumn=y,this.positionLineNumber=c,this.positionColumn=h}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(S){return i.selectionsEqual(this,S)}static selectionsEqual(S,y){return S.selectionStartLineNumber===y.selectionStartLineNumber&&S.selectionStartColumn===y.selectionStartColumn&&S.positionLineNumber===y.positionLineNumber&&S.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(S,y){return this.getDirection()===0?new i(this.startLineNumber,this.startColumn,S,y):new i(S,y,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new E.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(S,y){return this.getDirection()===0?new i(S,y,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,S,y)}static fromPositions(S,y=S){return new i(S.lineNumber,S.column,y.lineNumber,y.column)}static fromRange(S,y){return y===0?new i(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):new i(S.endLineNumber,S.endColumn,S.startLineNumber,S.startColumn)}static liftSelection(S){return new i(S.selectionStartLineNumber,S.selectionStartColumn,S.positionLineNumber,S.positionColumn)}static selectionsArrEqual(S,y){if(S&&!y||!S&&y)return!1;if(!S&&!y)return!0;if(S.length!==y.length)return!1;for(let c=0,h=S.length;c<h;c++)if(!this.selectionsEqual(S[c],y[c]))return!1;return!0}static isISelection(S){return S&&typeof S.selectionStartLineNumber=="number"&&typeof S.selectionStartColumn=="number"&&typeof S.positionLineNumber=="number"&&typeof S.positionColumn=="number"}static createWithDirection(S,y,c,h,w){return w===0?new i(S,y,c,h):new i(c,h,S,y)}}n.Selection=i}),Q(Y[33],X([0,1,19]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class M extends E.CharacterClassifier{constructor(S){super(0);for(let y=0,c=S.length;y<c;y++)this.set(S.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=M;function i(l){const S={};return y=>(S.hasOwnProperty(y)||(S[y]=l(y)),S[y])}n.getMapForWordSeparators=i(l=>new M(l))}),Q(Y[21],X([0,1,14,15]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function i(h=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)h.indexOf(e)>=0||(w+="\\"+e);return w+="\\s]+)",new RegExp(w,"g")}n.DEFAULT_WORD_REGEXP=i();function l(h){let w=n.DEFAULT_WORD_REGEXP;if(h&&h instanceof RegExp)if(h.global)w=h;else{let e="g";h.ignoreCase&&(e+="i"),h.multiline&&(e+="m"),h.unicode&&(e+="u"),w=new RegExp(h.source,e)}return w.lastIndex=0,w}n.ensureValidWordDefinition=l;const S=new M.LinkedList;S.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(h,w,e,_,f){if(f||(f=E.Iterable.first(S)),e.length>f.maxLen){let p=h-f.maxLen/2;return p<0?p=0:_+=p,e=e.substring(p,h+f.maxLen/2),y(h,w,e,_,f)}const b=Date.now(),g=h-1-_;let C=-1,A=null;for(let p=1;!(Date.now()-b>=f.timeBudget);p++){const d=g-f.windowSize*p;w.lastIndex=Math.max(0,d);const m=c(w,e,g,C);if(!m&&A||(A=m,d<=0))break;C=d}if(A){const p={word:A[0],startColumn:_+1+A.index,endColumn:_+1+A.index+A[0].length};return w.lastIndex=0,p}return null}n.getWordAtText=y;function c(h,w,e,_){let f;for(;f=h.exec(w);){const b=f.index||0;if(b<=e&&h.lastIndex>=e)return f;if(_>0&&b>_)return null}return null}}),Q(Y[5],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRange=n.SequenceDiff=void 0;class E{constructor(l,S){this.seq1Range=l,this.seq2Range=S}reverse(){return new E(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}n.SequenceDiff=E;class M{constructor(l,S){this.start=l,this.endExclusive=S}get isEmpty(){return this.start===this.endExclusive}delta(l){return new M(this.start+l,this.endExclusive+l)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(l){return new M(Math.min(this.start,l.start),Math.max(this.endExclusive,l.endExclusive))}}n.OffsetRange=M}),Q(Y[34],X([0,1,5]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.smoothenSequenceDiffs=n.optimizeSequenceDiffs=void 0;function M(c,h,w){let e=w;return e=l(c,h,e),e=S(c,h,e),e}n.optimizeSequenceDiffs=M;function i(c,h,w){const e=[];for(const _ of w){const f=e[e.length-1];if(!f){e.push(_);continue}_.seq1Range.start-f.seq1Range.endExclusive<=2||_.seq2Range.start-f.seq2Range.endExclusive<=2?e[e.length-1]=new E.SequenceDiff(f.seq1Range.join(_.seq1Range),f.seq2Range.join(_.seq2Range)):e.push(_)}return e}n.smoothenSequenceDiffs=i;function l(c,h,w){const e=[];w.length>0&&e.push(w[0]);for(let _=1;_<w.length;_++){const f=e[e.length-1],b=w[_];if(b.seq1Range.isEmpty){let g=!0;const C=b.seq1Range.start-f.seq1Range.endExclusive;for(let A=1;A<=C;A++)if(h.getElement(b.seq2Range.start-A)!==h.getElement(b.seq2Range.endExclusive-A)){g=!1;break}if(g){e[e.length-1]=new E.SequenceDiff(f.seq1Range,new E.OffsetRange(f.seq2Range.start,b.seq2Range.endExclusive-C));continue}}e.push(b)}return e}n.joinSequenceDiffs=l;function S(c,h,w){if(!c.getBoundaryScore||!h.getBoundaryScore)return w;for(let e=0;e<w.length;e++){const _=w[e];if(_.seq1Range.isEmpty){const f=e>0?w[e-1].seq2Range.endExclusive:-1,b=e+1<w.length?w[e+1].seq2Range.start:h.length;w[e]=y(_,c,h,b,f)}else if(_.seq2Range.isEmpty){const f=e>0?w[e-1].seq1Range.endExclusive:-1,b=e+1<w.length?w[e+1].seq1Range.start:c.length;w[e]=y(_.reverse(),h,c,b,f).reverse()}}return w}n.shiftSequenceDiffs=S;function y(c,h,w,e,_){let b=1;for(;c.seq2Range.start-b>_&&w.getElement(c.seq2Range.start-b)===w.getElement(c.seq2Range.endExclusive-b)&&b<20;)b++;b--;let g=0;for(;c.seq2Range.start+g<e&&w.getElement(c.seq2Range.start+g)===w.getElement(c.seq2Range.endExclusive+g)&&g<20;)g++;if(b===0&&g===0)return c;let C=0,A=-1;for(let p=-b;p<=g;p++){const d=c.seq2Range.start+p,m=c.seq2Range.endExclusive+p,v=c.seq1Range.start+p,r=h.getBoundaryScore(v)+w.getBoundaryScore(d)+w.getBoundaryScore(m);r>A&&(A=r,C=p)}return C!==0?new E.SequenceDiff(c.seq1Range.delta(C),c.seq2Range.delta(C)):c}}),Q(Y[35],X([0,1,5]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class M{compute(c,h){if(c.length===0)return[new E.SequenceDiff(new E.OffsetRange(0,0),new E.OffsetRange(0,h.length))];if(h.length===0)return[new E.SequenceDiff(new E.OffsetRange(0,c.length),new E.OffsetRange(0,0))];function w(d,m){for(;d<c.length&&m<h.length&&c.getElement(d)===h.getElement(m);)d++,m++;return d}let e=0;const _=new l;_.set(0,w(0,0));const f=new S;f.set(0,_.get(0)===0?null:new i(null,0,0,_.get(0)));let b=0;e:for(;;)for(e++,b=-e;b<=e;b+=2){const d=b===e?-1:_.get(b+1),m=b===-e?-1:_.get(b-1)+1,v=Math.min(Math.max(d,m),c.length),r=v-b,o=w(v,r);_.set(b,o);const s=v===d?f.get(b+1):f.get(b-1);if(f.set(b,o!==v?new i(s,v,r,o-v):s),_.get(b)===c.length&&_.get(b)-b===h.length)break e}let g=f.get(b);const C=[];let A=c.length,p=h.length;for(;;){const d=g?g.x+g.length:0,m=g?g.y+g.length:0;if((d!==A||m!==p)&&C.push(new E.SequenceDiff(new E.OffsetRange(d,A),new E.OffsetRange(m,p))),!g)break;A=g.x,p=g.y,g=g.prev}return C.reverse(),C}}n.MyersDiffAlgorithm=M;class i{constructor(c,h,w,e){this.prev=c,this.x=h,this.y=w,this.length=e}}class l{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(c){return c<0?(c=-c-1,this.negativeArr[c]):this.positiveArr[c]}set(c,h){if(c<0){if(c=-c-1,c>=this.negativeArr.length){const w=this.negativeArr;this.negativeArr=new Int32Array(w.length*2),this.negativeArr.set(w)}this.negativeArr[c]=h}else{if(c>=this.positiveArr.length){const w=this.positiveArr;this.positiveArr=new Int32Array(w.length*2),this.positiveArr.set(w)}this.positiveArr[c]=h}}}class S{constructor(){this.positiveArr=[],this.negativeArr=[]}get(c){return c<0?(c=-c-1,this.negativeArr[c]):this.positiveArr[c]}set(c,h){c<0?(c=-c-1,this.negativeArr[c]=h):this.positiveArr[c]=h}}}),Q(Y[36],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class E{constructor(i,l){this.width=i,this.height=l,this.array=[],this.array=new Array(i*l)}get(i,l){return this.array[i+l*this.width]}set(i,l,S){this.array[i+l*this.width]=S}}n.Array2D=E}),Q(Y[37],X([0,1,5,36]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class i{compute(S,y,c){const h=new M.Array2D(S.length,y.length),w=new M.Array2D(S.length,y.length),e=new M.Array2D(S.length,y.length);for(let p=0;p<S.length;p++)for(let d=0;d<y.length;d++){const m=p===0?0:h.get(p-1,d),v=d===0?0:h.get(p,d-1);let r;S.getElement(p)===y.getElement(d)?(p===0||d===0?r=0:r=h.get(p-1,d-1),p>0&&d>0&&w.get(p-1,d-1)===3&&(r+=e.get(p-1,d-1)),r+=c?c(p,d):1):r=-1;const o=Math.max(m,v,r);if(o===r){const s=p>0&&d>0?e.get(p-1,d-1):0;e.set(p,d,s+1),w.set(p,d,3)}else o===m?(e.set(p,d,0),w.set(p,d,1)):o===v&&(e.set(p,d,0),w.set(p,d,2));h.set(p,d,o)}const _=[];let f=S.length,b=y.length;function g(p,d){(p+1!==f||d+1!==b)&&_.push(new E.SequenceDiff(new E.OffsetRange(p+1,f),new E.OffsetRange(d+1,b))),f=p,b=d}let C=S.length-1,A=y.length-1;for(;C>=0&&A>=0;)w.get(C,A)===3?(g(C,A),C--,A--):w.get(C,A)===1?C--:A--;return g(-1,-1),_.reverse(),_}}n.DynamicProgrammingDiffing=i}),Q(Y[22],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.RangeMapping=n.LineRangeMapping=void 0;class E{constructor(l,S,y){this.originalRange=l,this.modifiedRange=S,this.innerChanges=y}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.LineRangeMapping=E;class M{constructor(l,S){this.originalRange=l,this.modifiedRange=S}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}}n.RangeMapping=M}),Q(Y[38],X([0,1,16,22,4,2,9,20]),function(O,n,E,M,i,l,S,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const c=3;class h{computeDiff(v,r,o){var s;const u=new C(v,r,{maxComputationTime:o.maxComputationTimeMs,shouldIgnoreTrimWhitespace:o.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),L=[];let R=null;for(const N of u.changes){let D;N.originalEndLineNumber===0?D=new y.LineRange(N.originalStartLineNumber+1,N.originalStartLineNumber+1):D=new y.LineRange(N.originalStartLineNumber,N.originalEndLineNumber+1);let U;N.modifiedEndLineNumber===0?U=new y.LineRange(N.modifiedStartLineNumber+1,N.modifiedStartLineNumber+1):U=new y.LineRange(N.modifiedStartLineNumber,N.modifiedEndLineNumber+1);let B=new M.LineRangeMapping(D,U,(s=N.charChanges)===null||s===void 0?void 0:s.map(T=>new M.RangeMapping(new l.Range(T.originalStartLineNumber,T.originalStartColumn,T.originalEndLineNumber,T.originalEndColumn),new l.Range(T.modifiedStartLineNumber,T.modifiedStartColumn,T.modifiedEndLineNumber,T.modifiedEndColumn))));R&&(R.modifiedRange.endLineNumberExclusive===B.modifiedRange.startLineNumber||R.originalRange.endLineNumberExclusive===B.originalRange.startLineNumber)&&(B=new M.LineRangeMapping(R.originalRange.join(B.originalRange),R.modifiedRange.join(B.modifiedRange),R.innerChanges&&B.innerChanges?R.innerChanges.concat(B.innerChanges):void 0),L.pop()),L.push(B),R=B}return(0,S.assertFn)(()=>(0,S.checkAdjacentItems)(L,(N,D)=>D.originalRange.startLineNumber-N.originalRange.endLineNumberExclusive===D.modifiedRange.startLineNumber-N.modifiedRange.endLineNumberExclusive&&N.originalRange.endLineNumberExclusive<D.originalRange.startLineNumber&&N.modifiedRange.endLineNumberExclusive<D.modifiedRange.startLineNumber)),{quitEarly:u.quitEarly,changes:L}}}n.SmartLinesDiffComputer=h;function w(m,v,r,o){return new E.LcsDiff(m,v,r).ComputeDiff(o)}class e{constructor(v){const r=[],o=[];for(let s=0,a=v.length;s<a;s++)r[s]=A(v[s],1),o[s]=p(v[s],1);this.lines=v,this._startColumns=r,this._endColumns=o}getElements(){const v=[];for(let r=0,o=this.lines.length;r<o;r++)v[r]=this.lines[r].substring(this._startColumns[r]-1,this._endColumns[r]-1);return v}getStrictElement(v){return this.lines[v]}getStartLineNumber(v){return v+1}getEndLineNumber(v){return v+1}createCharSequence(v,r,o){const s=[],a=[],u=[];let L=0;for(let R=r;R<=o;R++){const N=this.lines[R],D=v?this._startColumns[R]:1,U=v?this._endColumns[R]:N.length+1;for(let B=D;B<U;B++)s[L]=N.charCodeAt(B-1),a[L]=R+1,u[L]=B,L++;!v&&R<o&&(s[L]=10,a[L]=R+1,u[L]=N.length+1,L++)}return new _(s,a,u)}}class _{constructor(v,r,o){this._charCodes=v,this._lineNumbers=r,this._columns=o}toString(){return"["+this._charCodes.map((v,r)=>(v===10?"\\n":String.fromCharCode(v))+`-(${this._lineNumbers[r]},${this._columns[r]})`).join(", ")+"]"}_assertIndex(v,r){if(v<0||v>=r.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(v){return v>0&&v===this._lineNumbers.length?this.getEndLineNumber(v-1):(this._assertIndex(v,this._lineNumbers),this._lineNumbers[v])}getEndLineNumber(v){return v===-1?this.getStartLineNumber(v+1):(this._assertIndex(v,this._lineNumbers),this._charCodes[v]===10?this._lineNumbers[v]+1:this._lineNumbers[v])}getStartColumn(v){return v>0&&v===this._columns.length?this.getEndColumn(v-1):(this._assertIndex(v,this._columns),this._columns[v])}getEndColumn(v){return v===-1?this.getStartColumn(v+1):(this._assertIndex(v,this._columns),this._charCodes[v]===10?1:this._columns[v]+1)}}class f{constructor(v,r,o,s,a,u,L,R){this.originalStartLineNumber=v,this.originalStartColumn=r,this.originalEndLineNumber=o,this.originalEndColumn=s,this.modifiedStartLineNumber=a,this.modifiedStartColumn=u,this.modifiedEndLineNumber=L,this.modifiedEndColumn=R}static createFromDiffChange(v,r,o){const s=r.getStartLineNumber(v.originalStart),a=r.getStartColumn(v.originalStart),u=r.getEndLineNumber(v.originalStart+v.originalLength-1),L=r.getEndColumn(v.originalStart+v.originalLength-1),R=o.getStartLineNumber(v.modifiedStart),N=o.getStartColumn(v.modifiedStart),D=o.getEndLineNumber(v.modifiedStart+v.modifiedLength-1),U=o.getEndColumn(v.modifiedStart+v.modifiedLength-1);return new f(s,a,u,L,R,N,D,U)}}function b(m){if(m.length<=1)return m;const v=[m[0]];let r=v[0];for(let o=1,s=m.length;o<s;o++){const a=m[o],u=a.originalStart-(r.originalStart+r.originalLength),L=a.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(u,L)<c?(r.originalLength=a.originalStart+a.originalLength-r.originalStart,r.modifiedLength=a.modifiedStart+a.modifiedLength-r.modifiedStart):(v.push(a),r=a)}return v}class g{constructor(v,r,o,s,a){this.originalStartLineNumber=v,this.originalEndLineNumber=r,this.modifiedStartLineNumber=o,this.modifiedEndLineNumber=s,this.charChanges=a}static createFromDiffResult(v,r,o,s,a,u,L){let R,N,D,U,B;if(r.originalLength===0?(R=o.getStartLineNumber(r.originalStart)-1,N=0):(R=o.getStartLineNumber(r.originalStart),N=o.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(D=s.getStartLineNumber(r.modifiedStart)-1,U=0):(D=s.getStartLineNumber(r.modifiedStart),U=s.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),u&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&a()){const T=o.createCharSequence(v,r.originalStart,r.originalStart+r.originalLength-1),q=s.createCharSequence(v,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(T.getElements().length>0&&q.getElements().length>0){let H=w(T,q,a,!0).changes;L&&(H=b(H)),B=[];for(let I=0,F=H.length;I<F;I++)B.push(f.createFromDiffChange(H[I],T,q))}}return new g(R,N,D,U,B)}}class C{constructor(v,r,o){this.shouldComputeCharChanges=o.shouldComputeCharChanges,this.shouldPostProcessCharChanges=o.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=o.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=o.shouldMakePrettyDiff,this.originalLines=v,this.modifiedLines=r,this.original=new e(v),this.modified=new e(r),this.continueLineDiff=d(o.maxComputationTime),this.continueCharDiff=d(o.maxComputationTime===0?0:Math.min(o.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const v=w(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),r=v.changes,o=v.quitEarly;if(this.shouldIgnoreTrimWhitespace){const L=[];for(let R=0,N=r.length;R<N;R++)L.push(g.createFromDiffResult(this.shouldIgnoreTrimWhitespace,r[R],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:o,changes:L}}const s=[];let a=0,u=0;for(let L=-1,R=r.length;L<R;L++){const N=L+1<R?r[L+1]:null,D=N?N.originalStart:this.originalLines.length,U=N?N.modifiedStart:this.modifiedLines.length;for(;a<D&&u<U;){const B=this.originalLines[a],T=this.modifiedLines[u];if(B!==T){{let q=A(B,1),H=A(T,1);for(;q>1&&H>1;){const I=B.charCodeAt(q-2),F=T.charCodeAt(H-2);if(I!==F)break;q--,H--}(q>1||H>1)&&this._pushTrimWhitespaceCharChange(s,a+1,1,q,u+1,1,H)}{let q=p(B,1),H=p(T,1);const I=B.length+1,F=T.length+1;for(;q<I&&H<F;){const k=B.charCodeAt(q-1),V=B.charCodeAt(H-1);if(k!==V)break;q++,H++}(q<I||H<F)&&this._pushTrimWhitespaceCharChange(s,a+1,q,I,u+1,H,F)}}a++,u++}N&&(s.push(g.createFromDiffResult(this.shouldIgnoreTrimWhitespace,N,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),a+=N.originalLength,u+=N.modifiedLength)}return{quitEarly:o,changes:s}}_pushTrimWhitespaceCharChange(v,r,o,s,a,u,L){if(this._mergeTrimWhitespaceCharChange(v,r,o,s,a,u,L))return;let R;this.shouldComputeCharChanges&&(R=[new f(r,o,r,s,a,u,a,L)]),v.push(new g(r,r,a,a,R))}_mergeTrimWhitespaceCharChange(v,r,o,s,a,u,L){const R=v.length;if(R===0)return!1;const N=v[R-1];return N.originalEndLineNumber===0||N.modifiedEndLineNumber===0?!1:N.originalEndLineNumber===r&&N.modifiedEndLineNumber===a?(this.shouldComputeCharChanges&&N.charChanges&&N.charChanges.push(new f(r,o,r,s,a,u,a,L)),!0):N.originalEndLineNumber+1===r&&N.modifiedEndLineNumber+1===a?(N.originalEndLineNumber=r,N.modifiedEndLineNumber=a,this.shouldComputeCharChanges&&N.charChanges&&N.charChanges.push(new f(r,o,r,s,a,u,a,L)),!0):!1}}n.DiffComputer=C;function A(m,v){const r=i.firstNonWhitespaceIndex(m);return r===-1?v:r+1}function p(m,v){const r=i.lastNonWhitespaceIndex(m);return r===-1?v:r+2}function d(m){if(m===0)return()=>!0;const v=Date.now();return()=>Date.now()-v<m}}),Q(Y[39],X([0,1,9,20,3,2,5,37,34,35,22]),function(O,n,E,M,i,l,S,y,c,h,w){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineSequence=n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class e{constructor(){this.dynamicProgrammingDiffing=new y.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new h.MyersDiffAlgorithm}computeDiff(r,o,s){const a=new Map;function u(F){let k=a.get(F);return k===void 0&&(k=a.size,a.set(F,k)),k}const L=r.map(F=>u(F.trim())),R=o.map(F=>u(F.trim())),N=new b(L,r),D=new b(R,o);let U=(()=>N.length+D.length<1500?this.dynamicProgrammingDiffing.compute(N,D,(F,k)=>r[F]===o[k]?o[k].length===0?.1:1+Math.log(1+o[k].length):.99):this.myersDiffingAlgorithm.compute(N,D))();U=(0,c.optimizeSequenceDiffs)(N,D,U);const B=[],T=F=>{for(let k=0;k<F;k++){const V=q+k,t=H+k;if(r[V]!==o[t]){const ne=this.refineDiff(r,o,new S.SequenceDiff(new S.OffsetRange(V,V+1),new S.OffsetRange(t,t+1)));for(const oe of ne)B.push(oe)}}};let q=0,H=0;for(const F of U){(0,E.assertFn)(()=>F.seq1Range.start-q===F.seq2Range.start-H);const k=F.seq1Range.start-q;T(k),q=F.seq1Range.endExclusive,H=F.seq2Range.endExclusive;const V=this.refineDiff(r,o,F);for(const t of V)B.push(t)}T(r.length-q);const I=_(B);return{quitEarly:!1,changes:I}}refineDiff(r,o,s){const a=new C(r,s.seq1Range),u=new C(o,s.seq2Range),L=a.length+u.length<500?this.dynamicProgrammingDiffing.compute(a,u):this.myersDiffingAlgorithm.compute(a,u);let R=(0,c.optimizeSequenceDiffs)(a,u,L);return R=(0,c.smoothenSequenceDiffs)(a,u,R),R.map(D=>new w.RangeMapping(a.translateRange(D.seq1Range).delta(s.seq1Range.start),u.translateRange(D.seq2Range).delta(s.seq2Range.start)))}}n.StandardLinesDiffComputer=e;function _(v){const r=[];for(const o of f(v,(s,a)=>a.originalRange.startLineNumber-(s.originalRange.endLineNumber-(s.originalRange.endColumn>1?0:1))<=1||a.modifiedRange.startLineNumber-(s.modifiedRange.endLineNumber-(s.modifiedRange.endColumn>1?0:1))<=1)){const s=o[0],a=o[o.length-1];r.push(new w.LineRangeMapping(new M.LineRange(s.originalRange.startLineNumber,a.originalRange.endLineNumber+(a.originalRange.endColumn>1||a.modifiedRange.endColumn>1?1:0)),new M.LineRange(s.modifiedRange.startLineNumber,a.modifiedRange.endLineNumber+(a.originalRange.endColumn>1||a.modifiedRange.endColumn>1?1:0)),o))}return(0,E.assertFn)(()=>(0,E.checkAdjacentItems)(r,(o,s)=>s.originalRange.startLineNumber-o.originalRange.endLineNumberExclusive===s.modifiedRange.startLineNumber-o.modifiedRange.endLineNumberExclusive&&o.originalRange.endLineNumberExclusive<s.originalRange.startLineNumber&&o.modifiedRange.endLineNumberExclusive<s.modifiedRange.startLineNumber)),r}n.lineRangeMappingFromRangeMappings=_;function*f(v,r){let o,s;for(const a of v)s!==void 0&&r(s,a)?o.push(a):(o&&(yield o),o=[a]),s=a;o&&(yield o)}class b{constructor(r,o){this.trimmedHash=r,this.lines=o}getElement(r){return this.trimmedHash[r]}get length(){return this.trimmedHash.length}getBoundaryScore(r){const o=r===0?0:g(this.lines[r-1]),s=r===this.lines.length?0:g(this.lines[r]);return 1e3-(o+s)}}n.LineSequence=b;function g(v){let r=0;for(;r<v.length&&(v.charCodeAt(r)===32||v.charCodeAt(r)===9);)r++;return r}class C{constructor(r,o){this.lines=r,this.lineRange=o;let s=0;this.firstCharOnLineOffsets=new Int32Array(o.length);for(let u=o.start;u<o.endExclusive;u++)s+=r[u].length,this.firstCharOnLineOffsets[u-o.start]=s+1,s++;this.elements=new Int32Array(s);let a=0;for(let u=o.start;u<o.endExclusive;u++){const L=r[u];for(let R=0;R<L.length;R++)this.elements[a+R]=L.charCodeAt(R);a+=L.length,u<r.length-1&&(this.elements[a]=`
`.charCodeAt(0),a+=1)}}getElement(r){return this.elements[r]}get length(){return this.elements.length}getBoundaryScore(r){const o=d(r>0?this.elements[r-1]:-1),s=d(r<this.elements.length?this.elements[r]:-1);if(o===6&&s===7)return 0;let a=0;return o!==s&&(a+=10,s===1&&(a+=1)),a+=p(o),a+=p(s),a}translateOffset(r){let o=0,s=this.firstCharOnLineOffsets.length;for(;o<s;){const u=Math.floor((o+s)/2);this.firstCharOnLineOffsets[u]>r?s=u:o=u+1}const a=o===0?0:this.firstCharOnLineOffsets[o-1];return new i.Position(o+1,r-a+1)}translateRange(r){return l.Range.fromPositions(this.translateOffset(r.start),this.translateOffset(r.endExclusive))}}const A={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function p(v){return A[v]}function d(v){return v===10?7:v===13?6:m(v)?5:v>=97&&v<=122?0:v>=65&&v<=90?1:v>=48&&v<=57?2:v===-1?3:4}function m(v){return v===32||v===9}}),Q(Y[40],X([0,1,38,39]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={smart:new E.SmartLinesDiffComputer,experimental:new M.StandardLinesDiffComputer}}),Q(Y[41],X([0,1,19]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=void 0;class M{constructor(_,f,b){const g=new Uint8Array(_*f);for(let C=0,A=_*f;C<A;C++)g[C]=b;this._data=g,this.rows=_,this.cols=f}get(_,f){return this._data[_*this.cols+f]}set(_,f,b){this._data[_*this.cols+f]=b}}class i{constructor(_){let f=0,b=0;for(let C=0,A=_.length;C<A;C++){const[p,d,m]=_[C];d>f&&(f=d),p>b&&(b=p),m>b&&(b=m)}f++,b++;const g=new M(b,f,0);for(let C=0,A=_.length;C<A;C++){const[p,d,m]=_[C];g.set(p,d,m)}this._states=g,this._maxCharCode=f}nextState(_,f){return f<0||f>=this._maxCharCode?0:this._states.get(_,f)}}n.StateMachine=i;let l=null;function S(){return l===null&&(l=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),l}let y=null;function c(){if(y===null){y=new E.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<e.length;f++)y.set(e.charCodeAt(f),1);const _=".,;:";for(let f=0;f<_.length;f++)y.set(_.charCodeAt(f),2)}return y}class h{static _createLink(_,f,b,g,C){let A=C-1;do{const p=f.charCodeAt(A);if(_.get(p)!==2)break;A--}while(A>g);if(g>0){const p=f.charCodeAt(g-1),d=f.charCodeAt(A);(p===40&&d===41||p===91&&d===93||p===123&&d===125)&&A--}return{range:{startLineNumber:b,startColumn:g+1,endLineNumber:b,endColumn:A+2},url:f.substring(g,A+1)}}static computeLinks(_,f=S()){const b=c(),g=[];for(let C=1,A=_.getLineCount();C<=A;C++){const p=_.getLineContent(C),d=p.length;let m=0,v=0,r=0,o=1,s=!1,a=!1,u=!1,L=!1;for(;m<d;){let R=!1;const N=p.charCodeAt(m);if(o===13){let D;switch(N){case 40:s=!0,D=0;break;case 41:D=s?0:1;break;case 91:u=!0,a=!0,D=0;break;case 93:u=!1,D=a?0:1;break;case 123:L=!0,D=0;break;case 125:D=L?0:1;break;case 39:case 34:case 96:r===N?D=1:r===39||r===34||r===96?D=0:D=1;break;case 42:D=r===42?1:0;break;case 124:D=r===124?1:0;break;case 32:D=u?0:1;break;default:D=b.get(N)}D===1&&(g.push(h._createLink(b,p,C,v,m)),R=!0)}else if(o===12){let D;N===91?(a=!0,D=0):D=b.get(N),D===1?R=!0:o=13}else o=f.nextState(o,N),o===0&&(R=!0);R&&(o=1,s=!1,a=!1,L=!1,v=m+1,r=N),m++}o===13&&g.push(h._createLink(b,p,C,v,d))}return g}}n.LinkComputer=h;function w(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:h.computeLinks(e)}n.computeLinks=w}),Q(Y[42],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class E{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,l,S,y,c){if(i&&l){const h=this.doNavigateValueSet(l,c);if(h)return{range:i,value:h}}if(S&&y){const h=this.doNavigateValueSet(y,c);if(h)return{range:S,value:h}}return null}doNavigateValueSet(i,l){const S=this.numberReplace(i,l);return S!==null?S:this.textReplace(i,l)}numberReplace(i,l){const S=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let y=Number(i);const c=parseFloat(i);return!isNaN(y)&&!isNaN(c)&&y===c?y===0&&!l?null:(y=Math.floor(y*S),y+=l?S:-S,String(y/S)):null}textReplace(i,l){return this.valueSetsReplace(this._defaultValueSet,i,l)}valueSetsReplace(i,l,S){let y=null;for(let c=0,h=i.length;y===null&&c<h;c++)y=this.valueSetReplace(i[c],l,S);return y}valueSetReplace(i,l,S){let y=i.indexOf(l);return y>=0?(y+=S?1:-1,y<0?y=i.length-1:y%=i.length,i[y]):null}}E.INSTANCE=new E,n.BasicInplaceReplace=E}),Q(Y[43],X([0,1,11]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.isITextSnapshot=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.OverviewRulerLane=void 0;var M;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(M=n.OverviewRulerLane||(n.OverviewRulerLane={}));var i;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(i=n.MinimapPosition||(n.MinimapPosition={}));var l;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(l=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));class S{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(b){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,b.tabSize|0),b.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,b.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=Boolean(b.insertSpaces),this.defaultEOL=b.defaultEOL|0,this.trimAutoWhitespace=Boolean(b.trimAutoWhitespace),this.bracketPairColorizationOptions=b.bracketPairColorizationOptions}equals(b){return this.tabSize===b.tabSize&&this._indentSizeIsTabSize===b._indentSizeIsTabSize&&this.indentSize===b.indentSize&&this.insertSpaces===b.insertSpaces&&this.defaultEOL===b.defaultEOL&&this.trimAutoWhitespace===b.trimAutoWhitespace&&(0,E.equals)(this.bracketPairColorizationOptions,b.bracketPairColorizationOptions)}createChangeEvent(b){return{tabSize:this.tabSize!==b.tabSize,indentSize:this.indentSize!==b.indentSize,insertSpaces:this.insertSpaces!==b.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==b.trimAutoWhitespace}}}n.TextModelResolvedOptions=S;class y{constructor(b,g){this._findMatchBrand=void 0,this.range=b,this.matches=g}}n.FindMatch=y;function c(f){return f&&typeof f.read=="function"}n.isITextSnapshot=c;class h{constructor(b,g,C,A,p,d){this.identifier=b,this.range=g,this.text=C,this.forceMoveMarkers=A,this.isAutoWhitespaceEdit=p,this._isTracked=d}}n.ValidAnnotatedEditOperation=h;class w{constructor(b,g,C){this.regex=b,this.wordSeparators=g,this.simpleSearch=C}}n.SearchData=w;class e{constructor(b,g,C){this.reverseEdits=b,this.changes=g,this.trimAutoWhitespaceLineNumbers=C}}n.ApplyEditsResult=e;function _(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}n.shouldSynchronizeModel=_}),Q(Y[44],X([0,1,25,18]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class i{constructor(c){this.values=c,this.prefixSum=new Uint32Array(c.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(c,h){c=(0,M.toUint32)(c);const w=this.values,e=this.prefixSum,_=h.length;return _===0?!1:(this.values=new Uint32Array(w.length+_),this.values.set(w.subarray(0,c),0),this.values.set(w.subarray(c),c+_),this.values.set(h,c),c-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=c-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(c,h){return c=(0,M.toUint32)(c),h=(0,M.toUint32)(h),this.values[c]===h?!1:(this.values[c]=h,c-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=c-1),!0)}removeValues(c,h){c=(0,M.toUint32)(c),h=(0,M.toUint32)(h);const w=this.values,e=this.prefixSum;if(c>=w.length)return!1;const _=w.length-c;return h>=_&&(h=_),h===0?!1:(this.values=new Uint32Array(w.length-h),this.values.set(w.subarray(0,c),0),this.values.set(w.subarray(c+h),c),this.prefixSum=new Uint32Array(this.values.length),c-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=c-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(c){return c<0?0:(c=(0,M.toUint32)(c),this._getPrefixSum(c))}_getPrefixSum(c){if(c<=this.prefixSumValidIndex[0])return this.prefixSum[c];let h=this.prefixSumValidIndex[0]+1;h===0&&(this.prefixSum[0]=this.values[0],h++),c>=this.values.length&&(c=this.values.length-1);for(let w=h;w<=c;w++)this.prefixSum[w]=this.prefixSum[w-1]+this.values[w];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],c),this.prefixSum[c]}getIndexOf(c){c=Math.floor(c),this.getTotalSum();let h=0,w=this.values.length-1,e=0,_=0,f=0;for(;h<=w;)if(e=h+(w-h)/2|0,_=this.prefixSum[e],f=_-this.values[e],c<f)w=e-1;else if(c>=_)h=e+1;else break;return new S(e,c-f)}}n.PrefixSumComputer=i;class l{constructor(c){this._values=c,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(c){return this._ensureValid(),c===0?0:this._prefixSum[c-1]}getIndexOf(c){this._ensureValid();const h=this._indexBySum[c],w=h>0?this._prefixSum[h-1]:0;return new S(h,c-w)}removeValues(c,h){this._values.splice(c,h),this._invalidate(c)}insertValues(c,h){this._values=(0,E.arrayInsert)(this._values,c,h),this._invalidate(c)}_invalidate(c){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,c-1)}_ensureValid(){if(!this._isValid){for(let c=this._validEndIndex+1,h=this._values.length;c<h;c++){const w=this._values[c],e=c>0?this._prefixSum[c-1]:0;this._prefixSum[c]=e+w;for(let _=0;_<w;_++)this._indexBySum[e+_]=c}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(c,h){this._values[c]!==h&&(this._values[c]=h,this._invalidate(c))}}n.ConstantTimePrefixSumComputer=l;class S{constructor(c,h){this.index=c,this.remainder=h,this._prefixSumIndexOfResultBrand=void 0,this.index=c,this.remainder=h}}n.PrefixSumIndexOfResult=S}),Q(Y[45],X([0,1,4,3,44]),function(O,n,E,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class l{constructor(y,c,h,w){this._uri=y,this._lines=c,this._eol=h,this._versionId=w,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(y){y.eol&&y.eol!==this._eol&&(this._eol=y.eol,this._lineStarts=null);const c=y.changes;for(const h of c)this._acceptDeleteRange(h.range),this._acceptInsertText(new M.Position(h.range.startLineNumber,h.range.startColumn),h.text);this._versionId=y.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const y=this._eol.length,c=this._lines.length,h=new Uint32Array(c);for(let w=0;w<c;w++)h[w]=this._lines[w].length+y;this._lineStarts=new i.PrefixSumComputer(h)}}_setLineText(y,c){this._lines[y]=c,this._lineStarts&&this._lineStarts.setValue(y,this._lines[y].length+this._eol.length)}_acceptDeleteRange(y){if(y.startLineNumber===y.endLineNumber){if(y.startColumn===y.endColumn)return;this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.startLineNumber-1].substring(y.endColumn-1));return}this._setLineText(y.startLineNumber-1,this._lines[y.startLineNumber-1].substring(0,y.startColumn-1)+this._lines[y.endLineNumber-1].substring(y.endColumn-1)),this._lines.splice(y.startLineNumber,y.endLineNumber-y.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(y.startLineNumber,y.endLineNumber-y.startLineNumber)}_acceptInsertText(y,c){if(c.length===0)return;const h=(0,E.splitLines)(c);if(h.length===1){this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+h[0]+this._lines[y.lineNumber-1].substring(y.column-1));return}h[h.length-1]+=this._lines[y.lineNumber-1].substring(y.column-1),this._setLineText(y.lineNumber-1,this._lines[y.lineNumber-1].substring(0,y.column-1)+h[0]);const w=new Uint32Array(h.length-1);for(let e=1;e<h.length;e++)this._lines.splice(y.lineNumber+e-1,0,h[e]),w[e-1]=h[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(y.lineNumber,w)}}n.MirrorTextModel=l}),Q(Y[46],X([0,1,4,33,3,2,43]),function(O,n,E,M,i,l,S){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const y=999;class c{constructor(p,d,m,v){this.searchString=p,this.isRegex=d,this.matchCase=m,this.wordSeparators=v}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=h(this.searchString):p=this.searchString.indexOf(`
`)>=0;let d=null;try{d=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch{return null}if(!d)return null;let m=!this.isRegex&&!p;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new S.SearchData(d,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,m?this.searchString:null)}}n.SearchParams=c;function h(A){if(!A||A.length===0)return!1;for(let p=0,d=A.length;p<d;p++){const m=A.charCodeAt(p);if(m===10)return!0;if(m===92){if(p++,p>=d)break;const v=A.charCodeAt(p);if(v===110||v===114||v===87)return!0}}return!1}n.isMultilineRegexSource=h;function w(A,p,d){if(!d)return new S.FindMatch(A,null);const m=[];for(let v=0,r=p.length;v<r;v++)m[v]=p[v];return new S.FindMatch(A,m)}n.createFindMatch=w;class e{constructor(p){const d=[];let m=0;for(let v=0,r=p.length;v<r;v++)p.charCodeAt(v)===10&&(d[m++]=v);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(p){const d=this._lineFeedsOffsets;let m=0,v=d.length-1;if(v===-1||p<=d[0])return 0;for(;m<v;){const r=m+((v-m)/2>>0);d[r]>=p?v=r-1:d[r+1]>=p?(m=r,v=r):m=r+1}return m+1}}class _{static findMatches(p,d,m,v,r){const o=d.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(p,m,new C(o.wordSeparators,o.regex),v,r):this._doFindMatchesLineByLine(p,m,o,v,r):[]}static _getMultilineMatchRange(p,d,m,v,r,o){let s,a=0;v?(a=v.findLineFeedCountBeforeOffset(r),s=d+r+a):s=d+r;let u;if(v){const D=v.findLineFeedCountBeforeOffset(r+o.length)-a;u=s+o.length+D}else u=s+o.length;const L=p.getPositionAt(s),R=p.getPositionAt(u);return new l.Range(L.lineNumber,L.column,R.lineNumber,R.column)}static _doFindMatchesMultiline(p,d,m,v,r){const o=p.getOffsetAt(d.getStartPosition()),s=p.getValueInRange(d,1),a=p.getEOL()===`\r
`?new e(s):null,u=[];let L=0,R;for(m.reset(0);R=m.next(s);)if(u[L++]=w(this._getMultilineMatchRange(p,o,s,a,R.index,R[0]),R,v),L>=r)return u;return u}static _doFindMatchesLineByLine(p,d,m,v,r){const o=[];let s=0;if(d.startLineNumber===d.endLineNumber){const u=p.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return s=this._findMatchesInLine(m,u,d.startLineNumber,d.startColumn-1,s,o,v,r),o}const a=p.getLineContent(d.startLineNumber).substring(d.startColumn-1);s=this._findMatchesInLine(m,a,d.startLineNumber,d.startColumn-1,s,o,v,r);for(let u=d.startLineNumber+1;u<d.endLineNumber&&s<r;u++)s=this._findMatchesInLine(m,p.getLineContent(u),u,0,s,o,v,r);if(s<r){const u=p.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);s=this._findMatchesInLine(m,u,d.endLineNumber,0,s,o,v,r)}return o}static _findMatchesInLine(p,d,m,v,r,o,s,a){const u=p.wordSeparators;if(!s&&p.simpleSearch){const N=p.simpleSearch,D=N.length,U=d.length;let B=-D;for(;(B=d.indexOf(N,B+D))!==-1;)if((!u||g(u,d,U,B,D))&&(o[r++]=new S.FindMatch(new l.Range(m,B+1+v,m,B+1+D+v),null),r>=a))return r;return r}const L=new C(p.wordSeparators,p.regex);let R;L.reset(0);do if(R=L.next(d),R&&(o[r++]=w(new l.Range(m,R.index+1+v,m,R.index+1+R[0].length+v),R,s),r>=a))return r;while(R);return r}static findNextMatch(p,d,m,v){const r=d.parseSearchRequest();if(!r)return null;const o=new C(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(p,m,o,v):this._doFindNextMatchLineByLine(p,m,o,v)}static _doFindNextMatchMultiline(p,d,m,v){const r=new i.Position(d.lineNumber,1),o=p.getOffsetAt(r),s=p.getLineCount(),a=p.getValueInRange(new l.Range(r.lineNumber,r.column,s,p.getLineMaxColumn(s)),1),u=p.getEOL()===`\r
`?new e(a):null;m.reset(d.column-1);const L=m.next(a);return L?w(this._getMultilineMatchRange(p,o,a,u,L.index,L[0]),L,v):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(p,new i.Position(1,1),m,v):null}static _doFindNextMatchLineByLine(p,d,m,v){const r=p.getLineCount(),o=d.lineNumber,s=p.getLineContent(o),a=this._findFirstMatchInLine(m,s,o,d.column,v);if(a)return a;for(let u=1;u<=r;u++){const L=(o+u-1)%r,R=p.getLineContent(L+1),N=this._findFirstMatchInLine(m,R,L+1,1,v);if(N)return N}return null}static _findFirstMatchInLine(p,d,m,v,r){p.reset(v-1);const o=p.next(d);return o?w(new l.Range(m,o.index+1,m,o.index+1+o[0].length),o,r):null}static findPreviousMatch(p,d,m,v){const r=d.parseSearchRequest();if(!r)return null;const o=new C(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(p,m,o,v):this._doFindPreviousMatchLineByLine(p,m,o,v)}static _doFindPreviousMatchMultiline(p,d,m,v){const r=this._doFindMatchesMultiline(p,new l.Range(1,1,d.lineNumber,d.column),m,v,10*y);if(r.length>0)return r[r.length-1];const o=p.getLineCount();return d.lineNumber!==o||d.column!==p.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(p,new i.Position(o,p.getLineMaxColumn(o)),m,v):null}static _doFindPreviousMatchLineByLine(p,d,m,v){const r=p.getLineCount(),o=d.lineNumber,s=p.getLineContent(o).substring(0,d.column-1),a=this._findLastMatchInLine(m,s,o,v);if(a)return a;for(let u=1;u<=r;u++){const L=(r+o-u-1)%r,R=p.getLineContent(L+1),N=this._findLastMatchInLine(m,R,L+1,v);if(N)return N}return null}static _findLastMatchInLine(p,d,m,v){let r=null,o;for(p.reset(0);o=p.next(d);)r=w(new l.Range(m,o.index+1,m,o.index+1+o[0].length),o,v);return r}}n.TextModelSearch=_;function f(A,p,d,m,v){if(m===0)return!0;const r=p.charCodeAt(m-1);if(A.get(r)!==0||r===13||r===10)return!0;if(v>0){const o=p.charCodeAt(m);if(A.get(o)!==0)return!0}return!1}function b(A,p,d,m,v){if(m+v===d)return!0;const r=p.charCodeAt(m+v);if(A.get(r)!==0||r===13||r===10)return!0;if(v>0){const o=p.charCodeAt(m+v-1);if(A.get(o)!==0)return!0}return!1}function g(A,p,d,m,v){return f(A,p,d,m,v)&&b(A,p,d,m,v)}n.isValidMatch=g;class C{constructor(p,d){this._wordSeparators=p,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(p){this._searchRegex.lastIndex=p,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(p){const d=p.length;let m;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(m=this._searchRegex.exec(p),!m))return null;const v=m.index,r=m[0].length;if(v===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){E.getNextCodePoint(p,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=v,this._prevMatchLength=r,!this._wordSeparators||g(this._wordSeparators,p,d,v,r))return m}while(m);return null}}n.Searcher=C}),Q(Y[47],X([0,1,2,46,4,9,21]),function(O,n,E,M,i,l,S){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class y{static computeUnicodeHighlights(_,f,b){const g=b?b.startLineNumber:1,C=b?b.endLineNumber:_.getLineCount(),A=new h(f),p=A.getCandidateCodePoints();let d;p==="allNonBasicAscii"?d=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):d=new RegExp(`${c(Array.from(p))}`,"g");const m=new M.Searcher(null,d),v=[];let r=!1,o,s=0,a=0,u=0;e:for(let L=g,R=C;L<=R;L++){const N=_.getLineContent(L),D=N.length;m.reset(0);do if(o=m.next(N),o){let U=o.index,B=o.index+o[0].length;if(U>0){const I=N.charCodeAt(U-1);i.isHighSurrogate(I)&&U--}if(B+1<D){const I=N.charCodeAt(B-1);i.isHighSurrogate(I)&&B++}const T=N.substring(U,B);let q=(0,S.getWordAtText)(U+1,S.DEFAULT_WORD_REGEXP,N,0);q&&q.endColumn<=U+1&&(q=null);const H=A.shouldHighlightNonBasicASCII(T,q?q.word:null);if(H!==0){H===3?s++:H===2?a++:H===1?u++:(0,l.assertNever)(H);const I=1e3;if(v.length>=I){r=!0;break e}v.push(new E.Range(L,U+1,L,B+1))}}while(o)}return{ranges:v,hasMore:r,ambiguousCharacterCount:s,invisibleCharacterCount:a,nonBasicAsciiCharacterCount:u}}static computeUnicodeHighlightReason(_,f){const b=new h(f);switch(b.shouldHighlightNonBasicASCII(_,null)){case 0:return null;case 2:return{kind:1};case 3:{const C=_.codePointAt(0),A=b.ambiguousCharacters.getPrimaryConfusable(C),p=i.AmbiguousCharacters.getLocales().filter(d=>!i.AmbiguousCharacters.getInstance(new Set([...f.allowedLocales,d])).isAmbiguous(C));return{kind:0,confusableWith:String.fromCodePoint(A),notAmbiguousInLocales:p}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=y;function c(e,_){return`[${i.escapeRegExpCharacters(e.map(b=>String.fromCodePoint(b)).join(""))}]`}class h{constructor(_){this.options=_,this.allowedCodePoints=new Set(_.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(_.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const _=new Set;if(this.options.invisibleCharacters)for(const f of i.InvisibleCharacters.codePoints)w(String.fromCodePoint(f))||_.add(f);if(this.options.ambiguousCharacters)for(const f of this.ambiguousCharacters.getConfusableCodePoints())_.add(f);for(const f of this.allowedCodePoints)_.delete(f);return _}shouldHighlightNonBasicASCII(_,f){const b=_.codePointAt(0);if(this.allowedCodePoints.has(b))return 0;if(this.options.nonBasicASCII)return 1;let g=!1,C=!1;if(f)for(const A of f){const p=A.codePointAt(0),d=i.isBasicASCII(A);g=g||d,!d&&!this.ambiguousCharacters.isAmbiguous(p)&&!i.InvisibleCharacters.isInvisibleCharacter(p)&&(C=!0)}return!g&&C?0:this.options.invisibleCharacters&&!w(_)&&i.InvisibleCharacters.isInvisibleCharacter(b)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(b)?3:0}}function w(e){return e===" "||e===`
`||e==="	"}}),Q(Y[48],X([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var E;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(E=n.AccessibilitySupport||(n.AccessibilitySupport={}));var M;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(M=n.CodeActionTriggerType||(n.CodeActionTriggerType={}));var i;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(i=n.CompletionItemInsertTextRule||(n.CompletionItemInsertTextRule={}));var l;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(l=n.CompletionItemKind||(n.CompletionItemKind={}));var S;(function(t){t[t.Deprecated=1]="Deprecated"})(S=n.CompletionItemTag||(n.CompletionItemTag={}));var y;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(y=n.CompletionTriggerKind||(n.CompletionTriggerKind={}));var c;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(c=n.ContentWidgetPositionPreference||(n.ContentWidgetPositionPreference={}));var h;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(h=n.CursorChangeReason||(n.CursorChangeReason={}));var w;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(w=n.DefaultEndOfLine||(n.DefaultEndOfLine={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));var _;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(_=n.EditorAutoIndentStrategy||(n.EditorAutoIndentStrategy={}));var f;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.autoClosingBrackets=5]="autoClosingBrackets",t[t.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=7]="autoClosingDelete",t[t.autoClosingOvertype=8]="autoClosingOvertype",t[t.autoClosingQuotes=9]="autoClosingQuotes",t[t.autoIndent=10]="autoIndent",t[t.automaticLayout=11]="automaticLayout",t[t.autoSurround=12]="autoSurround",t[t.bracketPairColorization=13]="bracketPairColorization",t[t.guides=14]="guides",t[t.codeLens=15]="codeLens",t[t.codeLensFontFamily=16]="codeLensFontFamily",t[t.codeLensFontSize=17]="codeLensFontSize",t[t.colorDecorators=18]="colorDecorators",t[t.colorDecoratorsLimit=19]="colorDecoratorsLimit",t[t.columnSelection=20]="columnSelection",t[t.comments=21]="comments",t[t.contextmenu=22]="contextmenu",t[t.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",t[t.cursorBlinking=24]="cursorBlinking",t[t.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",t[t.cursorStyle=26]="cursorStyle",t[t.cursorSurroundingLines=27]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",t[t.cursorWidth=29]="cursorWidth",t[t.disableLayerHinting=30]="disableLayerHinting",t[t.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",t[t.domReadOnly=32]="domReadOnly",t[t.dragAndDrop=33]="dragAndDrop",t[t.dropIntoEditor=34]="dropIntoEditor",t[t.emptySelectionClipboard=35]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",t[t.extraEditorClassName=37]="extraEditorClassName",t[t.fastScrollSensitivity=38]="fastScrollSensitivity",t[t.find=39]="find",t[t.fixedOverflowWidgets=40]="fixedOverflowWidgets",t[t.folding=41]="folding",t[t.foldingStrategy=42]="foldingStrategy",t[t.foldingHighlight=43]="foldingHighlight",t[t.foldingImportsByDefault=44]="foldingImportsByDefault",t[t.foldingMaximumRegions=45]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=47]="fontFamily",t[t.fontInfo=48]="fontInfo",t[t.fontLigatures=49]="fontLigatures",t[t.fontSize=50]="fontSize",t[t.fontWeight=51]="fontWeight",t[t.fontVariations=52]="fontVariations",t[t.formatOnPaste=53]="formatOnPaste",t[t.formatOnType=54]="formatOnType",t[t.glyphMargin=55]="glyphMargin",t[t.gotoLocation=56]="gotoLocation",t[t.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",t[t.hover=58]="hover",t[t.inDiffEditor=59]="inDiffEditor",t[t.inlineSuggest=60]="inlineSuggest",t[t.letterSpacing=61]="letterSpacing",t[t.lightbulb=62]="lightbulb",t[t.lineDecorationsWidth=63]="lineDecorationsWidth",t[t.lineHeight=64]="lineHeight",t[t.lineNumbers=65]="lineNumbers",t[t.lineNumbersMinChars=66]="lineNumbersMinChars",t[t.linkedEditing=67]="linkedEditing",t[t.links=68]="links",t[t.matchBrackets=69]="matchBrackets",t[t.minimap=70]="minimap",t[t.mouseStyle=71]="mouseStyle",t[t.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=73]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",t[t.multiCursorModifier=75]="multiCursorModifier",t[t.multiCursorPaste=76]="multiCursorPaste",t[t.multiCursorLimit=77]="multiCursorLimit",t[t.occurrencesHighlight=78]="occurrencesHighlight",t[t.overviewRulerBorder=79]="overviewRulerBorder",t[t.overviewRulerLanes=80]="overviewRulerLanes",t[t.padding=81]="padding",t[t.parameterHints=82]="parameterHints",t[t.peekWidgetDefaultFocus=83]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=84]="definitionLinkOpensInPeek",t[t.quickSuggestions=85]="quickSuggestions",t[t.quickSuggestionsDelay=86]="quickSuggestionsDelay",t[t.readOnly=87]="readOnly",t[t.renameOnType=88]="renameOnType",t[t.renderControlCharacters=89]="renderControlCharacters",t[t.renderFinalNewline=90]="renderFinalNewline",t[t.renderLineHighlight=91]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=92]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=93]="renderValidationDecorations",t[t.renderWhitespace=94]="renderWhitespace",t[t.revealHorizontalRightPadding=95]="revealHorizontalRightPadding",t[t.roundedSelection=96]="roundedSelection",t[t.rulers=97]="rulers",t[t.scrollbar=98]="scrollbar",t[t.scrollBeyondLastColumn=99]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=100]="scrollBeyondLastLine",t[t.scrollPredominantAxis=101]="scrollPredominantAxis",t[t.selectionClipboard=102]="selectionClipboard",t[t.selectionHighlight=103]="selectionHighlight",t[t.selectOnLineNumbers=104]="selectOnLineNumbers",t[t.showFoldingControls=105]="showFoldingControls",t[t.showUnused=106]="showUnused",t[t.snippetSuggestions=107]="snippetSuggestions",t[t.smartSelect=108]="smartSelect",t[t.smoothScrolling=109]="smoothScrolling",t[t.stickyScroll=110]="stickyScroll",t[t.stickyTabStops=111]="stickyTabStops",t[t.stopRenderingLineAfter=112]="stopRenderingLineAfter",t[t.suggest=113]="suggest",t[t.suggestFontSize=114]="suggestFontSize",t[t.suggestLineHeight=115]="suggestLineHeight",t[t.suggestOnTriggerCharacters=116]="suggestOnTriggerCharacters",t[t.suggestSelection=117]="suggestSelection",t[t.tabCompletion=118]="tabCompletion",t[t.tabIndex=119]="tabIndex",t[t.unicodeHighlighting=120]="unicodeHighlighting",t[t.unusualLineTerminators=121]="unusualLineTerminators",t[t.useShadowDOM=122]="useShadowDOM",t[t.useTabStops=123]="useTabStops",t[t.wordBreak=124]="wordBreak",t[t.wordSeparators=125]="wordSeparators",t[t.wordWrap=126]="wordWrap",t[t.wordWrapBreakAfterCharacters=127]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=128]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=129]="wordWrapColumn",t[t.wordWrapOverride1=130]="wordWrapOverride1",t[t.wordWrapOverride2=131]="wordWrapOverride2",t[t.wrappingIndent=132]="wrappingIndent",t[t.wrappingStrategy=133]="wrappingStrategy",t[t.showDeprecated=134]="showDeprecated",t[t.inlayHints=135]="inlayHints",t[t.editorClassName=136]="editorClassName",t[t.pixelRatio=137]="pixelRatio",t[t.tabFocusMode=138]="tabFocusMode",t[t.layoutInfo=139]="layoutInfo",t[t.wrappingInfo=140]="wrappingInfo"})(f=n.EditorOption||(n.EditorOption={}));var b;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(b=n.EndOfLinePreference||(n.EndOfLinePreference={}));var g;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(g=n.EndOfLineSequence||(n.EndOfLineSequence={}));var C;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(C=n.IndentAction||(n.IndentAction={}));var A;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(A=n.InjectedTextCursorStops||(n.InjectedTextCursorStops={}));var p;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(p=n.InlayHintKind||(n.InlayHintKind={}));var d;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(d=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var m;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.Clear=126]="Clear",t[t.MAX_VALUE=127]="MAX_VALUE"})(m=n.KeyCode||(n.KeyCode={}));var v;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(v=n.MarkerSeverity||(n.MarkerSeverity={}));var r;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(r=n.MarkerTag||(n.MarkerTag={}));var o;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(o=n.MinimapPosition||(n.MinimapPosition={}));var s;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(s=n.MouseTargetType||(n.MouseTargetType={}));var a;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(a=n.OverlayWidgetPositionPreference||(n.OverlayWidgetPositionPreference={}));var u;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(u=n.OverviewRulerLane||(n.OverviewRulerLane={}));var L;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(L=n.PositionAffinity||(n.PositionAffinity={}));var R;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(R=n.RenderLineNumbersType||(n.RenderLineNumbersType={}));var N;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(N=n.RenderMinimap||(n.RenderMinimap={}));var D;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(D=n.ScrollType||(n.ScrollType={}));var U;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(U=n.ScrollbarVisibility||(n.ScrollbarVisibility={}));var B;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(B=n.SelectionDirection||(n.SelectionDirection={}));var T;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(T=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var q;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(q=n.SymbolKind||(n.SymbolKind={}));var H;(function(t){t[t.Deprecated=1]="Deprecated"})(H=n.SymbolTag||(n.SymbolTag={}));var I;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(I=n.TextEditorCursorBlinkingStyle||(n.TextEditorCursorBlinkingStyle={}));var F;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(F=n.TextEditorCursorStyle||(n.TextEditorCursorStyle={}));var k;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=n.TrackedRangeStickiness||(n.TrackedRangeStickiness={}));var V;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(V=n.WrappingIndent||(n.WrappingIndent={}))}),Q(Y[49],X([24,56]),function(O,n){return O.create("vs/base/common/platform",n)}),Q(Y[6],X([0,1,49]),function(O,n,E){"use strict";var M;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let i=!1,l=!1,S=!1,y=!1,c=!1,h=!1,w=!1,e=!1,_=!1,f=!1,b,g=n.LANGUAGE_DEFAULT,C=n.LANGUAGE_DEFAULT,A,p;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?d=n.globals.vscode.process:typeof process<"u"&&(d=process);const m=typeof((M=d?.versions)===null||M===void 0?void 0:M.electron)=="string",v=m&&d?.type==="renderer";if(typeof navigator=="object"&&!v)p=navigator.userAgent,i=p.indexOf("Windows")>=0,l=p.indexOf("Macintosh")>=0,e=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=p.indexOf("Linux")>=0,f=p?.indexOf("Mobi")>=0,h=!0,b=E.getConfiguredDefaultLocale(E.localize(0,null))||n.LANGUAGE_DEFAULT,g=b,C=navigator.language;else if(typeof d=="object"){i=d.platform==="win32",l=d.platform==="darwin",S=d.platform==="linux",y=S&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,w=m,_=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=n.LANGUAGE_DEFAULT,g=n.LANGUAGE_DEFAULT;const u=d.env.VSCODE_NLS_CONFIG;if(u)try{const L=JSON.parse(u),R=L.availableLanguages["*"];b=L.locale,C=L.osLocale,g=R||n.LANGUAGE_DEFAULT,A=L._translationsConfigFile}catch{}c=!0}else console.error("Unable to resolve platform.");let r=0;l?r=1:i?r=3:S&&(r=2),n.isWindows=i,n.isMacintosh=l,n.isLinux=S,n.isNative=c,n.isWeb=h,n.isWebWorker=h&&typeof n.globals.importScripts=="function",n.isIOS=e,n.isMobile=f,n.userAgent=p,n.language=g,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const u=[];n.globals.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let N=0,D=u.length;N<D;N++){const U=u[N];if(U.id===R.data.vscodeScheduleAsyncWork){u.splice(N,1),U.callback();return}}});let L=0;return R=>{const N=++L;u.push({id:N,callback:R}),n.globals.postMessage({vscodeScheduleAsyncWork:N},"*")}}return u=>setTimeout(u)})(),n.OS=l||e?2:i?1:3;let o=!0,s=!1;function a(){if(!s){s=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,o=new Uint16Array(u.buffer)[0]===(2<<8)+1}return o}n.isLittleEndian=a,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),Q(Y[50],X([0,1,6]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let M;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const i=E.globals.vscode.process;M={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=M.cwd,n.env=M.env,n.platform=M.platform}),Q(Y[51],X([0,1,50]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const M=65,i=97,l=90,S=122,y=46,c=47,h=92,w=58,e=63;class _ extends Error{constructor(o,s,a){let u;typeof s=="string"&&s.indexOf("not ")===0?(u="must not be",s=s.replace(/^not /,"")):u="must be";const L=o.indexOf(".")!==-1?"property":"argument";let R=`The "${o}" ${L} ${u} of type ${s}`;R+=`. Received type ${typeof a}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function f(r,o){if(r===null||typeof r!="object")throw new _(o,"Object",r)}function b(r,o){if(typeof r!="string")throw new _(o,"string",r)}const g=E.platform==="win32";function C(r){return r===c||r===h}function A(r){return r===c}function p(r){return r>=M&&r<=l||r>=i&&r<=S}function d(r,o,s,a){let u="",L=0,R=-1,N=0,D=0;for(let U=0;U<=r.length;++U){if(U<r.length)D=r.charCodeAt(U);else{if(a(D))break;D=c}if(a(D)){if(!(R===U-1||N===1))if(N===2){if(u.length<2||L!==2||u.charCodeAt(u.length-1)!==y||u.charCodeAt(u.length-2)!==y){if(u.length>2){const B=u.lastIndexOf(s);B===-1?(u="",L=0):(u=u.slice(0,B),L=u.length-1-u.lastIndexOf(s)),R=U,N=0;continue}else if(u.length!==0){u="",L=0,R=U,N=0;continue}}o&&(u+=u.length>0?`${s}..`:"..",L=2)}else u.length>0?u+=`${s}${r.slice(R+1,U)}`:u=r.slice(R+1,U),L=U-R-1;R=U,N=0}else D===y&&N!==-1?++N:N=-1}return u}function m(r,o){f(o,"pathObject");const s=o.dir||o.root,a=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${a}`:`${s}${r}${a}`:a}n.win32={resolve(...r){let o="",s="",a=!1;for(let u=r.length-1;u>=-1;u--){let L;if(u>=0){if(L=r[u],b(L,"path"),L.length===0)continue}else o.length===0?L=E.cwd():(L=E.env[`=${o}`]||E.cwd(),(L===void 0||L.slice(0,2).toLowerCase()!==o.toLowerCase()&&L.charCodeAt(2)===h)&&(L=`${o}\\`));const R=L.length;let N=0,D="",U=!1;const B=L.charCodeAt(0);if(R===1)C(B)&&(N=1,U=!0);else if(C(B))if(U=!0,C(L.charCodeAt(1))){let T=2,q=T;for(;T<R&&!C(L.charCodeAt(T));)T++;if(T<R&&T!==q){const H=L.slice(q,T);for(q=T;T<R&&C(L.charCodeAt(T));)T++;if(T<R&&T!==q){for(q=T;T<R&&!C(L.charCodeAt(T));)T++;(T===R||T!==q)&&(D=`\\\\${H}\\${L.slice(q,T)}`,N=T)}}}else N=1;else p(B)&&L.charCodeAt(1)===w&&(D=L.slice(0,2),N=2,R>2&&C(L.charCodeAt(2))&&(U=!0,N=3));if(D.length>0)if(o.length>0){if(D.toLowerCase()!==o.toLowerCase())continue}else o=D;if(a){if(o.length>0)break}else if(s=`${L.slice(N)}\\${s}`,a=U,U&&o.length>0)break}return s=d(s,!a,"\\",C),a?`${o}\\${s}`:`${o}${s}`||"."},normalize(r){b(r,"path");const o=r.length;if(o===0)return".";let s=0,a,u=!1;const L=r.charCodeAt(0);if(o===1)return A(L)?"\\":r;if(C(L))if(u=!0,C(r.charCodeAt(1))){let N=2,D=N;for(;N<o&&!C(r.charCodeAt(N));)N++;if(N<o&&N!==D){const U=r.slice(D,N);for(D=N;N<o&&C(r.charCodeAt(N));)N++;if(N<o&&N!==D){for(D=N;N<o&&!C(r.charCodeAt(N));)N++;if(N===o)return`\\\\${U}\\${r.slice(D)}\\`;N!==D&&(a=`\\\\${U}\\${r.slice(D,N)}`,s=N)}}}else s=1;else p(L)&&r.charCodeAt(1)===w&&(a=r.slice(0,2),s=2,o>2&&C(r.charCodeAt(2))&&(u=!0,s=3));let R=s<o?d(r.slice(s),!u,"\\",C):"";return R.length===0&&!u&&(R="."),R.length>0&&C(r.charCodeAt(o-1))&&(R+="\\"),a===void 0?u?`\\${R}`:R:u?`${a}\\${R}`:`${a}${R}`},isAbsolute(r){b(r,"path");const o=r.length;if(o===0)return!1;const s=r.charCodeAt(0);return C(s)||o>2&&p(s)&&r.charCodeAt(1)===w&&C(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let o,s;for(let L=0;L<r.length;++L){const R=r[L];b(R,"path"),R.length>0&&(o===void 0?o=s=R:o+=`\\${R}`)}if(o===void 0)return".";let a=!0,u=0;if(typeof s=="string"&&C(s.charCodeAt(0))){++u;const L=s.length;L>1&&C(s.charCodeAt(1))&&(++u,L>2&&(C(s.charCodeAt(2))?++u:a=!1))}if(a){for(;u<o.length&&C(o.charCodeAt(u));)u++;u>=2&&(o=`\\${o.slice(u)}`)}return n.win32.normalize(o)},relative(r,o){if(b(r,"from"),b(o,"to"),r===o)return"";const s=n.win32.resolve(r),a=n.win32.resolve(o);if(s===a||(r=s.toLowerCase(),o=a.toLowerCase(),r===o))return"";let u=0;for(;u<r.length&&r.charCodeAt(u)===h;)u++;let L=r.length;for(;L-1>u&&r.charCodeAt(L-1)===h;)L--;const R=L-u;let N=0;for(;N<o.length&&o.charCodeAt(N)===h;)N++;let D=o.length;for(;D-1>N&&o.charCodeAt(D-1)===h;)D--;const U=D-N,B=R<U?R:U;let T=-1,q=0;for(;q<B;q++){const I=r.charCodeAt(u+q);if(I!==o.charCodeAt(N+q))break;I===h&&(T=q)}if(q!==B){if(T===-1)return a}else{if(U>B){if(o.charCodeAt(N+q)===h)return a.slice(N+q+1);if(q===2)return a.slice(N+q)}R>B&&(r.charCodeAt(u+q)===h?T=q:q===2&&(T=3)),T===-1&&(T=0)}let H="";for(q=u+T+1;q<=L;++q)(q===L||r.charCodeAt(q)===h)&&(H+=H.length===0?"..":"\\..");return N+=T,H.length>0?`${H}${a.slice(N,D)}`:(a.charCodeAt(N)===h&&++N,a.slice(N,D))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const o=n.win32.resolve(r);if(o.length<=2)return r;if(o.charCodeAt(0)===h){if(o.charCodeAt(1)===h){const s=o.charCodeAt(2);if(s!==e&&s!==y)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(p(o.charCodeAt(0))&&o.charCodeAt(1)===w&&o.charCodeAt(2)===h)return`\\\\?\\${o}`;return r},dirname(r){b(r,"path");const o=r.length;if(o===0)return".";let s=-1,a=0;const u=r.charCodeAt(0);if(o===1)return C(u)?r:".";if(C(u)){if(s=a=1,C(r.charCodeAt(1))){let N=2,D=N;for(;N<o&&!C(r.charCodeAt(N));)N++;if(N<o&&N!==D){for(D=N;N<o&&C(r.charCodeAt(N));)N++;if(N<o&&N!==D){for(D=N;N<o&&!C(r.charCodeAt(N));)N++;if(N===o)return r;N!==D&&(s=a=N+1)}}}}else p(u)&&r.charCodeAt(1)===w&&(s=o>2&&C(r.charCodeAt(2))?3:2,a=s);let L=-1,R=!0;for(let N=o-1;N>=a;--N)if(C(r.charCodeAt(N))){if(!R){L=N;break}}else R=!1;if(L===-1){if(s===-1)return".";L=s}return r.slice(0,L)},basename(r,o){o!==void 0&&b(o,"ext"),b(r,"path");let s=0,a=-1,u=!0,L;if(r.length>=2&&p(r.charCodeAt(0))&&r.charCodeAt(1)===w&&(s=2),o!==void 0&&o.length>0&&o.length<=r.length){if(o===r)return"";let R=o.length-1,N=-1;for(L=r.length-1;L>=s;--L){const D=r.charCodeAt(L);if(C(D)){if(!u){s=L+1;break}}else N===-1&&(u=!1,N=L+1),R>=0&&(D===o.charCodeAt(R)?--R===-1&&(a=L):(R=-1,a=N))}return s===a?a=N:a===-1&&(a=r.length),r.slice(s,a)}for(L=r.length-1;L>=s;--L)if(C(r.charCodeAt(L))){if(!u){s=L+1;break}}else a===-1&&(u=!1,a=L+1);return a===-1?"":r.slice(s,a)},extname(r){b(r,"path");let o=0,s=-1,a=0,u=-1,L=!0,R=0;r.length>=2&&r.charCodeAt(1)===w&&p(r.charCodeAt(0))&&(o=a=2);for(let N=r.length-1;N>=o;--N){const D=r.charCodeAt(N);if(C(D)){if(!L){a=N+1;break}continue}u===-1&&(L=!1,u=N+1),D===y?s===-1?s=N:R!==1&&(R=1):s!==-1&&(R=-1)}return s===-1||u===-1||R===0||R===1&&s===u-1&&s===a+1?"":r.slice(s,u)},format:m.bind(null,"\\"),parse(r){b(r,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return o;const s=r.length;let a=0,u=r.charCodeAt(0);if(s===1)return C(u)?(o.root=o.dir=r,o):(o.base=o.name=r,o);if(C(u)){if(a=1,C(r.charCodeAt(1))){let T=2,q=T;for(;T<s&&!C(r.charCodeAt(T));)T++;if(T<s&&T!==q){for(q=T;T<s&&C(r.charCodeAt(T));)T++;if(T<s&&T!==q){for(q=T;T<s&&!C(r.charCodeAt(T));)T++;T===s?a=T:T!==q&&(a=T+1)}}}}else if(p(u)&&r.charCodeAt(1)===w){if(s<=2)return o.root=o.dir=r,o;if(a=2,C(r.charCodeAt(2))){if(s===3)return o.root=o.dir=r,o;a=3}}a>0&&(o.root=r.slice(0,a));let L=-1,R=a,N=-1,D=!0,U=r.length-1,B=0;for(;U>=a;--U){if(u=r.charCodeAt(U),C(u)){if(!D){R=U+1;break}continue}N===-1&&(D=!1,N=U+1),u===y?L===-1?L=U:B!==1&&(B=1):L!==-1&&(B=-1)}return N!==-1&&(L===-1||B===0||B===1&&L===N-1&&L===R+1?o.base=o.name=r.slice(R,N):(o.name=r.slice(R,L),o.base=r.slice(R,N),o.ext=r.slice(L,N))),R>0&&R!==a?o.dir=r.slice(0,R-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const v=(()=>{if(g){const r=/\\/g;return()=>{const o=E.cwd().replace(r,"/");return o.slice(o.indexOf("/"))}}return()=>E.cwd()})();n.posix={resolve(...r){let o="",s=!1;for(let a=r.length-1;a>=-1&&!s;a--){const u=a>=0?r[a]:v();b(u,"path"),u.length!==0&&(o=`${u}/${o}`,s=u.charCodeAt(0)===c)}return o=d(o,!s,"/",A),s?`/${o}`:o.length>0?o:"."},normalize(r){if(b(r,"path"),r.length===0)return".";const o=r.charCodeAt(0)===c,s=r.charCodeAt(r.length-1)===c;return r=d(r,!o,"/",A),r.length===0?o?"/":s?"./":".":(s&&(r+="/"),o?`/${r}`:r)},isAbsolute(r){return b(r,"path"),r.length>0&&r.charCodeAt(0)===c},join(...r){if(r.length===0)return".";let o;for(let s=0;s<r.length;++s){const a=r[s];b(a,"path"),a.length>0&&(o===void 0?o=a:o+=`/${a}`)}return o===void 0?".":n.posix.normalize(o)},relative(r,o){if(b(r,"from"),b(o,"to"),r===o||(r=n.posix.resolve(r),o=n.posix.resolve(o),r===o))return"";const s=1,a=r.length,u=a-s,L=1,R=o.length-L,N=u<R?u:R;let D=-1,U=0;for(;U<N;U++){const T=r.charCodeAt(s+U);if(T!==o.charCodeAt(L+U))break;T===c&&(D=U)}if(U===N)if(R>N){if(o.charCodeAt(L+U)===c)return o.slice(L+U+1);if(U===0)return o.slice(L+U)}else u>N&&(r.charCodeAt(s+U)===c?D=U:U===0&&(D=0));let B="";for(U=s+D+1;U<=a;++U)(U===a||r.charCodeAt(U)===c)&&(B+=B.length===0?"..":"/..");return`${B}${o.slice(L+D)}`},toNamespacedPath(r){return r},dirname(r){if(b(r,"path"),r.length===0)return".";const o=r.charCodeAt(0)===c;let s=-1,a=!0;for(let u=r.length-1;u>=1;--u)if(r.charCodeAt(u)===c){if(!a){s=u;break}}else a=!1;return s===-1?o?"/":".":o&&s===1?"//":r.slice(0,s)},basename(r,o){o!==void 0&&b(o,"ext"),b(r,"path");let s=0,a=-1,u=!0,L;if(o!==void 0&&o.length>0&&o.length<=r.length){if(o===r)return"";let R=o.length-1,N=-1;for(L=r.length-1;L>=0;--L){const D=r.charCodeAt(L);if(D===c){if(!u){s=L+1;break}}else N===-1&&(u=!1,N=L+1),R>=0&&(D===o.charCodeAt(R)?--R===-1&&(a=L):(R=-1,a=N))}return s===a?a=N:a===-1&&(a=r.length),r.slice(s,a)}for(L=r.length-1;L>=0;--L)if(r.charCodeAt(L)===c){if(!u){s=L+1;break}}else a===-1&&(u=!1,a=L+1);return a===-1?"":r.slice(s,a)},extname(r){b(r,"path");let o=-1,s=0,a=-1,u=!0,L=0;for(let R=r.length-1;R>=0;--R){const N=r.charCodeAt(R);if(N===c){if(!u){s=R+1;break}continue}a===-1&&(u=!1,a=R+1),N===y?o===-1?o=R:L!==1&&(L=1):o!==-1&&(L=-1)}return o===-1||a===-1||L===0||L===1&&o===a-1&&o===s+1?"":r.slice(o,a)},format:m.bind(null,"/"),parse(r){b(r,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return o;const s=r.charCodeAt(0)===c;let a;s?(o.root="/",a=1):a=0;let u=-1,L=0,R=-1,N=!0,D=r.length-1,U=0;for(;D>=a;--D){const B=r.charCodeAt(D);if(B===c){if(!N){L=D+1;break}continue}R===-1&&(N=!1,R=D+1),B===y?u===-1?u=D:U!==1&&(U=1):u!==-1&&(U=-1)}if(R!==-1){const B=L===0&&s?1:L;u===-1||U===0||U===1&&u===R-1&&u===L+1?o.base=o.name=r.slice(B,R):(o.name=r.slice(B,u),o.base=r.slice(B,R),o.ext=r.slice(u,R))}return L>0?o.dir=r.slice(0,L-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=g?n.win32.normalize:n.posix.normalize,n.resolve=g?n.win32.resolve:n.posix.resolve,n.relative=g?n.win32.relative:n.posix.relative,n.dirname=g?n.win32.dirname:n.posix.dirname,n.basename=g?n.win32.basename:n.posix.basename,n.extname=g?n.win32.extname:n.posix.extname,n.sep=g?n.win32.sep:n.posix.sep}),Q(Y[23],X([0,1,6]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const M=E.globals.performance&&typeof E.globals.performance.now=="function";class i{static create(S=!0){return new i(S)}constructor(S){this._highResolution=M&&S,this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}n.StopWatch=i}),Q(Y[7],X([0,1,8,13,10,15,23]),function(O,n,E,M,i,l,S){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.EventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const y=!1,c=!1;var h;(function(a){a.None=()=>i.Disposable.None;function u(J){if(c){const{onDidAddListener:j}=J,G=f.create();let $=0;J.onDidAddListener=()=>{++$===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),G.print()),j?.()}}}function L(J,j){return I(J,()=>{},0,void 0,!0,void 0,j)}a.defer=L;function R(J){return(j,G=null,$)=>{let K=!1,ee;return ee=J(te=>{if(!K)return ee?ee.dispose():K=!0,j.call(G,te)},null,$),K&&ee.dispose(),ee}}a.once=R;function N(J,j,G){return H(($,K=null,ee)=>J(te=>$.call(K,j(te)),null,ee),G)}a.map=N;function D(J,j,G){return H(($,K=null,ee)=>J(te=>{j(te),$.call(K,te)},null,ee),G)}a.forEach=D;function U(J,j,G){return H(($,K=null,ee)=>J(te=>j(te)&&$.call(K,te),null,ee),G)}a.filter=U;function B(J){return J}a.signal=B;function T(...J){return(j,G=null,$)=>(0,i.combinedDisposable)(...J.map(K=>K(ee=>j.call(G,ee),null,$)))}a.any=T;function q(J,j,G,$){let K=G;return N(J,ee=>(K=j(K,ee),K),$)}a.reduce=q;function H(J,j){let G;const $={onWillAddFirstListener(){G=J(K.fire,K)},onDidRemoveLastListener(){G?.dispose()}};j||u($);const K=new g($);return j?.add(K),K.event}function I(J,j,G=100,$=!1,K=!1,ee,te){let le,be,_e,ae=0,ce;const P={leakWarningThreshold:ee,onWillAddFirstListener(){le=J(W=>{ae++,be=j(be,W),$&&!_e&&(x.fire(be),be=void 0),ce=()=>{const z=be;be=void 0,_e=void 0,(!$||ae>1)&&x.fire(z),ae=0},typeof G=="number"?(clearTimeout(_e),_e=setTimeout(ce,G)):_e===void 0&&(_e=0,queueMicrotask(ce))})},onWillRemoveListener(){K&&ae>0&&ce?.()},onDidRemoveLastListener(){ce=void 0,le.dispose()}};te||u(P);const x=new g(P);return te?.add(x),x.event}a.debounce=I;function F(J,j=0,G){return a.debounce(J,($,K)=>$?($.push(K),$):[K],j,void 0,!0,void 0,G)}a.accumulate=F;function k(J,j=($,K)=>$===K,G){let $=!0,K;return U(J,ee=>{const te=$||!j(ee,K);return $=!1,K=ee,te},G)}a.latch=k;function V(J,j,G){return[a.filter(J,j,G),a.filter(J,$=>!j($),G)]}a.split=V;function t(J,j=!1,G=[]){let $=G.slice(),K=J(le=>{$?$.push(le):te.fire(le)});const ee=()=>{$?.forEach(le=>te.fire(le)),$=null},te=new g({onWillAddFirstListener(){K||(K=J(le=>te.fire(le)))},onDidAddFirstListener(){$&&(j?setTimeout(ee):ee())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return te.event}a.buffer=t;class ne{constructor(j){this.event=j,this.disposables=new i.DisposableStore}map(j){return new ne(N(this.event,j,this.disposables))}forEach(j){return new ne(D(this.event,j,this.disposables))}filter(j){return new ne(U(this.event,j,this.disposables))}reduce(j,G){return new ne(q(this.event,j,G,this.disposables))}latch(){return new ne(k(this.event,void 0,this.disposables))}debounce(j,G=100,$=!1,K=!1,ee){return new ne(I(this.event,j,G,$,K,ee,this.disposables))}on(j,G,$){return this.event(j,G,$)}once(j,G,$){return R(this.event)(j,G,$)}dispose(){this.disposables.dispose()}}function oe(J){return new ne(J)}a.chain=oe;function de(J,j,G=$=>$){const $=(...le)=>te.fire(G(...le)),K=()=>J.on(j,$),ee=()=>J.removeListener(j,$),te=new g({onWillAddFirstListener:K,onDidRemoveLastListener:ee});return te.event}a.fromNodeEventEmitter=de;function pe(J,j,G=$=>$){const $=(...le)=>te.fire(G(...le)),K=()=>J.addEventListener(j,$),ee=()=>J.removeEventListener(j,$),te=new g({onWillAddFirstListener:K,onDidRemoveLastListener:ee});return te.event}a.fromDOMEventEmitter=pe;function Le(J){return new Promise(j=>R(J)(j))}a.toPromise=Le;function Se(J,j){return j(void 0),J(G=>j(G))}a.runAndSubscribe=Se;function we(J,j){let G=null;function $(ee){G?.dispose(),G=new i.DisposableStore,j(ee,G)}$(void 0);const K=J(ee=>$(ee));return(0,i.toDisposable)(()=>{K.dispose(),G?.dispose()})}a.runAndSubscribeWithStore=we;class ye{constructor(j,G){this.obs=j,this._counter=0,this._hasChanged=!1;const $={onWillAddFirstListener:()=>{j.addObserver(this)},onDidRemoveLastListener:()=>{j.removeObserver(this)}};G||u($),this.emitter=new g($),G&&G.add(this.emitter)}beginUpdate(j){this._counter++}handleChange(j,G){this._hasChanged=!0}endUpdate(j){--this._counter===0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function Ae(J,j){return new ye(J,j).emitter.event}a.fromObservable=Ae})(h=n.Event||(n.Event={}));class w{constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${w._idPool++}`,w.all.add(this)}start(u){this._stopWatch=new S.StopWatch(!0),this.listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this._stopWatch=void 0}}}w.all=new Set,w._idPool=0,n.EventProfiling=w;let e=-1;class _{constructor(u,L=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=L,this._warnCountdown=0}dispose(){var u;(u=this._stacks)===null||u===void 0||u.clear()}check(u,L){const R=this.threshold;if(R<=0||L<R)return;this._stacks||(this._stacks=new Map);const N=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,N+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=R*.5;let D,U=0;for(const[B,T]of this._stacks)(!D||U<T)&&(D=B,U=T);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${U}):`),console.warn(D)}return()=>{const D=this._stacks.get(u.value)||0;this._stacks.set(u.value,D-1)}}}class f{static create(){var u;return new f((u=new Error().stack)!==null&&u!==void 0?u:"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b{constructor(u,L,R){this.callback=u,this.callbackThis=L,this.stack=R,this.subscription=new i.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class g{constructor(u){var L,R,N,D,U;this._disposed=!1,this._options=u,this._leakageMon=e>0||((L=this._options)===null||L===void 0?void 0:L.leakWarningThreshold)?new _((N=(R=this._options)===null||R===void 0?void 0:R.leakWarningThreshold)!==null&&N!==void 0?N:e):void 0,this._perfMon=!((D=this._options)===null||D===void 0)&&D._profName?new w(this._options._profName):void 0,this._deliveryQueue=(U=this._options)===null||U===void 0?void 0:U.deliveryQueue}dispose(){var u,L,R,N;if(!this._disposed){if(this._disposed=!0,this._listeners){if(y){const D=Array.from(this._listeners);queueMicrotask(()=>{var U;for(const B of D)B.subscription.isset()&&(B.subscription.unset(),(U=B.stack)===null||U===void 0||U.print())})}this._listeners.clear()}(u=this._deliveryQueue)===null||u===void 0||u.clear(this),(R=(L=this._options)===null||L===void 0?void 0:L.onDidRemoveLastListener)===null||R===void 0||R.call(L),(N=this._leakageMon)===null||N===void 0||N.dispose()}}get event(){return this._event||(this._event=(u,L,R)=>{var N,D,U;if(this._listeners||(this._listeners=new l.LinkedList),this._leakageMon&&this._listeners.size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const B=this._listeners.isEmpty();B&&((N=this._options)===null||N===void 0?void 0:N.onWillAddFirstListener)&&this._options.onWillAddFirstListener(this);let T,q;this._leakageMon&&this._listeners.size>=Math.ceil(this._leakageMon.threshold*.2)&&(q=f.create(),T=this._leakageMon.check(q,this._listeners.size+1)),y&&(q=q??f.create());const H=new b(u,L,q),I=this._listeners.push(H);B&&((D=this._options)===null||D===void 0?void 0:D.onDidAddFirstListener)&&this._options.onDidAddFirstListener(this),!((U=this._options)===null||U===void 0)&&U.onDidAddListener&&this._options.onDidAddListener(this,u,L);const F=H.subscription.set(()=>{var k,V;T?.(),this._disposed||((V=(k=this._options)===null||k===void 0?void 0:k.onWillRemoveListener)===null||V===void 0||V.call(k,this),I(),this._options&&this._options.onDidRemoveLastListener&&(this._listeners&&!this._listeners.isEmpty()||this._options.onDidRemoveLastListener(this)))});return R instanceof i.DisposableStore?R.add(F):Array.isArray(R)&&R.push(F),F}),this._event}fire(u){var L,R,N;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A((L=this._options)===null||L===void 0?void 0:L.onListenerError));for(const D of this._listeners)this._deliveryQueue.push(this,D,u);(R=this._perfMon)===null||R===void 0||R.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),(N=this._perfMon)===null||N===void 0||N.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}n.Emitter=g;class C{constructor(u=E.onUnexpectedError){this._onListenerError=u,this._queue=new l.LinkedList}get size(){return this._queue.size}push(u,L,R){this._queue.push(new p(u,L,R))}clear(u){const L=new l.LinkedList;for(const R of this._queue)R.emitter!==u&&L.push(R);this._queue=L}deliver(){for(;this._queue.size>0;){const u=this._queue.shift();try{u.listener.invoke(u.event)}catch(L){this._onListenerError(L)}}}}n.EventDeliveryQueue=C;class A extends C{clear(u){this._queue.clear()}}class p{constructor(u,L,R){this.emitter=u,this.listener=L,this.event=R}}class d extends g{constructor(u){super(u),this._isPaused=0,this._eventQueue=new l.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}n.PauseableEmitter=d;class m extends d{constructor(u){var L;super(u),this._delay=(L=u.delay)!==null&&L!==void 0?L:100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}n.DebounceEmitter=m;class v extends g{constructor(u){super(u),this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){!this.hasListeners()||(this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(L=>super.fire(L)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=v;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const L={event:u,listener:null};this.events.push(L),this.hasListeners&&this.hook(L);const R=()=>{this.hasListeners&&this.unhook(L);const N=this.events.indexOf(L);this.events.splice(N,1)};return(0,i.toDisposable)((0,M.once)(R))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(L=>this.emitter.fire(L))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=r;class o{constructor(){this.buffers=[]}wrapEvent(u){return(L,R,N)=>u(D=>{const U=this.buffers[this.buffers.length-1];U?U.push(()=>L.call(R,D)):L.call(R,D)},void 0,N)}bufferEvents(u){const L=[];this.buffers.push(L);const R=u();return this.buffers.pop(),L.forEach(N=>N()),R}}n.EventBufferer=o;class s{constructor(){this.listening=!1,this.inputEvent=h.None,this.inputEventListener=i.Disposable.None,this.emitter=new g({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=s}),Q(Y[52],X([0,1,7]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const M=Object.freeze(function(y,c){const h=setTimeout(y.bind(c),0);return{dispose(){clearTimeout(h)}}});var i;(function(y){function c(h){return h===y.None||h===y.Cancelled||h instanceof l?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}y.isCancellationToken=c,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(i=n.CancellationToken||(n.CancellationToken={}));class l{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?M:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(c){this._token=void 0,this._parentListener=void 0,this._parentListener=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new l),this._token}cancel(){this._token?this._token instanceof l&&this._token.cancel():this._token=i.Cancelled}dispose(c=!1){var h;c&&this.cancel(),(h=this._parentListener)===null||h===void 0||h.dispose(),this._token?this._token instanceof l&&this._token.dispose():this._token=i.None}}n.CancellationTokenSource=S}),Q(Y[12],X([0,1,51,6]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const i=/^\w[\w\d+.-]*$/,l=/^\//,S=/^\/\//;function y(s,a){if(!s.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!i.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!l.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(s,a){return!s&&!a?"file":s}function h(s,a){switch(s){case"https":case"http":case"file":a?a[0]!==e&&(a=e+a):a=e;break}return a}const w="",e="/",_=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(a){return a instanceof f?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,u,L,R,N,D=!1){typeof a=="object"?(this.scheme=a.scheme||w,this.authority=a.authority||w,this.path=a.path||w,this.query=a.query||w,this.fragment=a.fragment||w):(this.scheme=c(a,D),this.authority=u||w,this.path=h(this.scheme,L||w),this.query=R||w,this.fragment=N||w,y(this,D))}get fsPath(){return d(this,!1)}with(a){if(!a)return this;let{scheme:u,authority:L,path:R,query:N,fragment:D}=a;return u===void 0?u=this.scheme:u===null&&(u=w),L===void 0?L=this.authority:L===null&&(L=w),R===void 0?R=this.path:R===null&&(R=w),N===void 0?N=this.query:N===null&&(N=w),D===void 0?D=this.fragment:D===null&&(D=w),u===this.scheme&&L===this.authority&&R===this.path&&N===this.query&&D===this.fragment?this:new g(u,L,R,N,D)}static parse(a,u=!1){const L=_.exec(a);return L?new g(L[2]||w,o(L[4]||w),o(L[5]||w),o(L[7]||w),o(L[9]||w),u):new g(w,w,w,w,w)}static file(a){let u=w;if(M.isWindows&&(a=a.replace(/\\/g,e)),a[0]===e&&a[1]===e){const L=a.indexOf(e,2);L===-1?(u=a.substring(2),a=e):(u=a.substring(2,L),a=a.substring(L)||e)}return new g("file",u,a,w,w)}static from(a){const u=new g(a.scheme,a.authority,a.path,a.query,a.fragment);return y(u,!0),u}static joinPath(a,...u){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let L;return M.isWindows&&a.scheme==="file"?L=f.file(E.win32.join(d(a,!0),...u)).path:L=E.posix.join(a.path,...u),a.with({path:L})}toString(a=!1){return m(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof f)return a;{const u=new g(a);return u._formatted=a.external,u._fsPath=a._sep===b?a.fsPath:null,u}}else return a}}n.URI=f;const b=M.isWindows?1:void 0;class g extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(a=!1){return a?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=b),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function A(s,a,u){let L,R=-1;for(let N=0;N<s.length;N++){const D=s.charCodeAt(N);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||a&&D===47||u&&D===91||u&&D===93||u&&D===58)R!==-1&&(L+=encodeURIComponent(s.substring(R,N)),R=-1),L!==void 0&&(L+=s.charAt(N));else{L===void 0&&(L=s.substr(0,N));const U=C[D];U!==void 0?(R!==-1&&(L+=encodeURIComponent(s.substring(R,N)),R=-1),L+=U):R===-1&&(R=N)}}return R!==-1&&(L+=encodeURIComponent(s.substring(R))),L!==void 0?L:s}function p(s){let a;for(let u=0;u<s.length;u++){const L=s.charCodeAt(u);L===35||L===63?(a===void 0&&(a=s.substr(0,u)),a+=C[L]):a!==void 0&&(a+=s[u])}return a!==void 0?a:s}function d(s,a){let u;return s.authority&&s.path.length>1&&s.scheme==="file"?u=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?a?u=s.path.substr(1):u=s.path[1].toLowerCase()+s.path.substr(2):u=s.path,M.isWindows&&(u=u.replace(/\//g,"\\")),u}n.uriToFsPath=d;function m(s,a){const u=a?p:A;let L="",{scheme:R,authority:N,path:D,query:U,fragment:B}=s;if(R&&(L+=R,L+=":"),(N||R==="file")&&(L+=e,L+=e),N){let T=N.indexOf("@");if(T!==-1){const q=N.substr(0,T);N=N.substr(T+1),T=q.lastIndexOf(":"),T===-1?L+=u(q,!1,!1):(L+=u(q.substr(0,T),!1,!1),L+=":",L+=u(q.substr(T+1),!1,!0)),L+="@"}N=N.toLowerCase(),T=N.lastIndexOf(":"),T===-1?L+=u(N,!1,!0):(L+=u(N.substr(0,T),!1,!0),L+=N.substr(T))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const T=D.charCodeAt(1);T>=65&&T<=90&&(D=`/${String.fromCharCode(T+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const T=D.charCodeAt(0);T>=65&&T<=90&&(D=`${String.fromCharCode(T+32)}:${D.substr(2)}`)}L+=u(D,!0,!1)}return U&&(L+="?",L+=u(U,!1,!1)),B&&(L+="#",L+=a?B:A(B,!1,!1)),L}function v(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+v(s.substr(3)):s}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(r)?s.replace(r,a=>v(a)):s}}),Q(Y[57],X([0,1,8,7,10,11,6,4]),function(O,n,E,M,i,l,S,y){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const c="$initialize";let h=!1;function w(o){!S.isWeb||(h||(h=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(o.message))}n.logOnceWebWorkerWarning=w;class e{constructor(s,a,u,L){this.vsWorker=s,this.req=a,this.method=u,this.args=L,this.type=0}}class _{constructor(s,a,u,L){this.vsWorker=s,this.seq=a,this.res=u,this.err=L,this.type=1}}class f{constructor(s,a,u,L){this.vsWorker=s,this.req=a,this.eventName=u,this.arg=L,this.type=2}}class b{constructor(s,a,u){this.vsWorker=s,this.req=a,this.event=u,this.type=3}}class g{constructor(s,a){this.vsWorker=s,this.req=a,this.type=4}}class C{constructor(s){this._workerId=-1,this._handler=s,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(s){this._workerId=s}sendMessage(s,a){const u=String(++this._lastSentReq);return new Promise((L,R)=>{this._pendingReplies[u]={resolve:L,reject:R},this._send(new e(this._workerId,u,s,a))})}listen(s,a){let u=null;const L=new M.Emitter({onWillAddFirstListener:()=>{u=String(++this._lastSentReq),this._pendingEmitters.set(u,L),this._send(new f(this._workerId,u,s,a))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(u),this._send(new g(this._workerId,u)),u=null}});return L.event}handleMessage(s){!s||!s.vsWorker||this._workerId!==-1&&s.vsWorker!==this._workerId||this._handleMessage(s)}_handleMessage(s){switch(s.type){case 1:return this._handleReplyMessage(s);case 0:return this._handleRequestMessage(s);case 2:return this._handleSubscribeEventMessage(s);case 3:return this._handleEventMessage(s);case 4:return this._handleUnsubscribeEventMessage(s)}}_handleReplyMessage(s){if(!this._pendingReplies[s.seq]){console.warn("Got reply to unknown seq");return}const a=this._pendingReplies[s.seq];if(delete this._pendingReplies[s.seq],s.err){let u=s.err;s.err.$isError&&(u=new Error,u.name=s.err.name,u.message=s.err.message,u.stack=s.err.stack),a.reject(u);return}a.resolve(s.res)}_handleRequestMessage(s){const a=s.req;this._handler.handleMessage(s.method,s.args).then(L=>{this._send(new _(this._workerId,a,L,void 0))},L=>{L.detail instanceof Error&&(L.detail=(0,E.transformErrorForSerialization)(L.detail)),this._send(new _(this._workerId,a,void 0,(0,E.transformErrorForSerialization)(L)))})}_handleSubscribeEventMessage(s){const a=s.req,u=this._handler.handleEvent(s.eventName,s.arg)(L=>{this._send(new b(this._workerId,a,L))});this._pendingEvents.set(a,u)}_handleEventMessage(s){if(!this._pendingEmitters.has(s.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(s.req).fire(s.event)}_handleUnsubscribeEventMessage(s){if(!this._pendingEvents.has(s.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(s.req).dispose(),this._pendingEvents.delete(s.req)}_send(s){const a=[];if(s.type===0)for(let u=0;u<s.args.length;u++)s.args[u]instanceof ArrayBuffer&&a.push(s.args[u]);else s.type===1&&s.res instanceof ArrayBuffer&&a.push(s.res);this._handler.sendMessage(s,a)}}class A extends i.Disposable{constructor(s,a,u){super();let L=null;this._worker=this._register(s.create("vs/base/common/worker/simpleWorker",T=>{this._protocol.handleMessage(T)},T=>{L?.(T)})),this._protocol=new C({sendMessage:(T,q)=>{this._worker.postMessage(T,q)},handleMessage:(T,q)=>{if(typeof u[T]!="function")return Promise.reject(new Error("Missing method "+T+" on main thread host."));try{return Promise.resolve(u[T].apply(u,q))}catch(H){return Promise.reject(H)}},handleEvent:(T,q)=>{if(d(T)){const H=u[T].call(u,q);if(typeof H!="function")throw new Error(`Missing dynamic event ${T} on main thread host.`);return H}if(p(T)){const H=u[T];if(typeof H!="function")throw new Error(`Missing event ${T} on main thread host.`);return H}throw new Error(`Malformed event name ${T}`)}}),this._protocol.setWorkerId(this._worker.getId());let R=null;const N=globalThis.require;typeof N<"u"&&typeof N.getConfig=="function"?R=N.getConfig():typeof globalThis.requirejs<"u"&&(R=globalThis.requirejs.s.contexts._.config);const D=(0,l.getAllMethodNames)(u);this._onModuleLoaded=this._protocol.sendMessage(c,[this._worker.getId(),JSON.parse(JSON.stringify(R)),a,D]);const U=(T,q)=>this._request(T,q),B=(T,q)=>this._protocol.listen(T,q);this._lazyProxy=new Promise((T,q)=>{L=q,this._onModuleLoaded.then(H=>{T(m(H,U,B))},H=>{q(H),this._onError("Worker failed to load "+a,H)})})}getProxyObject(){return this._lazyProxy}_request(s,a){return new Promise((u,L)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(s,a).then(u,L)},L)})}_onError(s,a){console.error(s),console.info(a)}}n.SimpleWorkerClient=A;function p(o){return o[0]==="o"&&o[1]==="n"&&y.isUpperAsciiLetter(o.charCodeAt(2))}function d(o){return/^onDynamic/.test(o)&&y.isUpperAsciiLetter(o.charCodeAt(9))}function m(o,s,a){const u=N=>function(){const D=Array.prototype.slice.call(arguments,0);return s(N,D)},L=N=>function(D){return a(N,D)},R={};for(const N of o){if(d(N)){R[N]=L(N);continue}if(p(N)){R[N]=a(N,void 0);continue}R[N]=u(N)}return R}class v{constructor(s,a){this._requestHandlerFactory=a,this._requestHandler=null,this._protocol=new C({sendMessage:(u,L)=>{s(u,L)},handleMessage:(u,L)=>this._handleMessage(u,L),handleEvent:(u,L)=>this._handleEvent(u,L)})}onmessage(s){this._protocol.handleMessage(s)}_handleMessage(s,a){if(s===c)return this.initialize(a[0],a[1],a[2],a[3]);if(!this._requestHandler||typeof this._requestHandler[s]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+s));try{return Promise.resolve(this._requestHandler[s].apply(this._requestHandler,a))}catch(u){return Promise.reject(u)}}_handleEvent(s,a){if(!this._requestHandler)throw new Error("Missing requestHandler");if(d(s)){const u=this._requestHandler[s].call(this._requestHandler,a);if(typeof u!="function")throw new Error(`Missing dynamic event ${s} on request handler.`);return u}if(p(s)){const u=this._requestHandler[s];if(typeof u!="function")throw new Error(`Missing event ${s} on request handler.`);return u}throw new Error(`Malformed event name ${s}`)}initialize(s,a,u,L){this._protocol.setWorkerId(s);const D=m(L,(U,B)=>this._protocol.sendMessage(U,B),(U,B)=>this._protocol.listen(U,B));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(D),Promise.resolve((0,l.getAllMethodNames)(this._requestHandler))):(a&&(typeof a.baseUrl<"u"&&delete a.baseUrl,typeof a.paths<"u"&&typeof a.paths.vs<"u"&&delete a.paths.vs,typeof a.trustedTypesPolicy!==void 0&&delete a.trustedTypesPolicy,a.catchError=!0,globalThis.require.config(a)),new Promise((U,B)=>{(globalThis.require||O)([u],q=>{if(this._requestHandler=q.create(D),!this._requestHandler){B(new Error("No RequestHandler!"));return}U((0,l.getAllMethodNames)(this._requestHandler))},B)}))}}n.SimpleWorkerServer=v;function r(o){return new v(o,null)}n.create=r}),Q(Y[53],X([0,1,7,10]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,c){return this._tokenizationSupports.set(y,c),this.handleChange([y]),(0,M.toDisposable)(()=>{this._tokenizationSupports.get(y)===c&&(this._tokenizationSupports.delete(y),this.handleChange([y]))})}get(y){return this._tokenizationSupports.get(y)||null}registerFactory(y,c){var h;(h=this._factories.get(y))===null||h===void 0||h.dispose();const w=new l(this,y,c);return this._factories.set(y,w),(0,M.toDisposable)(()=>{const e=this._factories.get(y);!e||e!==w||(this._factories.delete(y),e.dispose())})}getOrCreate(y){return fe(this,void 0,void 0,function*(){const c=this.get(y);if(c)return c;const h=this._factories.get(y);return!h||h.isResolved?null:(yield h.resolve(),this.get(y))})}isResolved(y){if(this.get(y))return!0;const h=this._factories.get(y);return!!(!h||h.isResolved)}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=i;class l extends M.Disposable{get isResolved(){return this._isResolved}constructor(y,c,h){super(),this._registry=y,this._languageId=c,this._factory=h,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return fe(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return fe(this,void 0,void 0,function*(){const y=yield this._factory.tokenizationSupport;this._isResolved=!0,y&&!this._isDisposed&&this._register(this._registry.register(this._languageId,y))})}}}),Q(Y[54],X([0,1,31,12,2,53]),function(O,n,E,M,i,l){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.FoldingRangeKind=n.SymbolKinds=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class S{constructor(m,v,r){this.offset=m,this.type=v,this.language=r,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=S;class y{constructor(m,v){this.tokens=m,this.endState=v,this._tokenizationResultBrand=void 0}}n.TokenizationResult=y;class c{constructor(m,v){this.tokens=m,this.endState=v,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=c;var h;(function(d){const m=new Map;m.set(0,E.Codicon.symbolMethod),m.set(1,E.Codicon.symbolFunction),m.set(2,E.Codicon.symbolConstructor),m.set(3,E.Codicon.symbolField),m.set(4,E.Codicon.symbolVariable),m.set(5,E.Codicon.symbolClass),m.set(6,E.Codicon.symbolStruct),m.set(7,E.Codicon.symbolInterface),m.set(8,E.Codicon.symbolModule),m.set(9,E.Codicon.symbolProperty),m.set(10,E.Codicon.symbolEvent),m.set(11,E.Codicon.symbolOperator),m.set(12,E.Codicon.symbolUnit),m.set(13,E.Codicon.symbolValue),m.set(15,E.Codicon.symbolEnum),m.set(14,E.Codicon.symbolConstant),m.set(15,E.Codicon.symbolEnum),m.set(16,E.Codicon.symbolEnumMember),m.set(17,E.Codicon.symbolKeyword),m.set(27,E.Codicon.symbolSnippet),m.set(18,E.Codicon.symbolText),m.set(19,E.Codicon.symbolColor),m.set(20,E.Codicon.symbolFile),m.set(21,E.Codicon.symbolReference),m.set(22,E.Codicon.symbolCustomColor),m.set(23,E.Codicon.symbolFolder),m.set(24,E.Codicon.symbolTypeParameter),m.set(25,E.Codicon.account),m.set(26,E.Codicon.issues);function v(s){let a=m.get(s);return a||(console.info("No codicon found for CompletionItemKind "+s),a=E.Codicon.symbolProperty),a}d.toIcon=v;const r=new Map;r.set("method",0),r.set("function",1),r.set("constructor",2),r.set("field",3),r.set("variable",4),r.set("class",5),r.set("struct",6),r.set("interface",7),r.set("module",8),r.set("property",9),r.set("event",10),r.set("operator",11),r.set("unit",12),r.set("value",13),r.set("constant",14),r.set("enum",15),r.set("enum-member",16),r.set("enumMember",16),r.set("keyword",17),r.set("snippet",27),r.set("text",18),r.set("color",19),r.set("file",20),r.set("reference",21),r.set("customcolor",22),r.set("folder",23),r.set("type-parameter",24),r.set("typeParameter",24),r.set("account",25),r.set("issue",26);function o(s,a){let u=r.get(s);return typeof u>"u"&&!a&&(u=9),u}d.fromString=o})(h=n.CompletionItemKinds||(n.CompletionItemKinds={}));var w;(function(d){d[d.Automatic=0]="Automatic",d[d.Explicit=1]="Explicit"})(w=n.InlineCompletionTriggerKind||(n.InlineCompletionTriggerKind={}));var e;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(e=n.SignatureHelpTriggerKind||(n.SignatureHelpTriggerKind={}));var _;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(_=n.DocumentHighlightKind||(n.DocumentHighlightKind={}));function f(d){return d&&M.URI.isUri(d.uri)&&i.Range.isIRange(d.range)&&(i.Range.isIRange(d.originSelectionRange)||i.Range.isIRange(d.targetSelectionRange))}n.isLocationLink=f;var b;(function(d){const m=new Map;m.set(0,E.Codicon.symbolFile),m.set(1,E.Codicon.symbolModule),m.set(2,E.Codicon.symbolNamespace),m.set(3,E.Codicon.symbolPackage),m.set(4,E.Codicon.symbolClass),m.set(5,E.Codicon.symbolMethod),m.set(6,E.Codicon.symbolProperty),m.set(7,E.Codicon.symbolField),m.set(8,E.Codicon.symbolConstructor),m.set(9,E.Codicon.symbolEnum),m.set(10,E.Codicon.symbolInterface),m.set(11,E.Codicon.symbolFunction),m.set(12,E.Codicon.symbolVariable),m.set(13,E.Codicon.symbolConstant),m.set(14,E.Codicon.symbolString),m.set(15,E.Codicon.symbolNumber),m.set(16,E.Codicon.symbolBoolean),m.set(17,E.Codicon.symbolArray),m.set(18,E.Codicon.symbolObject),m.set(19,E.Codicon.symbolKey),m.set(20,E.Codicon.symbolNull),m.set(21,E.Codicon.symbolEnumMember),m.set(22,E.Codicon.symbolStruct),m.set(23,E.Codicon.symbolEvent),m.set(24,E.Codicon.symbolOperator),m.set(25,E.Codicon.symbolTypeParameter);function v(r){let o=m.get(r);return o||(console.info("No codicon found for SymbolKind "+r),o=E.Codicon.symbolProperty),o}d.toIcon=v})(b=n.SymbolKinds||(n.SymbolKinds={}));class g{static fromValue(m){switch(m){case"comment":return g.Comment;case"imports":return g.Imports;case"region":return g.Region}return new g(m)}constructor(m){this.value=m}}g.Comment=new g("comment"),g.Imports=new g("imports"),g.Region=new g("region"),n.FoldingRangeKind=g;var C;(function(d){function m(v){return!v||typeof v!="object"?!1:typeof v.id=="string"&&typeof v.title=="string"}d.is=m})(C=n.Command||(n.Command={}));var A;(function(d){d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(A=n.InlayHintKind||(n.InlayHintKind={}));class p{constructor(m){this.createSupport=m,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(m=>{m&&m.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=p,n.TokenizationRegistry=new l.TokenizationRegistry}),Q(Y[55],X([0,1,52,7,28,12,3,2,32,54,48]),function(O,n,E,M,i,l,S,y,c,h,w){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(b,g){return(0,i.KeyChord)(b,g)}}e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256,n.KeyMod=e;function _(){return{editor:void 0,languages:void 0,CancellationTokenSource:E.CancellationTokenSource,Emitter:M.Emitter,KeyCode:w.KeyCode,KeyMod:e,Position:S.Position,Range:y.Range,Selection:c.Selection,SelectionDirection:w.SelectionDirection,MarkerSeverity:w.MarkerSeverity,MarkerTag:w.MarkerTag,Uri:l.URI,Token:h.Token}}n.createMonacoBaseAPI=_}),Q(Y[58],X([0,1,16,12,3,2,45,21,41,42,55,23,47,40,11]),function(O,n,E,M,i,l,S,y,c,h,w,e,_,f,b){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class g extends S.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(d){return this._lines[d-1]}getWordAtPosition(d,m){const v=(0,y.getWordAtText)(d.column,(0,y.ensureValidWordDefinition)(m),this._lines[d.lineNumber-1],0);return v?new l.Range(d.lineNumber,v.startColumn,d.lineNumber,v.endColumn):null}words(d){const m=this._lines,v=this._wordenize.bind(this);let r=0,o="",s=0,a=[];return{*[Symbol.iterator](){for(;;)if(s<a.length){const u=o.substring(a[s].start,a[s].end);s+=1,yield u}else if(r<m.length)o=m[r],a=v(o,d),s=0,r+=1;else break}}}getLineWords(d,m){const v=this._lines[d-1],r=this._wordenize(v,m),o=[];for(const s of r)o.push({word:v.substring(s.start,s.end),startColumn:s.start+1,endColumn:s.end+1});return o}_wordenize(d,m){const v=[];let r;for(m.lastIndex=0;(r=m.exec(d))&&r[0].length!==0;)v.push({start:r.index,end:r.index+r[0].length});return v}getValueInRange(d){if(d=this._validateRange(d),d.startLineNumber===d.endLineNumber)return this._lines[d.startLineNumber-1].substring(d.startColumn-1,d.endColumn-1);const m=this._eol,v=d.startLineNumber-1,r=d.endLineNumber-1,o=[];o.push(this._lines[v].substring(d.startColumn-1));for(let s=v+1;s<r;s++)o.push(this._lines[s]);return o.push(this._lines[r].substring(0,d.endColumn-1)),o.join(m)}offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.lineNumber-2)+(d.column-1)}positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const m=this._lineStarts.getIndexOf(d),v=this._lines[m.index].length;return{lineNumber:1+m.index,column:1+Math.min(m.remainder,v)}}_validateRange(d){const m=this._validatePosition({lineNumber:d.startLineNumber,column:d.startColumn}),v=this._validatePosition({lineNumber:d.endLineNumber,column:d.endColumn});return m.lineNumber!==d.startLineNumber||m.column!==d.startColumn||v.lineNumber!==d.endLineNumber||v.column!==d.endColumn?{startLineNumber:m.lineNumber,startColumn:m.column,endLineNumber:v.lineNumber,endColumn:v.column}:d}_validatePosition(d){if(!i.Position.isIPosition(d))throw new Error("bad position");let{lineNumber:m,column:v}=d,r=!1;if(m<1)m=1,v=1,r=!0;else if(m>this._lines.length)m=this._lines.length,v=this._lines[m-1].length+1,r=!0;else{const o=this._lines[m-1].length+1;v<1?(v=1,r=!0):v>o&&(v=o,r=!0)}return r?{lineNumber:m,column:v}:d}}class C{constructor(d,m){this._host=d,this._models=Object.create(null),this._foreignModuleFactory=m,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(d){return this._models[d]}_getModels(){const d=[];return Object.keys(this._models).forEach(m=>d.push(this._models[m])),d}acceptNewModel(d){this._models[d.url]=new g(M.URI.parse(d.url),d.lines,d.EOL,d.versionId)}acceptModelChanged(d,m){if(!this._models[d])return;this._models[d].onEvents(m)}acceptRemovedModel(d){!this._models[d]||delete this._models[d]}computeUnicodeHighlights(d,m,v){return fe(this,void 0,void 0,function*(){const r=this._getModel(d);return r?_.UnicodeTextModelHighlighter.computeUnicodeHighlights(r,m,v):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(d,m,v,r){return fe(this,void 0,void 0,function*(){const o=this._getModel(d),s=this._getModel(m);return!o||!s?null:C.computeDiff(o,s,v,r)})}static computeDiff(d,m,v,r){const o=r==="experimental"?f.linesDiffComputers.experimental:f.linesDiffComputers.smart,s=d.getLinesContent(),a=m.getLinesContent(),u=o.computeDiff(s,a,v);return{identical:u.changes.length>0?!1:this._modelsAreIdentical(d,m),quitEarly:u.quitEarly,changes:u.changes.map(R=>{var N;return[R.originalRange.startLineNumber,R.originalRange.endLineNumberExclusive,R.modifiedRange.startLineNumber,R.modifiedRange.endLineNumberExclusive,(N=R.innerChanges)===null||N===void 0?void 0:N.map(D=>[D.originalRange.startLineNumber,D.originalRange.startColumn,D.originalRange.endLineNumber,D.originalRange.endColumn,D.modifiedRange.startLineNumber,D.modifiedRange.startColumn,D.modifiedRange.endLineNumber,D.modifiedRange.endColumn])]})}}static _modelsAreIdentical(d,m){const v=d.getLineCount(),r=m.getLineCount();if(v!==r)return!1;for(let o=1;o<=v;o++){const s=d.getLineContent(o),a=m.getLineContent(o);if(s!==a)return!1}return!0}computeMoreMinimalEdits(d,m,v){return fe(this,void 0,void 0,function*(){const r=this._getModel(d);if(!r)return m;const o=[];let s;m=m.slice(0).sort((a,u)=>{if(a.range&&u.range)return l.Range.compareRangesUsingStarts(a.range,u.range);const L=a.range?0:1,R=u.range?0:1;return L-R});for(let{range:a,text:u,eol:L}of m){if(typeof L=="number"&&(s=L),l.Range.isEmpty(a)&&!u)continue;const R=r.getValueInRange(a);if(u=u.replace(/\r\n|\n|\r/g,r.eol),R===u)continue;if(Math.max(u.length,R.length)>C._diffLimit){o.push({range:a,text:u});continue}const N=(0,E.stringDiff)(R,u,v),D=r.offsetAt(l.Range.lift(a).getStartPosition());for(const U of N){const B=r.positionAt(D+U.originalStart),T=r.positionAt(D+U.originalStart+U.originalLength),q={text:u.substr(U.modifiedStart,U.modifiedLength),range:{startLineNumber:B.lineNumber,startColumn:B.column,endLineNumber:T.lineNumber,endColumn:T.column}};r.getValueInRange(q.range)!==q.text&&o.push(q)}}return typeof s=="number"&&o.push({eol:s,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),o})}computeLinks(d){return fe(this,void 0,void 0,function*(){const m=this._getModel(d);return m?(0,c.computeLinks)(m):null})}textualSuggest(d,m,v,r){return fe(this,void 0,void 0,function*(){const o=new e.StopWatch(!0),s=new RegExp(v,r),a=new Set;e:for(const u of d){const L=this._getModel(u);if(!!L){for(const R of L.words(s))if(!(R===m||!isNaN(Number(R)))&&(a.add(R),a.size>C._suggestionsLimit))break e}}return{words:Array.from(a),duration:o.elapsed()}})}computeWordRanges(d,m,v,r){return fe(this,void 0,void 0,function*(){const o=this._getModel(d);if(!o)return Object.create(null);const s=new RegExp(v,r),a=Object.create(null);for(let u=m.startLineNumber;u<m.endLineNumber;u++){const L=o.getLineWords(u,s);for(const R of L){if(!isNaN(Number(R.word)))continue;let N=a[R.word];N||(N=[],a[R.word]=N),N.push({startLineNumber:u,startColumn:R.startColumn,endLineNumber:u,endColumn:R.endColumn})}}return a})}navigateValueSet(d,m,v,r,o){return fe(this,void 0,void 0,function*(){const s=this._getModel(d);if(!s)return null;const a=new RegExp(r,o);m.startColumn===m.endColumn&&(m={startLineNumber:m.startLineNumber,startColumn:m.startColumn,endLineNumber:m.endLineNumber,endColumn:m.endColumn+1});const u=s.getValueInRange(m),L=s.getWordAtPosition({lineNumber:m.startLineNumber,column:m.startColumn},a);if(!L)return null;const R=s.getValueInRange(L);return h.BasicInplaceReplace.INSTANCE.navigateValueSet(m,u,L,R,v)})}loadForeignModule(d,m,v){const r=(a,u)=>this._host.fhr(a,u),s={host:(0,b.createProxyObject)(v,r),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(s,m),Promise.resolve((0,b.getAllMethodNames)(this._foreignModule))):new Promise((a,u)=>{O([d],L=>{this._foreignModule=L.create(s,m),a((0,b.getAllMethodNames)(this._foreignModule))},u)})}fmr(d,m){if(!this._foreignModule||typeof this._foreignModule[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this._foreignModule[d].apply(this._foreignModule,m))}catch(v){return Promise.reject(v)}}}C._diffLimit=1e5,C._suggestionsLimit=1e4,n.EditorSimpleWorker=C;function A(p){return new C(p,null)}n.create=A,typeof importScripts=="function"&&(globalThis.monaco=(0,w.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map